searchNodes=[{"doc":"Documentation for the Absinthe package, a toolkit for building GraphQL APIs with Elixir. For usage information, see the documentation, which includes guides, API information for important modules, and links to useful resources.","ref":"Absinthe.html","title":"Absinthe","type":"module"},{"doc":"Evaluates a query document against a schema, with options. Options :adapter - The name of the adapter to use. See the Absinthe.Adapter behaviour and the Absinthe.Adapter.Passthrough and Absinthe.Adapter.LanguageConventions modules that implement it. (Absinthe.Adapter.LanguageConventions is the default value for this option.) :operation_name - If more than one operation is present in the provided query document, this must be provided to select which operation to execute. :variables - A map of provided variable values to be used when filling in arguments in the provided query document. :context -&gt; A map of the execution context. :root_value -&gt; A root value to use as the source for toplevel fields. :analyze_complexity -&gt; Whether to analyze the complexity before executing an operation. :max_complexity -&gt; An integer (or :infinity) for the maximum allowed complexity for the operation being executed. Examples &quot;&quot;&quot; query GetItemById($id: ID) { item(id: $id) { name } } &quot;&quot;&quot; |&gt; Absinthe.run(App.Schema, variables: %{&quot;id&quot; =&gt; params[:item_id]}) See the Absinthe module documentation for more examples.","ref":"Absinthe.html#run/3","title":"Absinthe.run/3","type":"function"},{"doc":"Evaluates a query document against a schema, without options. Options See run/3 for the available options.","ref":"Absinthe.html#run!/3","title":"Absinthe.run!/3","type":"function"},{"doc":"","ref":"Absinthe.html#t:result_error_t/0","title":"Absinthe.result_error_t/0","type":"type"},{"doc":"","ref":"Absinthe.html#t:result_selection_t/0","title":"Absinthe.result_selection_t/0","type":"type"},{"doc":"","ref":"Absinthe.html#t:result_t/0","title":"Absinthe.result_t/0","type":"type"},{"doc":"","ref":"Absinthe.html#t:run_opts/0","title":"Absinthe.run_opts/0","type":"type"},{"doc":"","ref":"Absinthe.html#t:run_result/0","title":"Absinthe.run_result/0","type":"type"},{"doc":"","ref":"Absinthe.Lexer.html","title":"Absinthe.Lexer","type":"module"},{"doc":"Parses the given binary as do_tokenize. Returns {:ok, [token], rest, context, position, byte_offset} or {:error, reason, rest, context, line, byte_offset} where position describes the location of the do_tokenize (start position) as {line, column_on_line}. Options :line - the initial line, defaults to 1 :byte_offset - the initial byte offset, defaults to 0 :context - the initial context value. It will be converted to a map","ref":"Absinthe.Lexer.html#do_tokenize/2","title":"Absinthe.Lexer.do_tokenize/2","type":"function"},{"doc":"","ref":"Absinthe.Lexer.html#line_and_column/3","title":"Absinthe.Lexer.line_and_column/3","type":"function"},{"doc":"","ref":"Absinthe.Lexer.html#tokenize/1","title":"Absinthe.Lexer.tokenize/1","type":"function"},{"doc":"","ref":"Absinthe.Phase.Document.Arguments.VariableTypesMatch.html","title":"Absinthe.Phase.Document.Arguments.VariableTypesMatch","type":"module"},{"doc":"","ref":"Absinthe.Phase.Document.Arguments.VariableTypesMatch.html#check_fragments/1","title":"Absinthe.Phase.Document.Arguments.VariableTypesMatch.check_fragments/1","type":"function"},{"doc":"","ref":"Absinthe.Phase.Document.Arguments.VariableTypesMatch.html#check_operations/1","title":"Absinthe.Phase.Document.Arguments.VariableTypesMatch.check_operations/1","type":"function"},{"doc":"","ref":"Absinthe.Phase.Document.Arguments.VariableTypesMatch.html#check_variable_types/1","title":"Absinthe.Phase.Document.Arguments.VariableTypesMatch.check_variable_types/1","type":"function"},{"doc":"","ref":"Absinthe.Phase.Document.Arguments.VariableTypesMatch.html#check_variable_types/2","title":"Absinthe.Phase.Document.Arguments.VariableTypesMatch.check_variable_types/2","type":"function"},{"doc":"","ref":"Absinthe.Phase.Document.Arguments.VariableTypesMatch.html#error_message/4","title":"Absinthe.Phase.Document.Arguments.VariableTypesMatch.error_message/4","type":"function"},{"doc":"","ref":"Absinthe.Phase.Document.Arguments.VariableTypesMatch.html#flag_invalid/1","title":"Absinthe.Phase.Document.Arguments.VariableTypesMatch.flag_invalid/1","type":"function"},{"doc":"","ref":"Absinthe.Phase.Document.Arguments.VariableTypesMatch.html#flag_invalid/2","title":"Absinthe.Phase.Document.Arguments.VariableTypesMatch.flag_invalid/2","type":"function"},{"doc":"","ref":"Absinthe.Phase.Document.Arguments.VariableTypesMatch.html#inherit_invalid/3","title":"Absinthe.Phase.Document.Arguments.VariableTypesMatch.inherit_invalid/3","type":"function"},{"doc":"","ref":"Absinthe.Phase.Document.Arguments.VariableTypesMatch.html#put_flag/2","title":"Absinthe.Phase.Document.Arguments.VariableTypesMatch.put_flag/2","type":"function"},{"doc":"Callback implementation for Absinthe.Phase.run/2.","ref":"Absinthe.Phase.Document.Arguments.VariableTypesMatch.html#run/2","title":"Absinthe.Phase.Document.Arguments.VariableTypesMatch.run/2","type":"function"},{"doc":"","ref":"Absinthe.Phase.Document.Validation.Utils.MessageSuggestions.html","title":"Absinthe.Phase.Document.Validation.Utils.MessageSuggestions","type":"module"},{"doc":"","ref":"Absinthe.Phase.Document.Validation.Utils.MessageSuggestions.html#suggest_fragment_message/1","title":"Absinthe.Phase.Document.Validation.Utils.MessageSuggestions.suggest_fragment_message/1","type":"function"},{"doc":"Generate an suggestions message for a incorrect field","ref":"Absinthe.Phase.Document.Validation.Utils.MessageSuggestions.html#suggest_message/1","title":"Absinthe.Phase.Document.Validation.Utils.MessageSuggestions.suggest_message/1","type":"function"},{"doc":"","ref":"Absinthe.Schema.Manager.html","title":"Absinthe.Schema.Manager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor.","ref":"Absinthe.Schema.Manager.html#child_spec/1","title":"Absinthe.Schema.Manager.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1.","ref":"Absinthe.Schema.Manager.html#init/1","title":"Absinthe.Schema.Manager.init/1","type":"function"},{"doc":"","ref":"Absinthe.Schema.Manager.html#start_link/1","title":"Absinthe.Schema.Manager.start_link/1","type":"function"},{"doc":"Experimental: Persistent Term based Schema Backend By default, Absinthe schemas are stored in a generated module. If your schema is called MyAppWeb.Schema, Absinthe creates a MyAppWeb.Schema.Compiled module containing the structs and other data that Absinthe needs at runtime to execute GraphQL operations against that schema. OTP introduced the :persistent_term module to provide many of the same performance benefits of using compiled modules, without the downsides associated with manipulating complex structures at compile time. This module is an experimental effort at using the :persistent_term module as an Absinthe schema backend. This module has been tested against against the entire Absinthe test suite and shown to perform perhaps even better than the compiled module. To use: In your schema module: @schema_provider Absinthe.Schema.PersistentTerm In your application&#39;s supervision tree, prior to anywhere where you&#39;d use the schema: {Absinthe.Schema, MyAppWeb.Schema} where MyAppWeb.Schema is the name of your schema.","ref":"Absinthe.Schema.PersistentTerm.html","title":"Absinthe.Schema.PersistentTerm","type":"module"},{"doc":"Callback implementation for Absinthe.Schema.Provider.pipeline/1.","ref":"Absinthe.Schema.PersistentTerm.html#pipeline/1","title":"Absinthe.Schema.PersistentTerm.pipeline/1","type":"function"},{"doc":"Experimental: Behaviour for providing schema data This behaviour is experimental and may change significatly in patch releases.","ref":"Absinthe.Schema.Provider.html","title":"Absinthe.Schema.Provider","type":"behaviour"},{"doc":"","ref":"Absinthe.Schema.Provider.html#c:__absinthe_directive__/2","title":"Absinthe.Schema.Provider.__absinthe_directive__/2","type":"callback"},{"doc":"","ref":"Absinthe.Schema.Provider.html#c:__absinthe_directives__/1","title":"Absinthe.Schema.Provider.__absinthe_directives__/1","type":"callback"},{"doc":"","ref":"Absinthe.Schema.Provider.html#c:__absinthe_interface_implementors__/1","title":"Absinthe.Schema.Provider.__absinthe_interface_implementors__/1","type":"callback"},{"doc":"","ref":"Absinthe.Schema.Provider.html#c:__absinthe_type__/2","title":"Absinthe.Schema.Provider.__absinthe_type__/2","type":"callback"},{"doc":"","ref":"Absinthe.Schema.Provider.html#c:__absinthe_types__/1","title":"Absinthe.Schema.Provider.__absinthe_types__/1","type":"callback"},{"doc":"","ref":"Absinthe.Schema.Provider.html#c:__absinthe_types__/2","title":"Absinthe.Schema.Provider.__absinthe_types__/2","type":"callback"},{"doc":"","ref":"Absinthe.Schema.Provider.html#c:pipeline/1","title":"Absinthe.Schema.Provider.pipeline/1","type":"callback"},{"doc":"","ref":"Absinthe.Schema.Provider.html#t:schema_identifier/0","title":"Absinthe.Schema.Provider.schema_identifier/0","type":"type"},{"doc":"","ref":"Absinthe.Schema.Provider.html#t:type_group/0","title":"Absinthe.Schema.Provider.type_group/0","type":"type"},{"doc":"Generate a schema.json file Usage absinthe.schema.json [FILENAME] [OPTIONS] The JSON codec to be used needs to be included in your mix.exs dependencies. If using the default codec, see the Jason installation instructions. Options --schema - The name of the Absinthe.Schema module defining the schema to be generated. Default: As configured for :absinthe :schema --json-codec - Codec to use to generate the JSON file (see Custom Codecs). Default: Jason --pretty - Whether to pretty-print. Default: false Examples Write to default path ./schema.json using the :schema configured for the :absinthe application: $ mix absinthe.schema.json Write to default path ./schema.json using the MySchema schema: $ mix absinthe.schema.json --schema MySchema Write to path /path/to/schema.json using the MySchema schema, with pretty-printing: $ mix absinthe.schema.json --schema MySchema --pretty /path/to/schema.json Write to default path ./schema.json using the MySchema schema and a custom JSON codec, MyCodec: $ mix absinthe.schema.json --schema MySchema --json-codec MyCodec Custom Codecs Any module that provides encode!/2 can be used as a custom codec: encode!(value, options) value will be provided as a Map containing the generated schema. options will be a keyword list with a :pretty boolean, indicating whether the user requested pretty-printing. The function should return a string to be written to the output file.","ref":"Mix.Tasks.Absinthe.Schema.Json.html","title":"Mix.Tasks.Absinthe.Schema.Json","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1, which receives a list of command-line args.","ref":"Mix.Tasks.Absinthe.Schema.Json.html#run/1","title":"Mix.Tasks.Absinthe.Schema.Json.run/1","type":"function"},{"doc":"Generate a schema.graphql file mix absinthe.schema.sdl --schema MySchema Usage absinthe.schema.sdl [FILENAME] [OPTIONS] Options --schema - The name of the Absinthe.Schema module defining the schema to be generated. Default: As configured for :absinthe :schema Examples Write to default path ./schema.graphql using the :schema configured for the :absinthe application: $ mix absinthe.schema.sdl Write to path /path/to/schema.graphql using the MySchema schema $ mix absinthe.schema.sdl --schema MySchema /path/to/schema.graphql","ref":"Mix.Tasks.Absinthe.Schema.Sdl.html","title":"Mix.Tasks.Absinthe.Schema.Sdl","type":"task"},{"doc":"","ref":"Mix.Tasks.Absinthe.Schema.Sdl.html#generate_schema/1","title":"Mix.Tasks.Absinthe.Schema.Sdl.generate_schema/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Absinthe.Schema.Sdl.html#parse_options/1","title":"Mix.Tasks.Absinthe.Schema.Sdl.parse_options/1","type":"function"},{"doc":"Handy functions for returning async or batched resolution functions Using Absinthe.Schema.Notation or (by extension) Absinthe.Schema will automatically import the batch and async helpers. Dataloader helpers require an explicit import Absinthe.Resolution.Helpers invocation, since dataloader is an optional dependency.","ref":"Absinthe.Resolution.Helpers.html","title":"Absinthe.Resolution.Helpers","type":"module"},{"doc":"Execute resolution field asynchronously. This is a helper function for using the Absinthe.Middleware.Async. Forbidden in mutation fields. (TODO: actually enforce this) Options :timeout default: 30_000. The maximum timeout to wait for running the task. Example Using the Absinthe.Resolution.Helpers.async/1 helper function: field :time_consuming, :thing do resolve fn _, _, _ -&gt; async(fn -&gt; {:ok, long_time_consuming_function()} end) end end","ref":"Absinthe.Resolution.Helpers.html#async/2","title":"Absinthe.Resolution.Helpers.async/2","type":"function"},{"doc":"Batch the resolution of several functions together. Helper function for creating Absinthe.Middleware.Batch Options :timeout default: 5_000. The maximum timeout to wait for running a batch. Example Raw usage: object :post do field :name, :string field :author, :user do resolve fn post, _, _ -&gt; batch({__MODULE__, :users_by_id}, post.author_id, fn batch_results -&gt; {:ok, Map.get(batch_results, post.author_id)} end) end end end def users_by_id(_, user_ids) do users = Repo.all from u in User, where: u.id in ^user_ids Map.new(users, fn user -&gt; {user.id, user} end) end","ref":"Absinthe.Resolution.Helpers.html#batch/4","title":"Absinthe.Resolution.Helpers.batch/4","type":"function"},{"doc":"Resolve a field with a dataloader source. This function is not imported by default. To make it available in your module do import Absinthe.Resolution.Helpers Same as dataloader/3, but it infers the resource name from the field name. Examples field :author, :user, resolve: dataloader(Blog) This is identical to doing the following. field :author, :user, resolve: dataloader(Blog, :author, [])","ref":"Absinthe.Resolution.Helpers.html#dataloader/1","title":"Absinthe.Resolution.Helpers.dataloader/1","type":"function"},{"doc":"Resolve a field with a dataloader source. This function is not imported by default. To make it available in your module do import Absinthe.Resolution.Helpers Same as dataloader/3, but it infers the resource name from the field name. For opts see dataloader/3 on what options can be passed in. Examples object :user do field :posts, list_of(:post), resolve: dataloader(Blog, args: %{deleted: false}) field :organization, :organization do resolve dataloader(Accounts, use_parent: false) end field(:account_active, non_null(:boolean), resolve: dataloader( Accounts, callback: fn account, _parent, _args -&gt; {:ok, account.active} end ) ) end","ref":"Absinthe.Resolution.Helpers.html#dataloader/2","title":"Absinthe.Resolution.Helpers.dataloader/2","type":"function"},{"doc":"Resolve a field with Dataloader This function is not imported by default. To make it available in your module do import Absinthe.Resolution.Helpers While on_load/2 makes using dataloader directly easy within a resolver function, it is often unnecessary to need this level of direct control. The dataloader/3 function exists to provide a simple API for using dataloader. It takes the name of a data source, the name of the resource you want to load, and then a variety of options. Basic Usage object :user do field :posts, list_of(:post), resolve: dataloader(Blog, :posts, args: %{deleted: false}) field :organization, :organization do resolve dataloader(Accounts, :organization, use_parent: false) end field(:account_active, non_null(:boolean), resolve: dataloader( Accounts, :account, callback: fn account, _parent, _args -&gt; {:ok, account.active} end ) ) end Key Functions Instead of passing in a literal like :posts or :organization in as the resource, it is also possible pass in a function: object :user do field :posts, list_of(:post) do arg :limit, non_null(:integer) resolve dataloader(Blog, fn user, args, info -&gt; args = Map.update!(args, :limit, fn val -&gt; max(min(val, 20), 0) end) {:posts, args} end) end end In this case we want to make sure that the limit value cannot be larger than 20. By passing a callback function to dataloader/2 we can ensure that the value will fall nicely between 0 and 20. Options :args default: %{}. Any arguments you want to always pass into the Dataloader.load/4 call. Resolver arguments are merged into this value and, in the event of a conflict, the resolver arguments win. :callback default: return result wrapped in ok or error tuple. Callback that is run with result of dataloader. It receives the result as the first argument, and the parent and args as second and third. Can be used to e.g. compute fields on the return value of the loader. Should return an ok or error tuple. :use_parent default: false. This option affects whether or not the dataloader/2 helper will use any pre-existing value on the parent. IE if you return %{author: %User{...}} from a blog post the helper will by default simply use the pre-existing author. Set it to true if you want to opt into using the pre-existing value instead of loading it fresh. Ultimately, this helper calls Dataloader.load/4 using the loader in your context, the source you provide, the tuple {resource, args} as the batch key, and then the parent value of the field def dataloader(source_name, resource) do fn parent, args, %{context: %{loader: loader}} -&gt; args = Map.merge(opts[:args] || %{}, args) loader |&gt; Dataloader.load(source_name, {resource, args}, parent) |&gt; on_load(fn loader -&gt; {:ok, Dataloader.get(loader, source_name, {resource, args}, parent)} end) end end","ref":"Absinthe.Resolution.Helpers.html#dataloader/3","title":"Absinthe.Resolution.Helpers.dataloader/3","type":"function"},{"doc":"Dataloader helper function This function is not imported by default. To make it available in your module do import Absinthe.Resolution.Helpers This function helps you use data loader in a direct way within your schema. While normally the dataloader/1,2,3 helpers are enough, on_load/2 is useful when you want to load multiple things in a single resolver, or when you need fine grained control over the dataloader cache. Examples field :reports, list_of(:report) do resolve fn shipment, _, %{context: %{loader: loader}} -&gt; loader |&gt; Dataloader.load(SourceName, :automatic_reports, shipment) |&gt; Dataloader.load(SourceName, :manual_reports, shipment) |&gt; on_load(fn loader -&gt; reports = loader |&gt; Dataloader.get(SourceName, :automatic_reports, shipment) |&gt; Enum.concat(Dataloader.get(loader, SourceName, :manual_reports, shipment)) |&gt; Enum.sort_by(&amp;reported_at/1) {:ok, reports} end) end end","ref":"Absinthe.Resolution.Helpers.html#on_load/2","title":"Absinthe.Resolution.Helpers.on_load/2","type":"function"},{"doc":"","ref":"Absinthe.Resolution.Helpers.html#t:dataloader_key_fun/0","title":"Absinthe.Resolution.Helpers.dataloader_key_fun/0","type":"type"},{"doc":"","ref":"Absinthe.Resolution.Helpers.html#t:dataloader_opt/0","title":"Absinthe.Resolution.Helpers.dataloader_opt/0","type":"type"},{"doc":"","ref":"Absinthe.Resolution.Helpers.html#t:dataloader_tuple/0","title":"Absinthe.Resolution.Helpers.dataloader_tuple/0","type":"type"},{"doc":"Build GraphQL Schemas Custom Schema Manipulation (in progress) In Absinthe 1.5 schemas are built using the same process by which queries are executed. All the macros in this module and in Notation build up an intermediary tree of structs in the %Absinthe.Blueprint{} namespace, which we generally call &quot;Blueprint structs&quot;. At the top you&#39;ve got a %Blueprint{} struct which holds onto some schema definitions that look a bit like this: %Blueprint.Schema.SchemaDefinition{ type_definitions: [ %Blueprint.Schema.ObjectTypeDefinition{identifier: :query, ...}, %Blueprint.Schema.ObjectTypeDefinition{identifier: :mutation, ...}, %Blueprint.Schema.ObjectTypeDefinition{identifier: :user, ...}, %Blueprint.Schema.EnumTypeDefinition{identifier: :sort_order, ...}, ] } You can see what your schema&#39;s blueprint looks like by calling __absinthe_blueprint__ on any schema or type definition module. defmodule MyAppWeb.Schema do use Absinthe.Schema query do end end &gt; MyAppWeb.Schema.__absinthe_blueprint__ #=&gt; %Absinthe.Blueprint{...} These blueprints are manipulated by phases, which validate and ultimately construct a schema. This pipeline of phases you can hook into like you do for queries. defmodule MyAppWeb.Schema do use Absinthe.Schema @pipeline_modifier MyAppWeb.CustomSchemaPhase query do end end defmodule MyAppWeb.CustomSchemaPhase do alias Absinthe.{Phase, Pipeline, Blueprint} # Add this module to the pipeline of phases # to run on the schema def pipeline(pipeline) do Pipeline.insert_after(pipeline, Phase.Schema.TypeImports, __MODULE__) end # Here&#39;s the blueprint of the schema, do whatever you want with it. def run(blueprint, _) do {:ok, blueprint} end end The blueprint structs are pretty complex, but if you ever want to figure out how to construct something in blueprints you can always just create the thing in the normal AST and then look at the output. Let&#39;s see what interfaces look like for example: defmodule Foo do use Absinthe.Schema.Notation interface :named do field :name, :string end end Foo.__absinthe_blueprint__ #=&gt; ...","ref":"Absinthe.Schema.html","title":"Absinthe.Schema","type":"behaviour"},{"doc":"","ref":"Absinthe.Schema.html#apply_modifiers/2","title":"Absinthe.Schema.apply_modifiers/2","type":"function"},{"doc":"","ref":"Absinthe.Schema.html#child_spec/1","title":"Absinthe.Schema.child_spec/1","type":"function"},{"doc":"Get all concrete types for union, interface, or object","ref":"Absinthe.Schema.html#concrete_types/2","title":"Absinthe.Schema.concrete_types/2","type":"function"},{"doc":"Used to set some values in the context that it may need in order to run. Examples Setup dataloader: def context(context) do loader = Dataloader.new |&gt; Dataloader.add_source(Blog, Blog.data()) Map.put(context, :loader, loader) end","ref":"Absinthe.Schema.html#c:context/1","title":"Absinthe.Schema.context/1","type":"callback"},{"doc":"List all directives on a schema","ref":"Absinthe.Schema.html#directives/1","title":"Absinthe.Schema.directives/1","type":"function"},{"doc":"Used to hydrate the schema with dynamic attributes. While this is normally used to add resolvers, etc, to schemas defined using import_sdl/1 and import_sdl2, it can also be used in schemas defined using other macros. The function is passed the blueprint definition node as the first argument and its ancestors in a list (with its parent node as the head) as its second argument. See the Absinthe.Phase.Schema.Hydrate implementation of Absinthe.Schema.Hydrator callbacks to see what hydration values can be returned. Examples Add a resolver for a field: def hydrate(%Absinthe.Blueprint.Schema.FieldDefinition{identifier: :health}, [%Absinthe.Blueprint.Schema.ObjectTypeDefinition{identifier: :query} | _]) do {:resolve, &amp;__MODULE__.health/3} end # Resolver implementation: def health(_, _, _), do: {:ok, &quot;alive!&quot;} Note that the values provided must be macro-escapable; notably, anonymous functions cannot be used. You can, of course, omit the struct names for brevity: def hydrate(%{identifier: :health}, [%{identifier: :query} | _]) do {:resolve, &amp;__MODULE__.health/3} end Add a description to a type: def hydrate(%Absinthe.Blueprint.Schema.ObjectTypeDefinition{identifier: :user}, _) do {:description, &quot;A user&quot;} end If you define hydrate/2, don&#39;t forget to include a fallback, e.g.: def hydrate(_node, _ancestors), do: []","ref":"Absinthe.Schema.html#c:hydrate/2","title":"Absinthe.Schema.hydrate/2","type":"callback"},{"doc":"List all implementors of an interface on a schema","ref":"Absinthe.Schema.html#implementors/2","title":"Absinthe.Schema.implementors/2","type":"function"},{"doc":"Run the introspection query on a schema. Convenience function.","ref":"Absinthe.Schema.html#introspect/2","title":"Absinthe.Schema.introspect/2","type":"function"},{"doc":"Get all introspection types","ref":"Absinthe.Schema.html#introspection_types/1","title":"Absinthe.Schema.introspection_types/1","type":"function"},{"doc":"","ref":"Absinthe.Schema.html#lookup_directive/2","title":"Absinthe.Schema.lookup_directive/2","type":"function"},{"doc":"","ref":"Absinthe.Schema.html#lookup_type/3","title":"Absinthe.Schema.lookup_type/3","type":"function"},{"doc":"Used to apply middleware on all or a group of fields based on pattern matching. It is passed the existing middleware for a field, the field itself, and the object that the field is a part of. Examples Adding a HandleChangesetError middleware only to mutations: # if it&#39;s a field for the mutation object, add this middleware to the end def middleware(middleware, _field, %{identifier: :mutation}) do middleware ++ [MyAppWeb.Middleware.HandleChangesetErrors] end # if it&#39;s any other object keep things as is def middleware(middleware, _field, _object), do: middleware","ref":"Absinthe.Schema.html#c:middleware/3","title":"Absinthe.Schema.middleware/3","type":"callback"},{"doc":"Defines a root Mutation object mutation do field :create_user, :user do arg :name, non_null(:string) arg :email, non_null(:string) resolve &amp;MyApp.Web.BlogResolvers.create_user/2 end end","ref":"Absinthe.Schema.html#mutation/2","title":"Absinthe.Schema.mutation/2","type":"macro"},{"doc":"Used to define the list of plugins to run before and after resolution. Plugins are modules that implement the Absinthe.Plugin behaviour. These modules have the opportunity to run callbacks before and after the resolution of the entire document, and have access to the resolution accumulator. Plugins must be specified by the schema, so that Absinthe can make sure they are all given a chance to run prior to resolution.","ref":"Absinthe.Schema.html#c:plugins/0","title":"Absinthe.Schema.plugins/0","type":"callback"},{"doc":"Defines a root Query object","ref":"Absinthe.Schema.html#query/2","title":"Absinthe.Schema.query/2","type":"macro"},{"doc":"Get all types that are referenced by an operation","ref":"Absinthe.Schema.html#referenced_types/1","title":"Absinthe.Schema.referenced_types/1","type":"function"},{"doc":"Replace the default middleware. Examples Replace the default for all fields with a string lookup instead of an atom lookup: def middleware(middleware, field, object) do new_middleware = {Absinthe.Middleware.MapGet, to_string(field.identifier)} middleware |&gt; Absinthe.Schema.replace_default(new_middleware, field, object) end","ref":"Absinthe.Schema.html#replace_default/4","title":"Absinthe.Schema.replace_default/4","type":"function"},{"doc":"Defines a root Subscription object Subscriptions in GraphQL let a client submit a document to the server that outlines what data they want to receive in the event of particular updates. For a full walk through of how to setup your project with subscriptions and Phoenix see the Absinthe.Phoenix project moduledoc. When you push a mutation, you can have selections on that mutation result to get back data you need, IE mutation { createUser(accountId: 1, name: &quot;bob&quot;) { id account { name } } } However, what if you want to know when OTHER people create a new user, so that your UI can update as well. This is the point of subscriptions. subscription { newUsers { id account { name } } } The job of the subscription macros then is to give you the tools to connect subscription documents with the values that will drive them. In the last example we would get all users for all accounts, but you could imagine wanting just newUsers(accountId: 2). In your schema you articulate the interests of a subscription via the config macro: subscription do field :new_users, :user do arg :account_id, non_null(:id) config fn args,_info -&gt; {:ok, topic: args.account_id} end end end The topic can be any term. You can broadcast a value manually to this subscription by doing Absinthe.Subscription.publish(pubsub, user, [new_users: user.account_id]) It&#39;s pretty common to want to associate particular mutations as the triggers for one or more subscriptions, so Absinthe provides some macros to help with that too. subscription do field :new_users, :user do arg :account_id, non_null(:id) config fn args, _info -&gt; {:ok, topic: args.account_id} end trigger :create_user, topic: fn user -&gt; user.account_id end end end The idea with a trigger is that it takes either a single mutation :create_user or a list of mutations [:create_user, :blah_user, ...] and a topic function. This function returns a value that is used to lookup documents on the basis of the topic they returned from the config macro. Note that a subscription field can have trigger as many trigger blocks as you need, in the event that different groups of mutations return different results that require different topic functions.","ref":"Absinthe.Schema.html#subscription/2","title":"Absinthe.Schema.subscription/2","type":"macro"},{"doc":"Converts a schema to an SDL string Per the spec, only types that are actually referenced directly or transitively from the root query, subscription, or mutation objects are included. Example Absinthe.Schema.to_sdl(MyAppWeb.Schema) &quot;schema { query {...} }&quot;","ref":"Absinthe.Schema.html#to_sdl/1","title":"Absinthe.Schema.to_sdl/1","type":"function"},{"doc":"List all types on a schema","ref":"Absinthe.Schema.html#types/1","title":"Absinthe.Schema.types/1","type":"function"},{"doc":"Get all types that are used by an operation","ref":"Absinthe.Schema.html#used_types/1","title":"Absinthe.Schema.used_types/1","type":"function"},{"doc":"","ref":"Absinthe.Schema.html#t:t/0","title":"Absinthe.Schema.t/0","type":"type"},{"doc":"","ref":"Absinthe.Schema.Hydrator.html","title":"Absinthe.Schema.Hydrator","type":"behaviour"},{"doc":"","ref":"Absinthe.Schema.Hydrator.html#c:apply_hydration/2","title":"Absinthe.Schema.Hydrator.apply_hydration/2","type":"callback"},{"doc":"","ref":"Absinthe.Schema.Hydrator.html#t:hydration/0","title":"Absinthe.Schema.Hydrator.hydration/0","type":"type"},{"doc":"Provides a set of macro&#39;s to use when creating a schema. Especially useful when moving definitions out into a different module than the schema itself. Example defmodule MyAppWeb.Schema.Types do use Absinthe.Schema.Notation object :item do field :id, :id field :name, :string end # ... end","ref":"Absinthe.Schema.Notation.html","title":"Absinthe.Schema.Notation","type":"module"},{"doc":"Add an argument. See arg/3","ref":"Absinthe.Schema.Notation.html#arg/2","title":"Absinthe.Schema.Notation.arg/2","type":"macro"},{"doc":"Add an argument. Placement Allowed under: directive field Examples field do arg :size, :integer arg :name, non_null(:string), description: &quot;The desired name&quot; arg :public, :boolean, default_value: true end","ref":"Absinthe.Schema.Notation.html#arg/3","title":"Absinthe.Schema.Notation.arg/3","type":"macro"},{"doc":"","ref":"Absinthe.Schema.Notation.html#build_reference/1","title":"Absinthe.Schema.Notation.build_reference/1","type":"function"},{"doc":"Set the complexity of a field For a field, the first argument to the function you supply to complexity/1 is the user arguments -- just as a field&#39;s resolver can use user arguments to resolve its value, the complexity function that you provide can use the same arguments to calculate the field&#39;s complexity. The second argument passed to your complexity function is the sum of all the complexity scores of all the fields nested below the current field. (If a complexity function accepts three arguments, the third will be an %Absinthe.Resolution{} struct, just as with resolvers.) Placement Allowed under: field Examples query do field :people, list_of(:person) do arg :limit, :integer, default_value: 10 complexity fn %{limit: limit}, child_complexity -&gt; # set complexity based on maximum number of items in the list and # complexity of a child. limit * child_complexity end end end","ref":"Absinthe.Schema.Notation.html#complexity/1","title":"Absinthe.Schema.Notation.complexity/1","type":"macro"},{"doc":"Configure a subscription field. Examples config fn args, %{context: context} -&gt; if authorized?(context) do {:ok, topic: args.client_id} else {:error, &quot;unauthorized&quot;} end end Alternatively can provide a list of topics: config fn _, _ -&gt; {:ok, topic: [&quot;topic_one&quot;, &quot;topic_two&quot;, &quot;topic_three&quot;]} end Using context_id option to allow de-duplication of updates: config fn _, %{context: context} -&gt; if authorized?(context) do {:ok, topic: &quot;topic_one&quot;, context_id: &quot;authorized&quot;} else {:ok, topic: &quot;topic_one&quot;, context_id: &quot;not-authorized&quot;} end end See Absinthe.Schema.subscription/1 for details","ref":"Absinthe.Schema.Notation.html#config/1","title":"Absinthe.Schema.Notation.config/1","type":"macro"},{"doc":"Mark a field as deprecated In most cases you can simply pass the deprecate: &quot;message&quot; attribute. However when using the block form of a field it can be nice to also use this macro. Placement Allowed under: field Examples field :foo, :string do deprecate &quot;Foo will no longer be supported&quot; end This is how to deprecate other things field :foo, :string do arg :bar, :integer, deprecate: &quot;This isn&#39;t supported either&quot; end enum :colors do value :red value :blue, deprecate: &quot;This isn&#39;t supported&quot; end","ref":"Absinthe.Schema.Notation.html#deprecate/1","title":"Absinthe.Schema.Notation.deprecate/1","type":"macro"},{"doc":"Defines a description This macro adds a description to any other macro which takes a block. Note that you can also specify a description by using @desc above any item that can take a description attribute. Placement Allowed under any block. Not allowed to be top level","ref":"Absinthe.Schema.Notation.html#description/1","title":"Absinthe.Schema.Notation.description/1","type":"macro"},{"doc":"Defines a directive Placement Top level in module. Examples directive :mydirective do arg :if, non_null(:boolean), description: &quot;Skipped when true.&quot; on [:field, :fragment_spread, :inline_fragment] expand fn %{if: true}, node -&gt; Blueprint.put_flag(node, :skip, __MODULE__) _, node -&gt; node end end","ref":"Absinthe.Schema.Notation.html#directive/3","title":"Absinthe.Schema.Notation.directive/3","type":"macro"},{"doc":"Defines an enum type See enum/3","ref":"Absinthe.Schema.Notation.html#enum/2","title":"Absinthe.Schema.Notation.enum/2","type":"macro"},{"doc":"Defines an enum type Placement Top level in module. Examples Handling RED, GREEN, BLUE values from the query document: enum :color do value :red value :green value :blue end A given query document might look like: { foo(color: RED) } Internally you would get an argument in elixir that looks like: %{color: :red} If your return value is an enum, it will get serialized out as: {&quot;color&quot;: &quot;RED&quot;} You can provide custom value mappings. Here we use r, g, b values: enum :color do value :red, as: &quot;r&quot; value :green, as: &quot;g&quot; value :blue, as: &quot;b&quot; end","ref":"Absinthe.Schema.Notation.html#enum/3","title":"Absinthe.Schema.Notation.enum/3","type":"macro"},{"doc":"Define the expansion for a directive Placement Allowed under: directive","ref":"Absinthe.Schema.Notation.html#expand/1","title":"Absinthe.Schema.Notation.expand/1","type":"macro"},{"doc":"Defines a GraphQL field See field/4","ref":"Absinthe.Schema.Notation.html#field/2","title":"Absinthe.Schema.Notation.field/2","type":"macro"},{"doc":"Defines a GraphQL field See field/4","ref":"Absinthe.Schema.Notation.html#field/3","title":"Absinthe.Schema.Notation.field/3","type":"macro"},{"doc":"Defines a GraphQL field. Placement Allowed under: input_object interface object query, mutation, and subscription are all objects under the covers, and thus you&#39;ll find field definitions under those as well. Examples field :id, :id field :age, :integer, description: &quot;How old the item is&quot; field :name, :string do description &quot;The name of the item&quot; end field :location, type: :location","ref":"Absinthe.Schema.Notation.html#field/4","title":"Absinthe.Schema.Notation.field/4","type":"macro"},{"doc":"","ref":"Absinthe.Schema.Notation.html#grab_functions/4","title":"Absinthe.Schema.Notation.grab_functions/4","type":"function"},{"doc":"","ref":"Absinthe.Schema.Notation.html#handle_arg_attrs/3","title":"Absinthe.Schema.Notation.handle_arg_attrs/3","type":"function"},{"doc":"","ref":"Absinthe.Schema.Notation.html#handle_enum_value_attrs/2","title":"Absinthe.Schema.Notation.handle_enum_value_attrs/2","type":"function"},{"doc":"Import fields from another object Example object :news_queries do field :all_links, list_of(:link) field :main_story, :link end object :admin_queries do field :users, list_of(:user) field :pending_posts, list_of(:post) end query do import_fields :news_queries import_fields :admin_queries end Import fields can also be used on objects created inside other modules that you have used import_types on. defmodule MyApp.Schema.NewsTypes do use Absinthe.Schema.Notation object :news_queries do field :all_links, list_of(:link) field :main_story, :link end end defmodule MyApp.Schema.Schema do use Absinthe.Schema import_types MyApp.Schema.NewsTypes query do import_fields :news_queries # ... end end","ref":"Absinthe.Schema.Notation.html#import_fields/2","title":"Absinthe.Schema.Notation.import_fields/2","type":"macro"},{"doc":"Import types defined using the Schema Definition Language (SDL). TODO: Explain handlers Placement Top level in module. Examples Directly embedded SDL: import_sdl &quot;&quot;&quot; type Query { posts: [Post] } type Post { title: String! body: String! } &quot;&quot;&quot; Loaded from a file location (supporting recompilation on change): import_sdl path: &quot;/path/to/sdl.graphql&quot; TODO: Example for dynamic loading during init","ref":"Absinthe.Schema.Notation.html#import_sdl/1","title":"Absinthe.Schema.Notation.import_sdl/1","type":"macro"},{"doc":"","ref":"Absinthe.Schema.Notation.html#import_sdl/2","title":"Absinthe.Schema.Notation.import_sdl/2","type":"macro"},{"doc":"Import types from another module Very frequently your schema module will simply have the query and mutation blocks, and you&#39;ll want to break out your other types into other modules. This macro imports those types for use the current module Placement Top level in module. Examples import_types MyApp.Schema.Types import_types MyApp.Schema.Types.{TypesA, TypesB}","ref":"Absinthe.Schema.Notation.html#import_types/2","title":"Absinthe.Schema.Notation.import_types/2","type":"macro"},{"doc":"Defines an input object See Absinthe.Type.InputObject Placement Top level in module. Examples input_object :contact_input do field :email, non_null(:string) end","ref":"Absinthe.Schema.Notation.html#input_object/3","title":"Absinthe.Schema.Notation.input_object/3","type":"macro"},{"doc":"Declare an implemented interface for an object. Adds an Absinthe.Type.Interface to your schema. See also interfaces/1, which can be used for multiple interfaces, and interface/3, used to define interfaces themselves. Examples object :car do interface :vehicle # ... end","ref":"Absinthe.Schema.Notation.html#interface/1","title":"Absinthe.Schema.Notation.interface/1","type":"macro"},{"doc":"Define an interface type. Adds an Absinthe.Type.Interface to your schema. Also see interface/1 and interfaces/1, which declare that an object implements one or more interfaces. Placement Top level in module. Examples interface :vehicle do field :wheel_count, :integer end object :rally_car do field :wheel_count, :integer interface :vehicle end","ref":"Absinthe.Schema.Notation.html#interface/3","title":"Absinthe.Schema.Notation.interface/3","type":"macro"},{"doc":"Declare implemented interfaces for an object. See also interface/1, which can be used for one interface, and interface/3, used to define interfaces themselves. Placement Allowed under: object Examples object :car do interfaces [:vehicle, :branded] # ... end","ref":"Absinthe.Schema.Notation.html#interfaces/1","title":"Absinthe.Schema.Notation.interfaces/1","type":"macro"},{"doc":"Placement Allowed under: object","ref":"Absinthe.Schema.Notation.html#is_type_of/1","title":"Absinthe.Schema.Notation.is_type_of/1","type":"macro"},{"doc":"","ref":"Absinthe.Schema.Notation.html#lift_functions/2","title":"Absinthe.Schema.Notation.lift_functions/2","type":"function"},{"doc":"","ref":"Absinthe.Schema.Notation.html#lift_functions/3","title":"Absinthe.Schema.Notation.lift_functions/3","type":"function"},{"doc":"Marks a type reference as a list of the given type See field/3 for examples","ref":"Absinthe.Schema.Notation.html#list_of/1","title":"Absinthe.Schema.Notation.list_of/1","type":"macro"},{"doc":"Defines list of metadata&#39;s key/value pair for a custom type. This is generally used to facilitate libraries that want to augment Absinthe functionality Examples object :user do meta cache: true, ttl: 22_000 end object :user, meta: [cache: true, ttl: 22_000] do # ... end The meta can be accessed via the Absinthe.Type.meta/2 function. user_type = Absinthe.Schema.lookup_type(MyApp.Schema, :user) Absinthe.Type.meta(user_type, :cache) #=&gt; true Absinthe.Type.meta(user_type) #=&gt; [cache: true, ttl: 22_000] Placement Allowed under: enum field input_object interface object scalar union","ref":"Absinthe.Schema.Notation.html#meta/1","title":"Absinthe.Schema.Notation.meta/1","type":"macro"},{"doc":"Defines a metadata key/value pair for a custom type. For more info see meta/1 Examples meta :cache, false Placement Allowed under: enum field input_object interface object scalar union","ref":"Absinthe.Schema.Notation.html#meta/2","title":"Absinthe.Schema.Notation.meta/2","type":"macro"},{"doc":"","ref":"Absinthe.Schema.Notation.html#middleware/2","title":"Absinthe.Schema.Notation.middleware/2","type":"macro"},{"doc":"Marks a type reference as non null See field/3 for examples","ref":"Absinthe.Schema.Notation.html#non_null/1","title":"Absinthe.Schema.Notation.non_null/1","type":"macro"},{"doc":"","ref":"Absinthe.Schema.Notation.html#noop/1","title":"Absinthe.Schema.Notation.noop/1","type":"function"},{"doc":"Define an object type. Adds an Absinthe.Type.Object to your schema. Placement Top level in module. Examples Basic definition: object :car do # ... end Providing a custom name: object :car, name: &quot;CarType&quot; do # ... end","ref":"Absinthe.Schema.Notation.html#object/3","title":"Absinthe.Schema.Notation.object/3","type":"macro"},{"doc":"Declare a directive as operating an a AST node type See directive/2 Placement Allowed under: directive","ref":"Absinthe.Schema.Notation.html#on/1","title":"Absinthe.Schema.Notation.on/1","type":"macro"},{"doc":"Defines a parse function for a scalar type The specified parse function is used on incoming data to transform it into an elixir datastructure. It should return {:ok, value} or :error Placement Allowed under: scalar","ref":"Absinthe.Schema.Notation.html#parse/1","title":"Absinthe.Schema.Notation.parse/1","type":"macro"},{"doc":"","ref":"Absinthe.Schema.Notation.html#put_attr/2","title":"Absinthe.Schema.Notation.put_attr/2","type":"function"},{"doc":"","ref":"Absinthe.Schema.Notation.html#put_desc/2","title":"Absinthe.Schema.Notation.put_desc/2","type":"function"},{"doc":"","ref":"Absinthe.Schema.Notation.html#put_reference/2","title":"Absinthe.Schema.Notation.put_reference/2","type":"function"},{"doc":"","ref":"Absinthe.Schema.Notation.html#record!/5","title":"Absinthe.Schema.Notation.record!/5","type":"function"},{"doc":"","ref":"Absinthe.Schema.Notation.html#record_config!/2","title":"Absinthe.Schema.Notation.record_config!/2","type":"function"},{"doc":"","ref":"Absinthe.Schema.Notation.html#record_middleware!/3","title":"Absinthe.Schema.Notation.record_middleware!/3","type":"function"},{"doc":"","ref":"Absinthe.Schema.Notation.html#record_trigger!/3","title":"Absinthe.Schema.Notation.record_trigger!/3","type":"function"},{"doc":"Defines a resolve function for a field Specify a 2 or 3 arity function to call when resolving a field. You can either hard code a particular anonymous function, or have a function call that returns a 2 or 3 arity anonymous function. See examples for more information. Note that when using a hard coded anonymous function, the function will not capture local variables. 3 Arity Functions The first argument to the function is the parent entity. { user(id: 1) { name } } A resolution function on the name field would have the result of the user(id: 1) field as its first argument. Top level fields have the root_value as their first argument. Unless otherwise specified, this defaults to an empty map. The second argument to the resolution function is the field arguments. The final argument is an Absinthe.Resolution struct, which includes information like the context and other execution data. 2 Arity Function Exactly the same as the 3 arity version, but without the first argument (the parent entity) Placement Allowed under: field Examples query do field :person, :person do resolve &amp;Person.resolve/2 end end query do field :person, :person do resolve fn %{id: id}, _ -&gt; {:ok, Person.find(id)} end end end query do field :person, :person do resolve lookup(:person) end end def lookup(:person) do fn %{id: id}, _ -&gt; {:ok, Person.find(id)} end end","ref":"Absinthe.Schema.Notation.html#resolve/1","title":"Absinthe.Schema.Notation.resolve/1","type":"macro"},{"doc":"Define a type resolver for a union or interface. See also: Absinthe.Type.Interface Absinthe.Type.Union Placement Allowed under: interface union Examples interface :entity do # ... resolve_type fn %{employee_count: _}, _ -&gt; :business %{age: _}, _ -&gt; :person end end","ref":"Absinthe.Schema.Notation.html#resolve_type/1","title":"Absinthe.Schema.Notation.resolve_type/1","type":"macro"},{"doc":"Defines a scalar type See scalar/3","ref":"Absinthe.Schema.Notation.html#scalar/2","title":"Absinthe.Schema.Notation.scalar/2","type":"macro"},{"doc":"Define a scalar type A scalar type requires parse/1 and serialize/1 functions. Placement Top level in module. Examples scalar :time, description: &quot;ISOz time&quot; do parse &amp;Timex.parse(&amp;1.value, &quot;{ISOz}&quot;) serialize &amp;Timex.format!(&amp;1, &quot;{ISOz}&quot;) end","ref":"Absinthe.Schema.Notation.html#scalar/3","title":"Absinthe.Schema.Notation.scalar/3","type":"macro"},{"doc":"Defines a serialization function for a scalar type The specified serialize function is used on outgoing data. It should simply return the desired external representation. Placement Allowed under: scalar","ref":"Absinthe.Schema.Notation.html#serialize/1","title":"Absinthe.Schema.Notation.serialize/1","type":"macro"},{"doc":"Set a trigger for a subscription field. It accepts one or more mutation field names, and can be called more than once. mutation do field :gps_event, :gps_event field :user_checkin, :user end subscription do field :location_update, :user do arg :user_id, non_null(:id) config fn args, _ -&gt; {:ok, topic: args.user_id} end trigger :gps_event, topic: fn event -&gt; event.user_id end trigger :user_checkin, topic: fn user -&gt; [user.id, user.parent_id] end end end Trigger functions are only called once per event, so database calls within them do not present a significant burden. See the subscription/2 macro docs for additional details","ref":"Absinthe.Schema.Notation.html#trigger/2","title":"Absinthe.Schema.Notation.trigger/2","type":"macro"},{"doc":"Defines the types possible under a union type See union/3 Placement Allowed under: union","ref":"Absinthe.Schema.Notation.html#types/1","title":"Absinthe.Schema.Notation.types/1","type":"macro"},{"doc":"Defines a union type See Absinthe.Type.Union Placement Top level in module. Examples union :search_result do description &quot;A search result&quot; types [:person, :business] resolve_type fn %Person{}, _ -&gt; :person %Business{}, _ -&gt; :business end end","ref":"Absinthe.Schema.Notation.html#union/3","title":"Absinthe.Schema.Notation.union/3","type":"macro"},{"doc":"Defines a value possible under an enum type See enum/3 Placement Allowed under: enum","ref":"Absinthe.Schema.Notation.html#value/2","title":"Absinthe.Schema.Notation.value/2","type":"macro"},{"doc":"","ref":"Absinthe.Schema.Notation.html#values/1","title":"Absinthe.Schema.Notation.values/1","type":"macro"},{"doc":"","ref":"Absinthe.Schema.Notation.html#t:import_sdl_option/0","title":"Absinthe.Schema.Notation.import_sdl_option/0","type":"type"},{"doc":"Provides the directives available for SDL schema definitions. By default, the only directive provided is @deprecated, which supports a reason argument (of GraphQL type String). This can be used to mark a field To add additional schema directives, define your own prototype schema, e.g.: defmodule MyAppWeb.SchemaPrototype do use Absinthe.Schema.Prototype directive :feature do arg :name, non_null(:string) on [:interface] # Define `expand`, etc. end # More directives... end Then, set it as the prototype for your schema: defmodule MyAppWeb.Schema do use Absinthe.Schema @prototype_schema MyAppWeb.SchemaPrototype # Use `import_sdl`, etc... end","ref":"Absinthe.Schema.Prototype.html","title":"Absinthe.Schema.Prototype","type":"module"},{"doc":"Add a deprecation (with an optional reason) to a node.","ref":"Absinthe.Schema.Prototype.html#expand_deprecate/2","title":"Absinthe.Schema.Prototype.expand_deprecate/2","type":"function"},{"doc":"","ref":"Absinthe.Schema.Prototype.html#pipeline/1","title":"Absinthe.Schema.Prototype.pipeline/1","type":"function"},{"doc":"Used to define an argument. Usually these are defined using Absinthe.Schema.Notation.arg/2","ref":"Absinthe.Type.Argument.html","title":"Absinthe.Type.Argument","type":"module"},{"doc":"","ref":"Absinthe.Type.Argument.html#fetch/2","title":"Absinthe.Type.Argument.fetch/2","type":"function"},{"doc":"Argument configuration :name - The name of the argument, usually assigned automatically using Absinthe.Schema.Notation.arg/2. :type - The type values the argument accepts/will coerce to. :deprecation - Deprecation information for an argument, usually set-up using Absinthe.Schema.Notation.deprecate/1. :description - Description of an argument, useful for introspection.","ref":"Absinthe.Type.Argument.html#t:t/0","title":"Absinthe.Type.Argument.t/0","type":"type"},{"doc":"This module contains the following additional data types: datetime (UTC) naive_datetime date time decimal (only if Decimal is available) Further description of these types can be found in the source code. To use: import_types Absinthe.Type.Custom.","ref":"Absinthe.Type.Custom.html","title":"Absinthe.Type.Custom","type":"module"},{"doc":"Used by the GraphQL runtime as a way of modifying execution behavior. Type system creators will usually not create these directly.","ref":"Absinthe.Type.Directive.html","title":"Absinthe.Type.Directive","type":"module"},{"doc":"Callback implementation for c:Absinthe.Introspection.Kind.kind/0.","ref":"Absinthe.Type.Directive.html#kind/0","title":"Absinthe.Type.Directive.kind/0","type":"function"},{"doc":"","ref":"Absinthe.Type.Directive.html#t:location/0","title":"Absinthe.Type.Directive.location/0","type":"type"},{"doc":"A defined directive. :name - The name of the directivee. Should be a lowercase binary. Set automatically. :description - A nice description for introspection. :args - A map of Absinthe.Type.Argument structs. See Absinthe.Schema.Notation.arg/2. :locations - A list of places the directives can be used. The :__reference__ key is for internal use.","ref":"Absinthe.Type.Directive.html#t:t/0","title":"Absinthe.Type.Directive.t/0","type":"type"},{"doc":"Used to define an enum type, a special scalar that can only have a defined set of values. See the t type below for details and examples. Examples Given a type defined as the following (see Absinthe.Schema.Notation): @desc &quot;The selected color channel&quot; enum :color_channel do value :red, as: :r, description: &quot;Color Red&quot; value :green, as: :g, description: &quot;Color Green&quot; value :blue, as: :b, description: &quot;Color Blue&quot; value :alpha, as: :a, deprecate: &quot;We no longer support opacity settings&quot;, description: &quot;Alpha Channel&quot; end The &quot;ColorChannel&quot; type (referred inside Absinthe as :color_channel) is an Enum type, with values with names &quot;red&quot;, &quot;green&quot;, &quot;blue&quot;, and &quot;alpha&quot; that map to internal, raw values :r, :g, :b, and :a. The alpha color channel is deprecated, just as fields and arguments can be. You can omit the raw value if you&#39;d like it to be the same as the identifier. For instance, in this example the value is automatically set to :red: enum :color_channel do description &quot;The selected color channel&quot; value :red, description: &quot;Color Red&quot; value :green, description: &quot;Color Green&quot; value :blue, description: &quot;Color Blue&quot; value :alpha, deprecate: &quot;We no longer support opacity settings&quot;, description: &quot;Alpha Channel&quot; end If you really want to use a shorthand, skipping support for descriptions, custom raw values, and deprecation, you can just provide a list of atoms: enum :color_channel, values: [:red, :green, :blue, :alpha] Keep in mind that writing a terse definition that skips descriptions and deprecations today may hamper tooling that relies on introspection tomorrow.","ref":"Absinthe.Type.Enum.html","title":"Absinthe.Type.Enum","type":"module"},{"doc":"Callback implementation for c:Absinthe.Introspection.Kind.kind/0.","ref":"Absinthe.Type.Enum.html#kind/0","title":"Absinthe.Type.Enum.kind/0","type":"function"},{"doc":"A defined enum type. Should be defined using Absinthe.Schema.Notation.enum/2. :name - The name of the enum type. Should be a TitleCased binary. Set automatically. :description - A nice description for introspection. :values - The enum values, usually provided using the Absinthe.Schema.Notation.values/1 or Absinthe.Schema.Notation.value/1 macro. The __private__ and :__reference__ fields are for internal use.","ref":"Absinthe.Type.Enum.html#t:t/0","title":"Absinthe.Type.Enum.t/0","type":"type"},{"doc":"A possible value for an enum. See Absinthe.Type.Enum and Absinthe.Schema.Notation.value/1.","ref":"Absinthe.Type.Enum.Value.html","title":"Absinthe.Type.Enum.Value","type":"module"},{"doc":"A defined enum value entry. Generally defined using Absinthe.Schema.Notation.value/2 as part of a schema. :name - The name of the value. This is also the incoming, external value that will be provided by query documents. :description - A nice description for introspection. :value - The raw, internal value that :name map to. This will be provided as the argument value to resolve functions. :deprecation - Deprecation information for a value, usually set-up using the Absinthe.Schema.Notation.deprecate/1 convenience function.","ref":"Absinthe.Type.Enum.Value.html#t:t/0","title":"Absinthe.Type.Enum.Value.t/0","type":"type"},{"doc":"Used to define a field. Usually these are defined using Absinthe.Schema.Notation.field/4 See the t type below for details and examples of how to define a field.","ref":"Absinthe.Type.Field.html","title":"Absinthe.Type.Field","type":"module"},{"doc":"","ref":"Absinthe.Type.Field.html#fetch/2","title":"Absinthe.Type.Field.fetch/2","type":"function"},{"doc":"A complexity function. See the Absinthe.Type.Field/t explanation of :complexity for more information.","ref":"Absinthe.Type.Field.html#t:complexity_t/0","title":"Absinthe.Type.Field.complexity_t/0","type":"type"},{"doc":"A custom error may be a map or a Keyword.t, but must contain a :message key. Note that the values that make up a custom error must be serializable.","ref":"Absinthe.Type.Field.html#t:custom_error/0","title":"Absinthe.Type.Field.custom_error/0","type":"type"},{"doc":"An error message is a human-readable string describing the error that occurred.","ref":"Absinthe.Type.Field.html#t:error_message/0","title":"Absinthe.Type.Field.error_message/0","type":"type"},{"doc":"","ref":"Absinthe.Type.Field.html#t:error_result/0","title":"Absinthe.Type.Field.error_result/0","type":"type"},{"doc":"An error value is a simple error message, a custom error, or a list of either/both of them.","ref":"Absinthe.Type.Field.html#t:error_value/0","title":"Absinthe.Type.Field.error_value/0","type":"type"},{"doc":"","ref":"Absinthe.Type.Field.html#t:middleware_result/0","title":"Absinthe.Type.Field.middleware_result/0","type":"type"},{"doc":"","ref":"Absinthe.Type.Field.html#t:ok_result/0","title":"Absinthe.Type.Field.ok_result/0","type":"type"},{"doc":"A resolver function. See the Absinthe.Type.Field.t explanation of :resolve for more information.","ref":"Absinthe.Type.Field.html#t:resolver_t/0","title":"Absinthe.Type.Field.resolver_t/0","type":"type"},{"doc":"The result of a resolver.","ref":"Absinthe.Type.Field.html#t:result/0","title":"Absinthe.Type.Field.result/0","type":"type"},{"doc":"Any serializable value.","ref":"Absinthe.Type.Field.html#t:serializable/0","title":"Absinthe.Type.Field.serializable/0","type":"type"},{"doc":"The configuration for a field. :name - The name of the field, usually assigned automatically by the Absinthe.Schema.Notation.field/4. Including this option will bypass the snake_case to camelCase conversion. :description - Description of a field, useful for introspection. :deprecation - Deprecation information for a field, usually set-up using Absinthe.Schema.Notation.deprecate/1. :type - The type the value of the field should resolve to :args - The arguments of the field, usually created by using Absinthe.Schema.Notation.arg/2. :resolve - The resolution function. See below for more information. :complexity - The complexity function. See below for more information. :default_value - The default value of a field. Note this is not used during resolution; only fields that are part of an Absinthe.Type.InputObject should set this value. Resolution Functions Default If no resolution function is given, the default resolution function is used, which is roughly equivalent to this: {:ok, Map.get(parent_object, field_name)} This is commonly use when listing the available fields on a Absinthe.Type.Object that models a data record. For instance: object :person do description &quot;A person&quot; field :first_name, :string field :last_name, :string end Custom Resolution When accepting arguments, however, you probably need to use them for something. Here&#39;s an example of defining a field that looks up a list of users for a given location_id: query do field :users, :person do arg :location_id, non_null(:id) resolve fn %{location_id: id}, _ -&gt; {:ok, MyApp.users_for_location_id(id)} end end end Custom resolution functions are passed two arguments: A map of the arguments for the field, filled in with values from the provided query document/variables. An Absinthe.Resolution struct, containing the execution environment for the field (and useful for complex resolutions using the resolved source object, etc) Complexity function Default If no complexity function is given, the default complexity function is used, which is equivalent to: fn(_, child_complexity) -&gt; 1 + child_complexity end Custom Complexity When accepting arguments, however, you probably need to use them for something. Here&#39;s an example of defining a field that looks up at most limit users: query do field :users, :person do arg :limit, :integer complexity fn %{limit: limit}, child_complexity -&gt; 10 + limit * child_complexity end end end An optional third argument, Absinthe.Complexity struct, provides extra information. Here&#39;s an example of changing the complexity using the context: query do field :users, :person do arg :limit, :integer complexity fn _, child_complexity, %{context: %{admin: admin?}} -&gt; if admin?, do: 0, else: 10 + limit * child_complexity end end end Custom complexity functions are passed two or three arguments: A map of the arguments for the field, filled in with values from the provided query document/variables. A non negative integer, which is total complexity of the child fields. An Absinthe.Complexity struct with information about the context of the field. This argument is optional when using an anonymous function. Alternatively complexity can be an integer greater than or equal to 0: query do field :users, :person do complexity 10 end end","ref":"Absinthe.Type.Field.html#t:t/0","title":"Absinthe.Type.Field.t/0","type":"type"},{"doc":"Defines a GraphQL input object Input objects enable nested arguments to queries and mutations. Example mutation do field :user, :user do arg :name, :string arg :contact, non_null(:contact) resolve &amp;User.create/2 end end input_object :contact do field :email, :string end This supports the following mutation: mutation CreateUser { user(contact: {email: &quot;foo@bar.com&quot;}) { id } }","ref":"Absinthe.Type.InputObject.html","title":"Absinthe.Type.InputObject","type":"module"},{"doc":"","ref":"Absinthe.Type.InputObject.html#fetch/2","title":"Absinthe.Type.InputObject.fetch/2","type":"function"},{"doc":"Callback implementation for c:Absinthe.Introspection.Kind.kind/0.","ref":"Absinthe.Type.InputObject.html#kind/0","title":"Absinthe.Type.InputObject.kind/0","type":"function"},{"doc":"Note new input object types should be defined using Absinthe.Schema.Notation.input_object/3. :name - The name of the input object type. Should be a TitleCased binary. Set automatically. :description - A nice description for introspection. :fields - A map of Absinthe.Type.Field structs. Usually built via Absinthe.Schema.Notation.field/4. The __private__ and :__reference__ fields are for internal use.","ref":"Absinthe.Type.InputObject.html#t:t/0","title":"Absinthe.Type.InputObject.t/0","type":"type"},{"doc":"A defined interface type that represent a list of named fields and their arguments. Fields on an interface have the same rules as fields on an Absinthe.Type.Object. If an Absinthe.Type.Object lists an interface in its :interfaces entry, it guarantees that it defines the same fields and arguments that the interface does. Because sometimes it&#39;s for the interface to determine the implementing type of a resolved object, you must either: Provide a :resolve_type function on the interface Provide a :is_type_of function on each implementing type interface :named_entity do field :name, :string resolve_type fn %{age: _}, _ -&gt; :person %{employee_count: _}, _ -&gt; :business _, _ -&gt; nil end end object :person do field :name, :string field :age, :string interface :named_entity end object :business do field :name, :string field :employee_count, :integer interface :named_entity end","ref":"Absinthe.Type.Interface.html","title":"Absinthe.Type.Interface","type":"module"},{"doc":"Callback implementation for c:Absinthe.Introspection.Kind.kind/0.","ref":"Absinthe.Type.Interface.html#kind/0","title":"Absinthe.Type.Interface.kind/0","type":"function"},{"doc":"","ref":"Absinthe.Type.Interface.html#resolve_type/4","title":"Absinthe.Type.Interface.resolve_type/4","type":"function"},{"doc":"Whether the interface (or implementors) are correctly configured to resolve objects.","ref":"Absinthe.Type.Interface.html#type_resolvable?/2","title":"Absinthe.Type.Interface.type_resolvable?/2","type":"function"},{"doc":":name - The name of the interface type. Should be a TitleCased binary. Set automatically. :description - A nice description for introspection. :fields - A map of Absinthe.Type.Field structs. See Absinthe.Schema.Notation.field/4 and :args - A map of Absinthe.Type.Argument structs. See Absinthe.Schema.Notation.arg/2. :resolve_type - A function used to determine the implementing type of a resolved object. See also Absinthe.Type.Object&#39;s :is_type_of. The :resolve_type function will be passed two arguments; the object whose type needs to be identified, and the Absinthe.Execution struct providing the full execution context. The __private__ and :__reference__ keys are for internal use.","ref":"Absinthe.Type.Interface.html#t:t/0","title":"Absinthe.Type.Interface.t/0","type":"type"},{"doc":"A wrapping type which declares the type of each item in the list. Examples Given a type, :item, to declare the type of a field/argument as a list of :item-typed values, you could do: type: %Absinthe.Type.List{of_type: :item} But normally this would be done using Absinthe.Schema.Notation.list_of/1. type: list_of(:item)","ref":"Absinthe.Type.List.html","title":"Absinthe.Type.List","type":"module"},{"doc":"","ref":"Absinthe.Type.List.html#fetch/2","title":"Absinthe.Type.List.fetch/2","type":"function"},{"doc":"Callback implementation for c:Absinthe.Introspection.Kind.kind/0.","ref":"Absinthe.Type.List.html#kind/0","title":"Absinthe.Type.List.kind/0","type":"function"},{"doc":"A defined list type. ## Options :of_type - The underlying, wrapped type.","ref":"Absinthe.Type.List.html#t:t/0","title":"Absinthe.Type.List.t/0","type":"type"},{"doc":"A type that wraps an underlying type, acting identically to that type but adding a non-null constraint. By default, all types in GraphQL are nullable. To declare a type that disallows null, wrap it in a Absinthe.Type.NonNull struct. Examples Given a type, :item, to declare it as non-null, you could do the following: type: %Absinthe.Type.NonNull{of_type: :item} But normally this would be done using Absinthe.Schema.Notation.non_null/1. type: non_null(:item)","ref":"Absinthe.Type.NonNull.html","title":"Absinthe.Type.NonNull","type":"module"},{"doc":"","ref":"Absinthe.Type.NonNull.html#fetch/2","title":"Absinthe.Type.NonNull.fetch/2","type":"function"},{"doc":"Callback implementation for c:Absinthe.Introspection.Kind.kind/0.","ref":"Absinthe.Type.NonNull.html#kind/0","title":"Absinthe.Type.NonNull.kind/0","type":"function"},{"doc":"A defined non-null type. Options :of_type -- the underlying type to wrap","ref":"Absinthe.Type.NonNull.html#t:t/0","title":"Absinthe.Type.NonNull.t/0","type":"type"},{"doc":"","ref":"Absinthe.Type.NonNull.html#t:t/1","title":"Absinthe.Type.NonNull.t/1","type":"type"},{"doc":"Represents a non-leaf node in a GraphQL tree of information. Objects represent a list of named fields, each of which yield a value of a specific type. Object values are serialized as unordered maps, where the queried field names (or aliases) are the keys and the result of evaluating the field is the value. Also see Absinthe.Type.Scalar. Examples Given a type defined as the following (see Absinthe.Schema.Notation.object/3): @desc &quot;A person&quot; object :person do field :name, :string field :age, :integer field :best_friend, :person field :pets, list_of(:pet) end The &quot;Person&quot; type (referred inside Absinthe as :person) is an object, with fields that use Absinthe.Type.Scalar types (namely :name and :age), and other Absinthe.Type.Object types (:best_friend and :pets, assuming :pet is an object). Given we have a query that supports getting a person by name (see Absinthe.Schema), and a query document like the following: { person(name: &quot;Joe&quot;) { name best_friend { name age } pets { breed } } } We could get a result like this: %{ data: %{ &quot;person&quot; =&gt; %{ &quot;best_friend&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;Jill&quot;, &quot;age&quot; =&gt; 29 }, &quot;pets&quot; =&gt; [ %{&quot;breed&quot; =&gt; &quot;Wyvern&quot;}, %{&quot;breed&quot; =&gt; &quot;Royal Griffon&quot;} ] } } }","ref":"Absinthe.Type.Object.html","title":"Absinthe.Type.Object","type":"module"},{"doc":"Callback implementation for c:Absinthe.Introspection.Kind.kind/0.","ref":"Absinthe.Type.Object.html#kind/0","title":"Absinthe.Type.Object.kind/0","type":"function"},{"doc":"A defined object type. Note new object types (with the exception of the root-level query, mutation, and subscription) should be defined using Absinthe.Schema.Notation.object/3. :name - The name of the object type. Should be a TitleCased binary. Set automatically. :description - A nice description for introspection. :fields - A map of Absinthe.Type.Field structs. Usually built via Absinthe.Schema.Notation.field/4. :interfaces - A list of interfaces that this type guarantees to implement. See Absinthe.Type.Interface. :is_type_of - A function used to identify whether a resolved object belongs to this defined type. For use with :interfaces entry and Absinthe.Type.Interface. The __private__ and :__reference__ keys are for internal use.","ref":"Absinthe.Type.Object.html#t:t/0","title":"Absinthe.Type.Object.t/0","type":"type"},{"doc":"Represents a primitive value. GraphQL responses take the form of a hierarchical tree; the leaves on these trees are scalars. Also see Absinthe.Type.Object. Built-In Scalars The following built-in scalar types are defined: :boolean - Represents true or false. See the GraphQL Specification. :float - Represents signed double‐precision fractional values as specified by IEEE 754. See the GraphQL Specification. :id - Represents a unique identifier, often used to refetch an object or as key for a cache. The ID type is serialized in the same way as a String; however, it is not intended to be human‐readable. See the GraphQL Specification. :integer - Represents a signed 32‐bit numeric non‐fractional value, greater than or equal to -2^31 and less than 2^31. Note that Absinthe uses the full word :integer to identify this type, but its name (used by variables, for instance), is &quot;Int&quot;. See the GraphQL Specification. :string - Represents textual data, represented as UTF‐8 character sequences. The String type is most often used by GraphQL to represent free‐form human‐readable text. See the GraphQL Specification. Examples Supporting a time format in ISOz format, using Timex: scalar :time do description &quot;Time (in ISOz format)&quot; parse &amp;Timex.DateFormat.parse(&amp;1, &quot;{ISOz}&quot;) serialize &amp;Timex.DateFormat.format!(&amp;1, &quot;{ISOz}&quot;) end","ref":"Absinthe.Type.Scalar.html","title":"Absinthe.Type.Scalar","type":"module"},{"doc":"Callback implementation for c:Absinthe.Introspection.Kind.kind/0.","ref":"Absinthe.Type.Scalar.html#kind/0","title":"Absinthe.Type.Scalar.kind/0","type":"function"},{"doc":"","ref":"Absinthe.Type.Scalar.html#parse/3","title":"Absinthe.Type.Scalar.parse/3","type":"function"},{"doc":"","ref":"Absinthe.Type.Scalar.html#serialize/2","title":"Absinthe.Type.Scalar.serialize/2","type":"function"},{"doc":"A defined scalar type. Note new scalars should be defined using Absinthe.Schema.Notation.scalar. :name - The name of scalar. Should be a TitleCased binary. Set Automatically by Absinthe.Schema.Notation.scalar. :description - A nice description for introspection. :serialize - A function used to convert a value to a form suitable for JSON serialization :parse - A function used to convert the raw, incoming form of a scalar to the canonical internal format. The :__private__ and :__reference__ keys are for internal use.","ref":"Absinthe.Type.Scalar.html#t:t/0","title":"Absinthe.Type.Scalar.t/0","type":"type"},{"doc":"The internal, canonical representation of a scalar value","ref":"Absinthe.Type.Scalar.html#t:value_t/0","title":"Absinthe.Type.Scalar.value_t/0","type":"type"},{"doc":"A unions is an abstract type made up of multiple possible concrete types. No common fields are declared in a union. Compare to Absinthe.Type.Interface. Because it&#39;s necessary for the union to determine the concrete type of a resolved object, you must either: Provide a :resolve_type function on the union Provide a :is_type_of function on each possible concrete type union :search_result do description &quot;A search result&quot; types [:person, :business] resolve_type fn %Person{}, _ -&gt; :person %Business{}, _ -&gt; :business end end","ref":"Absinthe.Type.Union.html","title":"Absinthe.Type.Union","type":"module"},{"doc":"Callback implementation for c:Absinthe.Introspection.Kind.kind/0.","ref":"Absinthe.Type.Union.html#kind/0","title":"Absinthe.Type.Union.kind/0","type":"function"},{"doc":":name - The name of the union type. Should be a TitleCased binary. Set automatically. :description - A nice description for introspection. :types - The list of possible types. :resolve_type - A function used to determine the concrete type of a resolved object. See also Absinthe.Type.Object&#39;s :is_type_of. Either resolve_type is specified in the union type, or every object type in the union must specify is_type_of The :resolve_type function will be passed two arguments; the object whose type needs to be identified, and the Absinthe.Execution struct providing the full execution context. The __private__ and :__reference__ keys are for internal use.","ref":"Absinthe.Type.Union.html#t:t/0","title":"Absinthe.Type.Union.t/0","type":"type"},{"doc":"Middleware enables custom resolution behaviour on a field. All resolution happens through middleware. Even resolve functions are middleware, as the resolve macro is just quote do middleware Absinthe.Resolution, unquote(function_ast) end Resolution happens by reducing a list of middleware spec onto an %Absinthe.Resolution{} struct. Example defmodule MyApp.Web.Authentication do @behaviour Absinthe.Middleware def call(resolution, _config) do case resolution.context do %{current_user: _} -&gt; resolution _ -&gt; resolution |&gt; Absinthe.Resolution.put_result({:error, &quot;unauthenticated&quot;}) end end end By specifying @behaviour Absinthe.Middleware the compiler will ensure that we provide a def call callback. This function takes an %Absinthe.Resolution{} struct and will also need to return one such struct. On that struct there is a context key which holds the absinthe context. This is generally where things like the current user are placed. For more information on how the current user ends up in the context please see our full authentication guide on the website. Our call/2 function simply checks the context to see if there is a current user. If there is, we pass the resolution onward. If there is not, we update the resolution state to :resolved and place an error result. Middleware can be placed on a field in three different ways: Using the Absinthe.Schema.Notation.middleware/2 macro used inside a field definition Using the middleware/3 callback in your schema. Returning a {:middleware, middleware_spec, config} tuple from a resolution function. The middleware/2 macro For placing middleware on a particular field, it&#39;s handy to use the middleware/2 macro. Middleware will be run in the order in which they are specified. The middleware/3 callback has final say on what middleware get set. Examples MyApp.Web.Authentication would run before resolution, and HandleError would run after. field :hello, :string do middleware MyApp.Web.Authentication resolve &amp;get_the_string/2 middleware HandleError, :foo end Anonymous functions are a valid middleware spec. A nice use case is altering the context in a logout mutation. Mutations are the only time the context should be altered. This is not enforced. field :logout, :query do middleware fn res, _ -&gt; %{res | context: Map.delete(res.context, :current_user), value: &quot;logged out&quot;, state: :resolved } end end middleware/2 even accepts local public function names. Note that middleware/2 is the only thing that can take local function names without an associated module. If not using macros, use {{__MODULE__, :function_name}, []} def auth(res, _config) do # auth logic here end query do field :hello, :string do middleware :auth resolve &amp;get_the_string/2 end end The middleware/3 callback. middleware/3 is a function callback on a schema. When you use Absinthe.Schema a default implementation of this function is placed in your schema. It is passed the existing middleware for a field, the field itself, and the object that the field is a part of. So for example if your schema contained: object :user do field :name, :string field :age, :integer end query do field :lookup_user, :user do resolve fn _, _ -&gt; {:ok, %{name: &quot;Bob&quot;}} end end end def middleware(middleware, field, object) do middleware |&gt; IO.inspect field |&gt; IO.inspect object |&gt; IO.inspect middleware end Given a document like: { lookupUser { name }} object is each object that is accessed while executing the document. In our case that is the :user object and the :query object. field is every field on that object, and middleware is a list of whatever middleware spec have been configured by the schema on that field. Concretely then, the function will be called , with the following arguments: YourSchema.middleware([{Absinthe.Resolution, #Function&lt;20.52032458/0&gt;}], lookup_user_field_of_root_query_object, root_query_object) YourSchema.middleware([{Absinthe.Middleware.MapGet, :name}], name_field_of_user, user_object) YourSchema.middleware([{Absinthe.Middleware.MapGet, :age}], age_field_of_user, user_object) In the latter two cases we see that the middleware list is empty. In the first case we see one middleware spec, which is placed by the resolve macro used in the :lookup_user field. Default Middleware One use of middleware/3 is setting the default middleware on a field By default middleware is placed on a field that looks up a field by its snake case identifier, ie :resource_name Here is an example of how to change the default to use a camel cased string, IE, &quot;resourceName&quot;. def middleware(middleware, %{identifier: identifier} = field, object) do camelized = identifier |&gt; Atom.to_string |&gt; Macro.camelize new_middleware_spec = {{__MODULE__, :get_camelized_key}, camelized} Absinthe.Schema.replace_default(middleware, new_middleware_spec, field, object) end def get_camelized_key(%{source: source} = res, key) do %{res | state: :resolved, value: Map.get(source, key)} end There&#39;s a lot going on here so let&#39;s unpack it. We need to define a specification to tell Absinthe what middleware to run. The form we&#39;re using is {{MODULE, :function_to_call}, options_of_middleware}. For our purposes we&#39;re simply going to use a function in the schema module itself get_camelized_key. We then use the Absinthe.Schema.replace_default/4 function to swap out the default middleware already present in the middleware list with the new one we want to use. It handles going through the existing list of middleware and seeing if it&#39;s using the default or if it has custom resolvers on it. If it&#39;s using the default, the function applies our newly defined middleware spec. Like all middleware functions, :get_camelized_key takes a resolution struct, and options. The options is the camelized key we generated. We get the camelized string from the parent map, and set it as the value of the resolution struct. Finally we mark the resolution state :resolved. Side note: This middleware/3 function is called whenever we pull the type out of the schema. The middleware itself is run every time we get a field on an object. If we have 1000 objects and we were doing the camelization logic INSIDE the middleware, we would compute the camelized string 1000 times. By doing it in the def middleware callback we do it just once. Changes Since 1.3 In Absinthe 1.3, fields without any middleware/2 or resolve/1 calls would show up with an empty list [] as its middleware in the middleware/3 function. If no middleware was applied in the function and it also returned [], THEN Absinthe would apply the default. This made it very easy to accidently break your schema if you weren&#39;t particularly careful with your pattern matching. Now the defaults are applied FIRST by absinthe, and THEN passed to middleware/3. Consequently, the middleware list argument should always have at least one value. This is also why there is now the replace_default/4 function, because it handles telling the difference between a field with a resolver and a field with the default. Object Wide Authentication Let&#39;s use our authentication middleware from earlier, and place it on every field in the query object. defmodule MyApp.Web.Schema do use Absinthe.Schema query do field :private_field, :string do resolve fn _, _ -&gt; {:ok, &quot;this can only be viewed if authenticated&quot;} end end end def middleware(middleware, _field, %Absinthe.Type.Object{identifier: identifier}) when identifier in [:query, :subscription, :mutation] do [MyApp.Web.Authentication | middleware] end def middleware(middleware, _field, _object) do middleware end end It is important to note that we are matching for the :query, :subscription or :mutation identifier types. We do this because the middleware function will be called for each field in the schema. If we didn&#39;t limit it to those types, we would be applying authentication to every field in the entire schema, even stuff like :name or :age. This generally isn&#39;t necessary provided you authenticate at the entrypoints. Main Points Middleware functions take a %Absinthe.Resolution{} struct, and return one. All middleware on a field are always run, make sure to pattern match on the state if you care.","ref":"Absinthe.Middleware.html","title":"Absinthe.Middleware","type":"behaviour"},{"doc":"This is the main middleware callback. It receives an %Absinthe.Resolution{} struct and it needs to return an %Absinthe.Resolution{} struct. The second argument will be whatever value was passed to the middleware call that setup the middleware.","ref":"Absinthe.Middleware.html#c:call/2","title":"Absinthe.Middleware.call/2","type":"callback"},{"doc":"For testing and inspection purposes","ref":"Absinthe.Middleware.html#unshim/2","title":"Absinthe.Middleware.unshim/2","type":"function"},{"doc":"","ref":"Absinthe.Middleware.html#t:function_name/0","title":"Absinthe.Middleware.function_name/0","type":"type"},{"doc":"","ref":"Absinthe.Middleware.html#t:spec/0","title":"Absinthe.Middleware.spec/0","type":"type"},{"doc":"This plugin enables asynchronous execution of a field. See also Absinthe.Resolution.Helpers.async/1 Example Usage: Using the Absinthe.Resolution.Helpers.async/1 helper function: field :time_consuming, :thing do resolve fn _, _, _ -&gt; async(fn -&gt; {:ok, long_time_consuming_function()} end) end end Using the bare plugin API field :time_consuming, :thing do resolve fn _, _, _ -&gt; task = Task.async(fn -&gt; {:ok, long_time_consuming_function()} end) {:middleware, Elixir.Absinthe.Middleware.Async, task} end end This module also serves as an example for how to build middleware that uses the resolution callbacks. See the source code and associated comments for further details.","ref":"Absinthe.Middleware.Async.html","title":"Absinthe.Middleware.Async","type":"module"},{"doc":"Callback implementation for Absinthe.Plugin.after_resolution/1.","ref":"Absinthe.Middleware.Async.html#after_resolution/1","title":"Absinthe.Middleware.Async.after_resolution/1","type":"function"},{"doc":"Callback implementation for Absinthe.Plugin.before_resolution/1.","ref":"Absinthe.Middleware.Async.html#before_resolution/1","title":"Absinthe.Middleware.Async.before_resolution/1","type":"function"},{"doc":"Callback implementation for Absinthe.Middleware.call/2.","ref":"Absinthe.Middleware.Async.html#call/2","title":"Absinthe.Middleware.Async.call/2","type":"function"},{"doc":"Callback implementation for Absinthe.Plugin.pipeline/2.","ref":"Absinthe.Middleware.Async.html#pipeline/2","title":"Absinthe.Middleware.Async.pipeline/2","type":"function"},{"doc":"Batch the resolution of multiple fields. Motivation Consider the following graphql query: { posts { author { name } } } posts returns a list of post objects, which has an associated author field. If the author field makes a call to the database we have the classic N + 1 problem. What we want is a way to load all authors for all posts in one database request. This plugin provides this, without any eager loading at the parent level. That is, the code for the posts field does not need to do anything to facilitate the efficient loading of its children. Example Usage The API for this plugin is a little on the verbose side because it is not specific to any particular batching mechanism. That is, this API is just as useful for an Ecto based DB as it is for talking to S3 or the File System. Thus we anticipate people (including ourselves) will be creating additional functions more tailored to each of those specific use cases. Here is an example using the Absinthe.Resolution.Helpers.batch/3 helper. object :post do field :name, :string field :author, :user do resolve fn post, _, _ -&gt; batch({__MODULE__, :users_by_id}, post.author_id, fn batch_results -&gt; {:ok, Map.get(batch_results, post.author_id)} end) end end end def users_by_id(_, user_ids) do users = Repo.all from u in User, where: u.id in ^user_ids Map.new(users, fn user -&gt; {user.id, user} end) end Let&#39;s look at this piece by piece: {__MODULE__, :users_by_id}: is the batching function which will be used. It must be a 2 arity function. For details see the batch_fun typedoc. post.author_id: This is the information to be aggregated. The aggregated values are the second argument to the batching function. fn batch_results: This function takes the results from the batching function. it should return one of the resolution function values.","ref":"Absinthe.Middleware.Batch.html","title":"Absinthe.Middleware.Batch","type":"module"},{"doc":"Callback implementation for Absinthe.Plugin.after_resolution/1.","ref":"Absinthe.Middleware.Batch.html#after_resolution/1","title":"Absinthe.Middleware.Batch.after_resolution/1","type":"function"},{"doc":"Callback implementation for Absinthe.Plugin.before_resolution/1.","ref":"Absinthe.Middleware.Batch.html#before_resolution/1","title":"Absinthe.Middleware.Batch.before_resolution/1","type":"function"},{"doc":"Callback implementation for Absinthe.Middleware.call/2.","ref":"Absinthe.Middleware.Batch.html#call/2","title":"Absinthe.Middleware.Batch.call/2","type":"function"},{"doc":"Callback implementation for Absinthe.Plugin.pipeline/2.","ref":"Absinthe.Middleware.Batch.html#pipeline/2","title":"Absinthe.Middleware.Batch.pipeline/2","type":"function"},{"doc":"The function to be called with the aggregate batch information. It comes in both a 2 tuple and 3 tuple form. The first two elements are the module and function name. The third element is an arbitrary parameter that is passed as the first argument to the batch function. For example, one could parameterize the users_by_id function from the moduledoc to make it more generic. Instead of doing {__MODULE__, :users_by_id} you could do {__MODULE__, :by_id, User}. Then the function would be: def by_id(model, ids) do model |&gt; where([m], m.id in ^ids) |&gt; Repo.all() |&gt; Map.new(&amp;{&amp;1.id, &amp;1}) end It could also be used to set options unique to the execution of a particular batching function.","ref":"Absinthe.Middleware.Batch.html#t:batch_fun/0","title":"Absinthe.Middleware.Batch.batch_fun/0","type":"type"},{"doc":"","ref":"Absinthe.Middleware.Batch.html#t:post_batch_fun/0","title":"Absinthe.Middleware.Batch.post_batch_fun/0","type":"type"},{"doc":"","ref":"Absinthe.Middleware.Dataloader.html","title":"Absinthe.Middleware.Dataloader","type":"module"},{"doc":"This is the default middleware. It assumes the the object it receives is a map and uses Map.get/2 to get the value for this field. If this field is already marked as resolved, then this middleware does not touch it. If you want to replace this middleware you should use Absinthe.Schema.replace_default/4","ref":"Absinthe.Middleware.MapGet.html","title":"Absinthe.Middleware.MapGet","type":"module"},{"doc":"Callback implementation for Absinthe.Middleware.call/2.","ref":"Absinthe.Middleware.MapGet.html#call/2","title":"Absinthe.Middleware.MapGet.call/2","type":"function"},{"doc":"Middleware that just passes the parent down to the children. This is the default resolver for subscription fields.","ref":"Absinthe.Middleware.PassParent.html","title":"Absinthe.Middleware.PassParent","type":"module"},{"doc":"Callback implementation for Absinthe.Middleware.call/2.","ref":"Absinthe.Middleware.PassParent.html#call/2","title":"Absinthe.Middleware.PassParent.call/2","type":"function"},{"doc":"Gather and report telemetry about an individual field resolution","ref":"Absinthe.Middleware.Telemetry.html","title":"Absinthe.Middleware.Telemetry","type":"module"},{"doc":"","ref":"Absinthe.Middleware.Telemetry.html#on_complete/2","title":"Absinthe.Middleware.Telemetry.on_complete/2","type":"function"},{"doc":"Plugin Behaviour Plugins are an additional set of callbacks that can be used by module based middleware to run actions before and after resolution, as well as add additional phases to run after resolution","ref":"Absinthe.Plugin.html","title":"Absinthe.Plugin","type":"behaviour"},{"doc":"callback to do something with the resolution accumulator after resolution. NOTE: This function is given the full accumulator. Namespacing is suggested to avoid conflicts.","ref":"Absinthe.Plugin.html#c:after_resolution/1","title":"Absinthe.Plugin.after_resolution/1","type":"callback"},{"doc":"callback to setup the resolution accumulator prior to resolution. NOTE: This function is given the full accumulator. Namespacing is suggested to avoid conflicts.","ref":"Absinthe.Plugin.html#c:before_resolution/1","title":"Absinthe.Plugin.before_resolution/1","type":"callback"},{"doc":"Returns the list of default plugins.","ref":"Absinthe.Plugin.html#defaults/0","title":"Absinthe.Plugin.defaults/0","type":"function"},{"doc":"callback used to specify additional phases to run. Plugins may require additional resolution phases to be run. This function should use values set in the resolution accumulator to determine whether or not additional phases are required. NOTE: This function is given the whole pipeline to be inserted after the current phase completes.","ref":"Absinthe.Plugin.html#c:pipeline/2","title":"Absinthe.Plugin.pipeline/2","type":"callback"},{"doc":"","ref":"Absinthe.Plugin.html#t:t/0","title":"Absinthe.Plugin.t/0","type":"type"},{"doc":"Real time updates via GraphQL For a how to guide on getting started with Absinthe.Subscriptions in your phoenix project see the Absinthe.Phoenix package. Define in your schema via Absinthe.Schema.subscription/2 Basic Usage Performance Characteristics There are a couple of limitations to the beta release of subscriptions that are worth keeping in mind if you want to use this in production: By design, all subscription docs triggered by a mutation are run inside the mutation process as a form of back pressure. At the moment however database batching does not happen across the set of subscription docs. Thus if you have a lot of subscription docs and they each do a lot of extra DB lookups you&#39;re going to delay incoming mutation responses by however long it takes to do all that work. Before the final version of 1.4.0 we want Batching across subscriptions More user control over back pressure / async balance.","ref":"Absinthe.Subscription.html","title":"Absinthe.Subscription","type":"module"},{"doc":"","ref":"Absinthe.Subscription.html#child_spec/1","title":"Absinthe.Subscription.child_spec/1","type":"function"},{"doc":"Publish a mutation This function is generally used when trying to publish to one or more subscription fields &quot;out of band&quot; from any particular mutation. Examples Note: As with all subscription examples if you&#39;re using Absinthe.Phoenix pubsub will be MyAppWeb.Endpoint. Absinthe.Subscription.publish(pubsub, user, [new_users: user.account_id]) # publish to two subscription fields Absinthe.Subscription.publish(pubsub, user, [ new_users: user.account_id, other_user_subscription_field: user.id, ])","ref":"Absinthe.Subscription.html#publish/3","title":"Absinthe.Subscription.publish/3","type":"function"},{"doc":"Add Absinthe.Subscription to your process tree.","ref":"Absinthe.Subscription.html#start_link/1","title":"Absinthe.Subscription.start_link/1","type":"function"},{"doc":"","ref":"Absinthe.Subscription.html#t:subscription_field_spec/0","title":"Absinthe.Subscription.subscription_field_spec/0","type":"type"},{"doc":"This module handles broadcasting documents that are local to this node","ref":"Absinthe.Subscription.Local.html","title":"Absinthe.Subscription.Local","type":"module"},{"doc":"Publish a mutation to the local node only. See also Absinthe.Subscription.publish/3","ref":"Absinthe.Subscription.Local.html#publish_mutation/3","title":"Absinthe.Subscription.Local.publish_mutation/3","type":"function"},{"doc":"Pubsub behaviour expected by Absinthe to power subscriptions A subscription includes a GraphQL query document that resolves to a set of objects and fields. When the subscription is triggered, Absinthe will run the document and publish the resolved objects to subscribers through a module that implements the behaviour defined here. Each application is free to implement the PubSub behavior in its own way.For example, the absinthe_phoenix project implements the subscription pubsub using Phoenix.PubSub by way of the application&#39;s Endpoint. Regardless of the underlying mechanisms, the implementation should maintain the type signatures and expected behaviors of the callbacks below.","ref":"Absinthe.Subscription.Pubsub.html","title":"Absinthe.Subscription.Pubsub","type":"behaviour"},{"doc":"An Absinthe.Subscription.Pubsub system may extend across multiple nodes connected by some mechanism. Regardless of this mechanism, all nodes should have unique names. Absinthe invokes node_name function to get current node&#39;s name. If you are running inside erlang cluster, you can use Kernel.node/0 as a node name.","ref":"Absinthe.Subscription.Pubsub.html#c:node_name/0","title":"Absinthe.Subscription.Pubsub.node_name/0","type":"callback"},{"doc":"An Absinthe.Subscription.Pubsub system may extend across multiple nodes. Processes need only subscribe to the pubsub process that is running on their own node. However, mutations can happen on any node in the custer and must to be broadcast to other nodes so that they can also reevaluate their GraphQL subscriptions and notify subscribers on that node. When told of a mutation, Absinthe invokes the publish_mutation function on the node in which the mutation is processed first. The function should publish a message to the given proxy_topic, with the identity of node on which the mutation occurred included in the broadcast message. The message broadcast should be a map that contains, at least %{ node: node_name, # should be equal to `node_name/0` mutation_result: …, # from arguments subscribed_fields: … # from arguments # other fields as needed }","ref":"Absinthe.Subscription.Pubsub.html#c:publish_mutation/3","title":"Absinthe.Subscription.Pubsub.publish_mutation/3","type":"callback"},{"doc":"After a mutation is published, and Absinthe has re-run the necessary GraphQL subscriptions to generate a new set of resolved data, it calls publish_subscription. Your pubsub implementation should publish a message to the given topic, with the newly resolved data. The broadcast should be limited to the current node only.","ref":"Absinthe.Subscription.Pubsub.html#c:publish_subscription/2","title":"Absinthe.Subscription.Pubsub.publish_subscription/2","type":"callback"},{"doc":"Subscribe the current process for messages about the given topic.","ref":"Absinthe.Subscription.Pubsub.html#c:subscribe/1","title":"Absinthe.Subscription.Pubsub.subscribe/1","type":"callback"},{"doc":"","ref":"Absinthe.Subscription.Pubsub.html#t:t/0","title":"Absinthe.Subscription.Pubsub.t/0","type":"type"},{"doc":"Behaviour for Absinthe Phases. A phase takes an Absinthe.Blueprint document and returns another blueprint document. All validation, resolution, and result building happens via phases. See Absinthe.Pipeline for information on how to run phases. See the code under this namespace for information on individual phases.","ref":"Absinthe.Phase.html","title":"Absinthe.Phase","type":"behaviour"},{"doc":"","ref":"Absinthe.Phase.html#any_invalid?/1","title":"Absinthe.Phase.any_invalid?/1","type":"function"},{"doc":"","ref":"Absinthe.Phase.html#put_error/2","title":"Absinthe.Phase.put_error/2","type":"function"},{"doc":"","ref":"Absinthe.Phase.html#c:run/2","title":"Absinthe.Phase.run/2","type":"callback"},{"doc":"","ref":"Absinthe.Phase.html#t:result_t/0","title":"Absinthe.Phase.result_t/0","type":"type"},{"doc":"","ref":"Absinthe.Phase.html#t:t/0","title":"Absinthe.Phase.t/0","type":"type"},{"doc":"Pass on context and root value to document.","ref":"Absinthe.Phase.Document.Context.html","title":"Absinthe.Phase.Document.Context","type":"module"},{"doc":"","ref":"Absinthe.Phase.Document.Context.html#flag_invalid/1","title":"Absinthe.Phase.Document.Context.flag_invalid/1","type":"function"},{"doc":"","ref":"Absinthe.Phase.Document.Context.html#flag_invalid/2","title":"Absinthe.Phase.Document.Context.flag_invalid/2","type":"function"},{"doc":"","ref":"Absinthe.Phase.Document.Context.html#inherit_invalid/3","title":"Absinthe.Phase.Document.Context.inherit_invalid/3","type":"function"},{"doc":"","ref":"Absinthe.Phase.Document.Context.html#put_flag/2","title":"Absinthe.Phase.Document.Context.put_flag/2","type":"function"},{"doc":"Callback implementation for Absinthe.Phase.run/2.","ref":"Absinthe.Phase.Document.Context.html#run/2","title":"Absinthe.Phase.Document.Context.run/2","type":"function"},{"doc":"Gather and report telemetry about an operation.","ref":"Absinthe.Phase.Telemetry.html","title":"Absinthe.Phase.Telemetry","type":"module"},{"doc":"","ref":"Absinthe.Phase.Telemetry.html#flag_invalid/1","title":"Absinthe.Phase.Telemetry.flag_invalid/1","type":"function"},{"doc":"","ref":"Absinthe.Phase.Telemetry.html#flag_invalid/2","title":"Absinthe.Phase.Telemetry.flag_invalid/2","type":"function"},{"doc":"","ref":"Absinthe.Phase.Telemetry.html#inherit_invalid/3","title":"Absinthe.Phase.Telemetry.inherit_invalid/3","type":"function"},{"doc":"","ref":"Absinthe.Phase.Telemetry.html#put_flag/2","title":"Absinthe.Phase.Telemetry.put_flag/2","type":"function"},{"doc":"Callback implementation for Absinthe.Phase.run/2.","ref":"Absinthe.Phase.Telemetry.html#run/2","title":"Absinthe.Phase.Telemetry.run/2","type":"function"},{"doc":"Execute a pipeline of phases. A pipeline is merely a list of phases. This module contains functions for building, modifying, and executing pipelines of phases.","ref":"Absinthe.Pipeline.html","title":"Absinthe.Pipeline","type":"module"},{"doc":"Return the part of a pipeline before a specific phase. Examples iex&gt; Pipeline.before([A, B, C], B) [A]","ref":"Absinthe.Pipeline.html#before/2","title":"Absinthe.Pipeline.before/2","type":"function"},{"doc":"","ref":"Absinthe.Pipeline.html#for_document/2","title":"Absinthe.Pipeline.for_document/2","type":"function"},{"doc":"","ref":"Absinthe.Pipeline.html#for_schema/2","title":"Absinthe.Pipeline.for_schema/2","type":"function"},{"doc":"Return the part of a pipeline after (and including) a specific phase. Examples iex&gt; Pipeline.from([A, B, C], B) [B, C]","ref":"Absinthe.Pipeline.html#from/2","title":"Absinthe.Pipeline.from/2","type":"function"},{"doc":"Return the pipeline with the phase/list of phases inserted after the supplied phase. Examples Add one phase after another: iex&gt; Pipeline.insert_after([A, C, D], A, B) [A, B, C, D] Add list of phases after another: iex&gt; Pipeline.insert_after([A, D, E], A, [B, C]) [A, B, C, D, E]","ref":"Absinthe.Pipeline.html#insert_after/3","title":"Absinthe.Pipeline.insert_after/3","type":"function"},{"doc":"Return the pipeline with the phase/list of phases inserted before the supplied phase. Examples Add one phase before another: iex&gt; Pipeline.insert_before([A, C, D], C, B) [A, B, C, D] Add list of phase before another: iex&gt; Pipeline.insert_before([A, D, E], D, [B, C]) [A, B, C, D, E]","ref":"Absinthe.Pipeline.html#insert_before/3","title":"Absinthe.Pipeline.insert_before/3","type":"function"},{"doc":"","ref":"Absinthe.Pipeline.html#options/1","title":"Absinthe.Pipeline.options/1","type":"function"},{"doc":"Return the pipeline with the phases matching the regex removed. Examples iex&gt; Pipeline.reject([A, B, C], ~r/A|B/) [C]","ref":"Absinthe.Pipeline.html#reject/2","title":"Absinthe.Pipeline.reject/2","type":"function"},{"doc":"Replace a phase in a pipeline with another, supporting reusing the same options. Examples Replace a simple phase (without options): iex&gt; Pipeline.replace([A, B, C], B, X) [A, X, C] Replace a phase with options, retaining them: iex&gt; Pipeline.replace([A, {B, [name: &quot;Thing&quot;]}, C], B, X) [A, {X, [name: &quot;Thing&quot;]}, C] Replace a phase with options, overriding them: iex&gt; Pipeline.replace([A, {B, [name: &quot;Thing&quot;]}, C], B, {X, [name: &quot;Nope&quot;]}) [A, {X, [name: &quot;Nope&quot;]}, C]","ref":"Absinthe.Pipeline.html#replace/3","title":"Absinthe.Pipeline.replace/3","type":"function"},{"doc":"","ref":"Absinthe.Pipeline.html#run/2","title":"Absinthe.Pipeline.run/2","type":"function"},{"doc":"","ref":"Absinthe.Pipeline.html#run_phase/3","title":"Absinthe.Pipeline.run_phase/3","type":"function"},{"doc":"Return the part of a pipeline up to and including a specific phase. Examples iex&gt; Pipeline.upto([A, B, C], B) [A, B]","ref":"Absinthe.Pipeline.html#upto/2","title":"Absinthe.Pipeline.upto/2","type":"function"},{"doc":"Return the pipeline with the supplied phase removed. Examples iex&gt; Pipeline.without([A, B, C], B) [A, C]","ref":"Absinthe.Pipeline.html#without/2","title":"Absinthe.Pipeline.without/2","type":"function"},{"doc":"","ref":"Absinthe.Pipeline.html#t:data_t/0","title":"Absinthe.Pipeline.data_t/0","type":"type"},{"doc":"","ref":"Absinthe.Pipeline.html#t:phase_config_t/0","title":"Absinthe.Pipeline.phase_config_t/0","type":"type"},{"doc":"","ref":"Absinthe.Pipeline.html#t:t/0","title":"Absinthe.Pipeline.t/0","type":"type"},{"doc":"A basic struct that wraps phase errors for reporting to the user.","ref":"Absinthe.Pipeline.ErrorResult.html","title":"Absinthe.Pipeline.ErrorResult","type":"module"},{"doc":"Generate a new ErrorResult for one or more phase errors","ref":"Absinthe.Pipeline.ErrorResult.html#new/1","title":"Absinthe.Pipeline.ErrorResult.new/1","type":"function"},{"doc":"","ref":"Absinthe.Pipeline.ErrorResult.html#t:t/0","title":"Absinthe.Pipeline.ErrorResult.t/0","type":"type"},{"doc":"Absinthe supports an adapter mechanism that allows developers to define their schema using one code convention (eg, snake_cased fields and arguments), but accept query documents and return results (including names in errors) in another (eg, camelCase). Adapters aren&#39;t a part of GraphQL, but a utility that Absinthe adds so that both client and server can use use conventions most natural to them. Absinthe ships with four adapters: Absinthe.Adapter.LanguageConventions, which expects schemas to be defined in snake_case (the standard Elixir convention), translating to/from camelCase for incoming query documents and outgoing results. (This is the default as of v0.3.) Absinthe.Adapter.Underscore, which is similar to the Absinthe.Adapter.LanguageConventions adapter but converts all incoming identifiers to underscores and does not modify outgoing identifiers (since those are already expected to be underscores). Unlike Absinthe.Adapter.Passthrough this does not break introspection. Absinthe.Adapter.Passthrough, which is a no-op adapter and makes no modifications. (Note at the current time this does not support introspection if you&#39;re using camelized conventions). Absinthe.Adapter.StrictLanguageConventions, which expects schemas to be defined in snake_case, translating to camelCase for outgoing results. This adapter requires incoming query documents to use camelCase. To set an adapter, you pass a configuration option at runtime: For Absinthe.run/3: Absinthe.run( query, MyApp.Schema, adapter: YourApp.Adapter.TheAdapterName ) For Absinthe.Plug: forward &quot;/api&quot;, to: Absinthe.Plug, init_opts: [schema: MyAppWeb.Schema, adapter: YourApp.Adapter.TheAdapterName] For GraphiQL: forward &quot;/graphiql&quot;, to: Absinthe.Plug.GraphiQL, init_opts: [schema: MyAppWeb.Schema, adapter: YourApp.Adapter.TheAdapterName] Check Absinthe.Plug for full documentation on using the Plugs Notably, this means you&#39;re able to switch adapters on case-by-case basis. In a Phoenix application, this means you could even support using different adapters for different clients. A custom adapter module must merely implement the Absinthe.Adapter protocol, in many cases with use Absinthe.Adapter and only overriding the desired functions. Writing Your Own All you may need to implement in your adapter is to_internal_name/2 and to_external_name/2. Check out Absinthe.Adapter.LanguageConventions for a good example. Note that types that are defined external to your application (including the introspection types) may not be compatible if you&#39;re using a different adapter.","ref":"Absinthe.Adapter.html","title":"Absinthe.Adapter","type":"behaviour"},{"doc":"Convert a name from an internal name to an external name. Examples Remove the role-prefix (the inverse of what we did in to_internal_name/2 above): def to_external_name(internal_name, role) do internal_name |&gt; String.replace(~r/^\#{role}_/, &quot;&quot;) end","ref":"Absinthe.Adapter.html#c:to_external_name/2","title":"Absinthe.Adapter.to_external_name/2","type":"callback"},{"doc":"Convert a name from an external name to an internal name. Examples Prefix all names with their role, just for fun! def to_internal_name(external_name, role) do role_name = role |&gt; to_string role_name &lt;&gt; &quot;_&quot; &lt;&gt; external_name end","ref":"Absinthe.Adapter.html#c:to_internal_name/2","title":"Absinthe.Adapter.to_internal_name/2","type":"callback"},{"doc":"The lexical role of a name within the document/schema.","ref":"Absinthe.Adapter.html#t:role_t/0","title":"Absinthe.Adapter.role_t/0","type":"type"},{"doc":"","ref":"Absinthe.Adapter.html#t:t/0","title":"Absinthe.Adapter.t/0","type":"type"},{"doc":"This defines an adapter that supports GraphQL query documents in their conventional (in JS) camelcase notation, while allowing the schema to be defined using conventional (in Elixir) underscore (snakecase) notation, and tranforming the names as needed for lookups, results, and error messages. For example, this document: { myUser: createUser(userId: 2) { firstName lastName } } Would map to an internal schema that used the following names: create_user instead of createUser user_id instead of userId first_name instead of firstName last_name instead of lastName Likewise, the result of executing this (camelcase) query document against our (snakecase) schema would have its names transformed back into camelcase on the way out: %{ data: %{ &quot;myUser&quot; =&gt; %{ &quot;firstName&quot; =&gt; &quot;Joe&quot;, &quot;lastName&quot; =&gt; &quot;Black&quot; } } } Note variables are a client-facing concern (they may be provided as parameters), so variable names should match the convention of the query document (eg, camelCase).","ref":"Absinthe.Adapter.LanguageConventions.html","title":"Absinthe.Adapter.LanguageConventions","type":"module"},{"doc":"Converts a snake_case name to camelCase","ref":"Absinthe.Adapter.LanguageConventions.html#to_external_name/2","title":"Absinthe.Adapter.LanguageConventions.to_external_name/2","type":"function"},{"doc":"Converts a camelCase to snake_case","ref":"Absinthe.Adapter.LanguageConventions.html#to_internal_name/2","title":"Absinthe.Adapter.LanguageConventions.to_internal_name/2","type":"function"},{"doc":"The default adapter, which makes no changes to incoming query document ASTs or outgoing results.","ref":"Absinthe.Adapter.Passthrough.html","title":"Absinthe.Adapter.Passthrough","type":"module"},{"doc":"","ref":"Absinthe.Adapter.Passthrough.html#dump_results/1","title":"Absinthe.Adapter.Passthrough.dump_results/1","type":"function"},{"doc":"","ref":"Absinthe.Adapter.Passthrough.html#load_document/1","title":"Absinthe.Adapter.Passthrough.load_document/1","type":"function"},{"doc":"Callback implementation for Absinthe.Adapter.to_external_name/2.","ref":"Absinthe.Adapter.Passthrough.html#to_external_name/2","title":"Absinthe.Adapter.Passthrough.to_external_name/2","type":"function"},{"doc":"Callback implementation for Absinthe.Adapter.to_internal_name/2.","ref":"Absinthe.Adapter.Passthrough.html#to_internal_name/2","title":"Absinthe.Adapter.Passthrough.to_internal_name/2","type":"function"},{"doc":"Strict version of Absinthe.Adapter.LanguageConventions that will reject improperly formatted external names. For example, this document: { create_user(user_id: 2) { first_name last_name } } Would result in name-mismatch errors returned to the client. The client should instead send the camelcase variant of the names: { createUser(userId: 2) { firstName lastName } } See Absinthe.Adapter.LanguageConventions for more information.","ref":"Absinthe.Adapter.StrictLanguageConventions.html","title":"Absinthe.Adapter.StrictLanguageConventions","type":"module"},{"doc":"Converts a snake_case to camelCase See Absinthe.Adapter.LanguageConventions.to_external_name/2","ref":"Absinthe.Adapter.StrictLanguageConventions.html#to_external_name/2","title":"Absinthe.Adapter.StrictLanguageConventions.to_external_name/2","type":"function"},{"doc":"Converts a camelCase to snake_case Returns nil if the converted internal name does not match the converted external name. See Absinthe.Adapter.LanguageConventions.to_internal_name/2","ref":"Absinthe.Adapter.StrictLanguageConventions.html#to_internal_name/2","title":"Absinthe.Adapter.StrictLanguageConventions.to_internal_name/2","type":"function"},{"doc":"Underscores external input and leaves external input alone. Unlike the Absinthe.Adapter.Passthrough this does not break introspection (because introspection relies on underscoring incoming introspection queries which we still do).","ref":"Absinthe.Adapter.Underscore.html","title":"Absinthe.Adapter.Underscore","type":"module"},{"doc":"Callback implementation for Absinthe.Adapter.to_external_name/2.","ref":"Absinthe.Adapter.Underscore.html#to_external_name/2","title":"Absinthe.Adapter.Underscore.to_external_name/2","type":"function"},{"doc":"Callback implementation for Absinthe.Adapter.to_internal_name/2.","ref":"Absinthe.Adapter.Underscore.html#to_internal_name/2","title":"Absinthe.Adapter.Underscore.to_internal_name/2","type":"function"},{"doc":"Represents the graphql document to be executed. Please see the code itself for more information on individual blueprint sub modules.","ref":"Absinthe.Blueprint.html","title":"Absinthe.Blueprint","type":"module"},{"doc":"","ref":"Absinthe.Blueprint.html#add_field/3","title":"Absinthe.Blueprint.add_field/3","type":"function"},{"doc":"Get the currently selected operation.","ref":"Absinthe.Blueprint.html#current_operation/1","title":"Absinthe.Blueprint.current_operation/1","type":"function"},{"doc":"Append the given field or fields to the given type","ref":"Absinthe.Blueprint.html#extend_fields/2","title":"Absinthe.Blueprint.extend_fields/2","type":"function"},{"doc":"","ref":"Absinthe.Blueprint.html#find/2","title":"Absinthe.Blueprint.find/2","type":"function"},{"doc":"","ref":"Absinthe.Blueprint.html#find_field/2","title":"Absinthe.Blueprint.find_field/2","type":"function"},{"doc":"Determine whether a flag has been set on a node.","ref":"Absinthe.Blueprint.html#flagged?/2","title":"Absinthe.Blueprint.flagged?/2","type":"function"},{"doc":"","ref":"Absinthe.Blueprint.html#fragment/2","title":"Absinthe.Blueprint.fragment/2","type":"function"},{"doc":"See Absinthe.Blueprint.Transform.postwalk/2.","ref":"Absinthe.Blueprint.html#postwalk/2","title":"Absinthe.Blueprint.postwalk/2","type":"function"},{"doc":"See Absinthe.Blueprint.Transform.postwalk/3.","ref":"Absinthe.Blueprint.html#postwalk/3","title":"Absinthe.Blueprint.postwalk/3","type":"function"},{"doc":"See Absinthe.Blueprint.Transform.prewalk/2.","ref":"Absinthe.Blueprint.html#prewalk/2","title":"Absinthe.Blueprint.prewalk/2","type":"function"},{"doc":"See Absinthe.Blueprint.Transform.prewalk/3.","ref":"Absinthe.Blueprint.html#prewalk/3","title":"Absinthe.Blueprint.prewalk/3","type":"function"},{"doc":"Add a flag to a node.","ref":"Absinthe.Blueprint.html#put_flag/3","title":"Absinthe.Blueprint.put_flag/3","type":"function"},{"doc":"Index the types by their name","ref":"Absinthe.Blueprint.html#types_by_name/1","title":"Absinthe.Blueprint.types_by_name/1","type":"function"},{"doc":"Update the current operation.","ref":"Absinthe.Blueprint.html#update_current/2","title":"Absinthe.Blueprint.update_current/2","type":"function"},{"doc":"","ref":"Absinthe.Blueprint.html#t:flags_t/0","title":"Absinthe.Blueprint.flags_t/0","type":"type"},{"doc":"","ref":"Absinthe.Blueprint.html#t:node_t/0","title":"Absinthe.Blueprint.node_t/0","type":"type"},{"doc":"","ref":"Absinthe.Blueprint.html#t:result_t/0","title":"Absinthe.Blueprint.result_t/0","type":"type"},{"doc":"","ref":"Absinthe.Blueprint.html#t:t/0","title":"Absinthe.Blueprint.t/0","type":"type"},{"doc":"","ref":"Absinthe.Blueprint.html#t:use_t/0","title":"Absinthe.Blueprint.use_t/0","type":"type"},{"doc":"Blueprint Execution Data The %Absinthe.Blueprint.Execution{} struct holds on to the core values that drive a document&#39;s execution. Here&#39;s how the execution flow works. Given a document like: { posts { title author { name } } } After all the validation happens, and we&#39;re actually going to execute this document, an %Execution{} struct is created. This struct is passed to each plugin&#39;s before_resolution callback, so that plugins can set initial values in the accumulator or context. Then the resolution phase walks the document until it hits the posts field. To resolve the posts field, an %Absinthe.Resolution{} struct is created from the %Execution{} struct. This resolution struct powers the normal middleware resolution process. When a field has resolved, the :acc, :context, and :field_cache values within the resolution struct are pulled out and used to update the execution.","ref":"Absinthe.Blueprint.Execution.html","title":"Absinthe.Blueprint.Execution","type":"module"},{"doc":"","ref":"Absinthe.Blueprint.Execution.html#get/2","title":"Absinthe.Blueprint.Execution.get/2","type":"function"},{"doc":"","ref":"Absinthe.Blueprint.Execution.html#get_result/2","title":"Absinthe.Blueprint.Execution.get_result/2","type":"function"},{"doc":"","ref":"Absinthe.Blueprint.Execution.html#get_result/3","title":"Absinthe.Blueprint.Execution.get_result/3","type":"function"},{"doc":"","ref":"Absinthe.Blueprint.Execution.html#update/4","title":"Absinthe.Blueprint.Execution.update/4","type":"function"},{"doc":"","ref":"Absinthe.Blueprint.Execution.html#t:acc/0","title":"Absinthe.Blueprint.Execution.acc/0","type":"type"},{"doc":"","ref":"Absinthe.Blueprint.Execution.html#t:node_t/0","title":"Absinthe.Blueprint.Execution.node_t/0","type":"type"},{"doc":"","ref":"Absinthe.Blueprint.Execution.html#t:t/0","title":"Absinthe.Blueprint.Execution.t/0","type":"type"},{"doc":"Extra metadata passed to aid complexity analysis functions, describing the current field&#39;s environment.","ref":"Absinthe.Complexity.html","title":"Absinthe.Complexity","type":"module"},{"doc":":definition - The Blueprint definition for this field. :context - The context passed to Absinthe.run. :root_value - The root value passed to Absinthe.run, if any. :schema - The current schema.","ref":"Absinthe.Complexity.html#t:t/0","title":"Absinthe.Complexity.t/0","type":"type"},{"doc":"Information about the current resolution. It is created by adding field specific information to the more general %Absinthe.Blueprint.Execution{} struct. In many ways like the %Conn{} from Plug, the %Absinthe.Resolution{} is the piece of information that passed along from middleware to middleware as part of resolution. Contents :adapter - The adapter used for any name conversions. :definition - The Blueprint definition for this field. :context - The context passed to Absinthe.run. :root_value - The root value passed to Absinthe.run, if any. :parent_type - The parent type for the field. :private - Operates similarly to the :private key on a %Plug.Conn{} and is a place for libraries (and similar) to store their information. :schema - The current schema. :source - The resolved parent object; source of this field. When a %Resolution{} is accessed via middleware, you may want to update the context (e.g. to cache a dataloader instance or the result of an ecto query). Updating the context can be done simply by using the map updating syntax (or Map.put/4): %{resolution | context: new_context} # OR Map.put(resolution, :context, new_context) To access the schema type for this field, see the definition.schema_node.","ref":"Absinthe.Resolution.html","title":"Absinthe.Resolution","type":"module"},{"doc":"","ref":"Absinthe.Resolution.html#call/2","title":"Absinthe.Resolution.call/2","type":"function"},{"doc":"","ref":"Absinthe.Resolution.html#call/3","title":"Absinthe.Resolution.call/3","type":"function"},{"doc":"TODO: Deprecate","ref":"Absinthe.Resolution.html#call/4","title":"Absinthe.Resolution.call/4","type":"function"},{"doc":"Get the current path. Each Absinthe.Resolution struct holds the current result path as a list of blueprint nodes and indices. Usually however you don&#39;t need the full AST list and instead just want the path that will eventually end up in the result. For that, use this function. Examples Given some query: {users { email }} If you called this function inside a resolver on the users email field it returns a value like: resolve fn _, _, resolution -&gt; Absinthe.Resolution.path(resolution) #=&gt; [&quot;users&quot;, 5, &quot;email&quot;] end In this case 5 is the 0 based index in the list of users the field is currently at.","ref":"Absinthe.Resolution.html#path/1","title":"Absinthe.Resolution.path/1","type":"function"},{"doc":"","ref":"Absinthe.Resolution.html#path_string/1","title":"Absinthe.Resolution.path_string/1","type":"function"},{"doc":"Get the child fields under the current field. See project/2 for details.","ref":"Absinthe.Resolution.html#project/1","title":"Absinthe.Resolution.project/1","type":"function"},{"doc":"Get the child fields under the current field. Example Given a document like: { user { id name }} field :user, :user do resolve fn _, info -&gt; child_fields = Absinthe.Resolution.project(info) |&gt; Enum.map(&amp;(&amp;1.name)) # ... end end child_fields will be [&quot;id&quot;, &quot;name&quot;]. It correctly handles fragments, so for example if you had the document: { user { ... on User { id } ... on Named { name } } } you would still get a nice and simple child_fields that was [&quot;id&quot;, &quot;name&quot;].","ref":"Absinthe.Resolution.html#project/2","title":"Absinthe.Resolution.project/2","type":"function"},{"doc":"Handy function for applying user function result tuples to a resolution struct User facing functions generally return one of several tuples like {:ok, val} or {:error, reason}. This function handles applying those various tuples to the resolution struct. The resolution state is updated depending on the tuple returned. :ok and :error tuples set the state to :resolved, whereas middleware tuples set it to :unresolved. This is useful for middleware that wants to handle user facing functions, but does not want to duplicate this logic.","ref":"Absinthe.Resolution.html#put_result/2","title":"Absinthe.Resolution.put_result/2","type":"function"},{"doc":"","ref":"Absinthe.Resolution.html#resolver_spec/1","title":"Absinthe.Resolution.resolver_spec/1","type":"function"},{"doc":"","ref":"Absinthe.Resolution.html#result_error/4","title":"Absinthe.Resolution.result_error/4","type":"function"},{"doc":"The arguments that are passed from the schema. (e.g. id of the record to be fetched)","ref":"Absinthe.Resolution.html#t:arguments/0","title":"Absinthe.Resolution.arguments/0","type":"type"},{"doc":"","ref":"Absinthe.Resolution.html#t:field_state/0","title":"Absinthe.Resolution.field_state/0","type":"type"},{"doc":"","ref":"Absinthe.Resolution.html#t:source/0","title":"Absinthe.Resolution.source/0","type":"type"},{"doc":"","ref":"Absinthe.Resolution.html#t:t/0","title":"Absinthe.Resolution.t/0","type":"type"},{"doc":"Introspection support. You can introspect your schema using __schema, __type, and __typename, as described in the specification. Examples Seeing the names of the types in the schema: &quot;&quot;&quot; { __schema { types { name } } } &quot;&quot;&quot; |&gt; Absinthe.run(MyApp.Schema) {:ok, %{data: %{ &quot;__schema&quot; =&gt; %{ &quot;types&quot; =&gt; [ %{&quot;name&quot; =&gt; &quot;Boolean&quot;}, %{&quot;name&quot; =&gt; &quot;Float&quot;}, %{&quot;name&quot; =&gt; &quot;ID&quot;}, %{&quot;name&quot; =&gt; &quot;Int&quot;}, %{&quot;name&quot; =&gt; &quot;String&quot;}, ... ] } }} } Getting the name of the queried type: &quot;&quot;&quot; { profile { name __typename } } &quot;&quot;&quot; |&gt; Absinthe.run(MyApp.Schema) {:ok, %{data: %{ &quot;profile&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;Joe&quot;, &quot;__typename&quot; =&gt; &quot;Person&quot; } }} } Getting the name of the fields for a named type: &quot;&quot;&quot; { __type(name: &quot;Person&quot;) { fields { name type { kind name } } } } &quot;&quot;&quot; |&gt; Absinthe.run(MyApp.Schema) {:ok, %{data: %{ &quot;__type&quot; =&gt; %{ &quot;fields&quot; =&gt; [ %{ &quot;name&quot; =&gt; &quot;name&quot;, &quot;type&quot; =&gt; %{&quot;kind&quot; =&gt; &quot;SCALAR&quot;, &quot;name&quot; =&gt; &quot;String&quot;} }, %{ &quot;name&quot; =&gt; &quot;age&quot;, &quot;type&quot; =&gt; %{&quot;kind&quot; =&gt; &quot;SCALAR&quot;, &quot;name&quot; =&gt; &quot;Int&quot;} }, ] } }} } (Note that you may have to nest several depths of type/ofType, as type information includes any wrapping layers of List and/or NonNull.)","ref":"Absinthe.Introspection.html","title":"Absinthe.Introspection","type":"module"},{"doc":"","ref":"Absinthe.Test.html","title":"Absinthe.Test","type":"module"},{"doc":"Run the introspection query on a schema. In your test_helper.exs file add Absinthe.Test.prime(MyApp.Schema) Explanation In the test environment mix loads code lazily, which means that it isn&#39;t until the first GraphQL query in your test suite runs that Absinthe&#39;s code base is actually loaded. Absinthe is a lot of code, and so this can take several milliseconds. This can be a problem for tests using message passing that expect messages to happen within a certain amount of time. By running the introspection query on your schema this function will cause mix to load the majority of the Absinthe code base.","ref":"Absinthe.Test.html#prime/1","title":"Absinthe.Test.prime/1","type":"function"},{"doc":"Handles logging of Absinthe-specific events. Variable filtering Absinthe can filter out sensitive information like tokens and passwords during logging. They are replaced by &quot;[FILTERED]&quot;. Use the :filter_variables configuration setting for this module. For example: config :absinthe, Absinthe.Logger, filter_variables: [&quot;token&quot;, &quot;password&quot;, &quot;secret&quot;] With the configuration above, Absinthe will filter any variable whose name includes the terms token, password, or secret. The match is case sensitive. Note that filtering only applies to GraphQL variables - the query itself is logged before any parsing happens. The default is [&quot;token&quot;, &quot;password&quot;]. Pipeline display Absinthe can optionally display the list of pipeline phases for each processed document when logging. To enable this feature, set the :pipeline configuration option for this module: config :absinthe, Absinthe.Logger, pipeline: true The default is false. Disabling To disable Absinthe logging, set the :log configuration option to false: config :absinthe, log: false The default is true.","ref":"Absinthe.Logger.html","title":"Absinthe.Logger","type":"module"},{"doc":"Log a document being processed.","ref":"Absinthe.Logger.html#log_run/2","title":"Absinthe.Logger.log_run/2","type":"function"},{"doc":"","ref":"Absinthe.Utils.html","title":"Absinthe.Utils","type":"module"},{"doc":"Camelize a word, respecting underscore prefixes. Examples With an uppercase first letter: iex&gt; camelize(&quot;foo_bar&quot;) &quot;FooBar&quot; iex&gt; camelize(&quot;foo&quot;) &quot;Foo&quot; iex&gt; camelize(&quot;__foo_bar&quot;) &quot;__FooBar&quot; iex&gt; camelize(&quot;__foo&quot;) &quot;__Foo&quot; iex&gt; camelize(&quot;_foo&quot;) &quot;_Foo&quot; With a lowercase first letter: iex&gt; camelize(&quot;foo_bar&quot;, lower: true) &quot;fooBar&quot; iex&gt; camelize(&quot;foo&quot;, lower: true) &quot;foo&quot; iex&gt; camelize(&quot;__foo_bar&quot;, lower: true) &quot;__fooBar&quot; iex&gt; camelize(&quot;__foo&quot;, lower: true) &quot;__foo&quot; iex&gt; camelize(&quot;_foo&quot;, lower: true) &quot;_foo&quot;","ref":"Absinthe.Utils.html#camelize/2","title":"Absinthe.Utils.camelize/2","type":"function"},{"doc":"","ref":"Absinthe.Utils.Suggestion.html","title":"Absinthe.Utils.Suggestion","type":"module"},{"doc":"Sort a list of suggestions by Jaro distance to a target string, supporting a cut-off threshold.","ref":"Absinthe.Utils.Suggestion.html#sort_list/3","title":"Absinthe.Utils.Suggestion.sort_list/3","type":"function"},{"doc":"An error during analysis.","ref":"Absinthe.AnalysisError.html","title":"Absinthe.AnalysisError","type":"exception"},{"doc":"An error during execution.","ref":"Absinthe.ExecutionError.html","title":"Absinthe.ExecutionError","type":"exception"},{"doc":"Exception raised when a schema is invalid","ref":"Absinthe.Schema.Error.html","title":"Absinthe.Schema.Error","type":"exception"},{"doc":"Callback implementation for Exception.message/1.","ref":"Absinthe.Schema.Error.html#message/1","title":"Absinthe.Schema.Error.message/1","type":"function"},{"doc":"Exception raised when a schema is invalid","ref":"Absinthe.Schema.Notation.Error.html","title":"Absinthe.Schema.Notation.Error","type":"exception"},{"doc":"An error during serialization.","ref":"Absinthe.SerializationError.html","title":"Absinthe.SerializationError","type":"exception"},{"doc":"Overview Absinthe is the GraphQL toolkit for Elixir, an implementation of the GraphQL specification built to suit the language&#39;s capabilities and idiomatic style. The Absinthe project consists of several complementary packages. You can find the full listing on the absinthe-graphql GitHub organization page.","ref":"overview.html","title":"Overview","type":"extras"},{"doc":"If you&#39;re new to GraphQL, we suggest you read up a bit on GraphQL&#39;s foundational principles before you dive into Absinthe. Here are a few resources that might be helpful: The official GraphQL website How to GraphQL, which includes a brief tutorial using Absinthe","ref":"overview.html#graphql-basics","title":"Overview - GraphQL Basics","type":"extras"},{"doc":"Absinthe&#39;s functionality generally falls into two broad areas. You can read more about the details in the guides provided as part of this documentation and in the related packages/projects: Defining Schemas. A schema: defines the structure of data entities and the relationships between, as well as the available queries, mutations, and subscriptions, using an elegant collection of declarative macros defines custom scalar types declares any deprecated definitions defines resolution functions to access data, using a flexible and extensible middleware/plugin system Executing Documents. A GraphQL document: can be any standard GraphQL query, mutation, or subscription may include reusable variable definitions can be analyzed for its complexity and be rejected if it&#39;s unsafe/too expensive has a context that you can integrate with authentication and authorization strategies can contain standard GraphQL introspection fields can include multipart file uploads as GraphQL arguments (as part of the absinthe_plug package)","ref":"overview.html#absinthe","title":"Overview - Absinthe","type":"extras"},{"doc":"Absinthe integrates with a number of other important projects, both on the backend and frontend, to provide a better experience for developers. Elixir Support for HTTP APIs using Plug and Phoenix via the absinthe_plug and absinthe_phoenix packages Support for Ecto via the dataloader package JavaScript (client-side) Support for Relay and Apollo Client Support for Absinthe&#39;s channel-based subscriptions. See absinthe-socket.","ref":"overview.html#integrations","title":"Overview - Integrations","type":"extras"},{"doc":"To contribute to the guides, please submit a pull request to the absinthe project on GitHub. You&#39;ll find the content under guides/.","ref":"overview.html#guides","title":"Overview - Guides","type":"extras"},{"doc":"Installation To install Absinthe, just add an entry to your mix.exs: def deps do [ # ... {:absinthe, &quot;~&gt; 1.5&quot;} ] end (Check Hex to make sure you&#39;re using an up-to-date version number.)","ref":"installation.html","title":"Installation","type":"extras"},{"doc":"Because the Absinthe project is made up of a large number of related packages to support integrations with other tools, sometimes you may want to update only part of your absinthe-related dependencies. Don&#39;t forget you can use the :override option for your Mix dependencies if you&#39;d like to ensure a specific package is at a specific version number. For example, If you wanted to try a new version of Absinthe without updating something that depends on it (which is locked to an older version): def deps do [ # ... {:absinthe, &quot;~&gt; 1.5&quot;, override: true} ] end","ref":"installation.html#overriding-dependencies","title":"Installation - Overriding Dependencies","type":"extras"},{"doc":"Most people use Absinthe to support an HTTP API. You&#39;ll want to read the Plug and Phoenix for specific installation and configuration options, including how you can run the handy, included GraphiQL tool directly from your application.","ref":"installation.html#plug-phoenix-and-graphiql","title":"Installation - Plug, Phoenix, and GraphiQL","type":"extras"},{"doc":"Learning The following are some Absinthe-specific educational resources that are available.","ref":"learning.html","title":"Learning","type":"extras"},{"doc":"Craft GraphQL APIs in Elixir with Absinthe by the creators of Absinthe.","ref":"learning.html#books","title":"Learning - Books","type":"extras"},{"doc":"Website (mostly just links elsewhere) Documentation (current stable release) How to GraphQL (with Absinthe)","ref":"learning.html#online-resources","title":"Learning - Online Resources","type":"extras"},{"doc":"Live APIs with GraphQL Subscriptions, ElixirConf 2017 (Bellevue) GraphQL in Practice, ElixirConf EU 2017 (Barcelona)","ref":"learning.html#videos","title":"Learning - Videos","type":"extras"},{"doc":"There&#39;s a ton of GraphQL resources on the web. The official website and How to GraphQL are good places to start.","ref":"learning.html#general-graphql-information","title":"Learning - General GraphQL Information","type":"extras"},{"doc":"Community","ref":"community.html","title":"Community","type":"extras"},{"doc":"Follow the project on Twitter as @absinthegraphql for news and additional resources.","ref":"community.html#twitter","title":"Community - Twitter","type":"extras"},{"doc":"You can find the maintainers and an active community of users and contributors in the #absinthe-graphql channel in the Elixir Slack.","ref":"community.html#chat","title":"Community - Chat","type":"extras"},{"doc":"Questions and suggestions can be submitted on the Elixir Forum. Please categorize/tag as Absinthe.","ref":"community.html#forum","title":"Community - Forum","type":"extras"},{"doc":"Getting Started We&#39;ll be building a very basic GraphQL API for a blog, written in Elixir using Absinthe.","ref":"start.html","title":"Getting Started","type":"extras"},{"doc":"Before you start, it&#39;s a good idea to have some background into GraphQL in general. Here are a few resources that might be helpful: The official GraphQL website How to GraphQL (this includes another brief tutorial using Absinthe)","ref":"start.html#background","title":"Getting Started - Background","type":"extras"},{"doc":"The tutorial expects you to have a properly set-up Phoenix application with absinthe and absinthe_plug added to the dependencies. If you&#39;d like to cheat, you can find the finished code for the tutorial in the Absinthe Example project on GitHub.","ref":"start.html#the-example","title":"Getting Started - The Example","type":"extras"},{"doc":"Let&#39;s get started with our first query!","ref":"start.html#first-step","title":"Getting Started - First Step","type":"extras"},{"doc":"Our First Query The first thing our viewers want is a list of our blog posts, so that&#39;s what we&#39;re going to give them. Here&#39;s the query we want to support: { posts { title body } } To do this we&#39;re going to need a schema. Let&#39;s create some basic types for our schema, starting with a :post. GraphQL has several fundamental types on top of which all of our types will be built. The Object type is the right one to use when representing a set of key value pairs. Since our Post Ecto schema lives in the Blog.Content Phoenix context, we&#39;ll define its GraphQL counterpart type, :post, in a matching BlogWeb.Schema.ContentTypes module: In blog_web/schema/content_types.ex: defmodule BlogWeb.Schema.ContentTypes do use Absinthe.Schema.Notation object :post do field :id, :id field :title, :string field :body, :string end end The GraphQL specification requires that type names be unique, TitleCased words. Absinthe does this automatically for us, extrapolating from our type identifier (in this case :post gives us &quot;Post&quot;. If really needed, we could provide a custom type name as a :name option to the object macro. If you&#39;re curious what the type :id is used by the :id field, see the GraphQL spec. It&#39;s an opaque value, and in our case is just the regular Ecto id, but serialized as a string. With our type completed we can now write a basic schema that will let us query a set of posts. In blog_web/schema.ex: defmodule BlogWeb.Schema do use Absinthe.Schema import_types BlogWeb.Schema.ContentTypes alias BlogWeb.Resolvers query do @desc &quot;Get all posts&quot; field :posts, list_of(:post) do resolve &amp;Resolvers.Content.list_posts/3 end end end For more information on the macros available to build a schema, see their definitions in Absinthe.Schema and Absinthe.Schema.Notation. This uses a resolver module we&#39;ve created (again, to match the Phoenix context naming) at blog_web/resolvers/content.ex: defmodule BlogWeb.Resolvers.Content do def list_posts(_parent, _args, _resolution) do {:ok, Blog.Content.list_posts()} end end Queries are defined as fields inside the GraphQL object returned by our query function. We created a posts query that has a type list_of(:post) and is resolved by our BlogWeb.Resolvers.Content.list_posts/3 function. Later we&#39;ll talk more about the resolver function parameters; for now just remember that resolver functions can take two forms: A function with an arity of 3 (taking a parent, arguments, and resolution struct) An alternate, short form with an arity of 2 (omitting the first parameter, the parent) The job of the resolver function is to return the data for the requested field. Our resolver calls out to the Blog.Content module, which is where all the domain logic for posts lives, invoking its list_posts/0 function, then returns the posts in an :ok tuple. Resolvers can return a wide variety of results, to include errors and configuration for advanced plugins that further process the data. If you&#39;re asking yourself what the implementation of the domain logic looks like, and exactly how the related Ecto schemas are built, read through the code in the absinthe_tutorial repository. The tutorial content here is intentionally focused on the Absinthe-specific code. Now that we have the functional pieces in place, let&#39;s configure our Phoenix router to wire this into HTTP: In blog_web/router.ex: defmodule BlogWeb.Router do use BlogWeb, :router pipeline :api do plug :accepts, [&quot;json&quot;] end scope &quot;/api&quot; do pipe_through :api forward &quot;/graphiql&quot;, Absinthe.Plug.GraphiQL, schema: BlogWeb.Schema forward &quot;/&quot;, Absinthe.Plug, schema: BlogWeb.Schema end end In addition to our API, we&#39;ve wired in a handy GraphiQL user interface to play with it. Absinthe integrates both the classic GraphiQL and more advanced GraphiQL Workspace interfaces as part of the absinthe_plug package. Now let&#39;s check to make sure everything is working. Start the server: $ mix phx.server Absinthe does a number of sanity checks during compilation, so if you misspell a type or make another schema-related gaffe, you&#39;ll be notified. Once it&#39;s up-and-running, take a look at http://localhost:4000/api/graphiql: Make sure that the URL is pointing to the correct place and press the play button. If everything goes according to plan, you should see something like this:","ref":"our-first-query.html","title":"Our First Query","type":"extras"},{"doc":"Now let&#39;s look at how we can add arguments to our queries.","ref":"our-first-query.html#next-step","title":"Our First Query - Next Step","type":"extras"},{"doc":"Query Arguments Our GraphQL API would be pretty boring (and useless) if clients couldn&#39;t retrieve filtered data. Let&#39;s assume that our API needs to add the ability to look-up users by their ID and get the posts that they&#39;ve authored. Here&#39;s what a basic query to do that might look like: { user(id: &quot;1&quot;) { name posts { id title } } } The query includes a field argument, id, contained within the parentheses after the user field name. To make this all work, we need to modify our schema a bit.","ref":"query-arguments.html","title":"Query Arguments","type":"extras"},{"doc":"First, let&#39;s create a :user type and define its relationship to :post while we&#39;re at it. We&#39;ll create a new module for the account-related types and put it there; in blog_web/schema/account_types.ex: defmodule BlogWeb.Schema.AccountTypes do use Absinthe.Schema.Notation @desc &quot;A user of the blog&quot; object :user do field :id, :id field :name, :string field :email, :string field :posts, list_of(:post) end end The :posts field points to a list of :post results. (This matches up with what we have on the Ecto side, where Blog.Accounts.User defines a has_many association with Blog.Content.Post.) We&#39;ve already defined the :post type, but let&#39;s go ahead and add an :author field that points back to our :user type. In blog_web/schema/content_types.ex: object :post do # post fields we defined earlier... field :author, :user end Now let&#39;s add the :user field to our query root object in our schema, defining a mandatory :id argument and using the Resolvers.Accounts.find_user/3 resolver function. We also need to make sure we import the types from BlogWeb.Schema.AccountTypes so that :user is available. In blog_web/schema.ex: defmodule BlogWeb.Schema do use Absinthe.Schema import_types Absinthe.Type.Custom # Add this `import_types`: import_types BlogWeb.Schema.AccountTypes import_types BlogWeb.Schema.ContentTypes alias BlogWeb.Resolvers query do @desc &quot;Get all posts&quot; field :posts, list_of(:post) do resolve &amp;Resolvers.Content.list_posts/3 end # Add this field: @desc &quot;Get a user of the blog&quot; field :user, :user do arg :id, non_null(:id) resolve &amp;Resolvers.Accounts.find_user/3 end end end Now lets use the argument in our resolver. In blog_web/resolvers/accounts.ex: defmodule BlogWeb.Resolvers.Accounts do def find_user(_parent, %{id: id}, _resolution) do case Blog.Accounts.find_user(id) do nil -&gt; {:error, &quot;User ID \#{id} not found&quot;} user -&gt; {:ok, user} end end end Our schema marks the :id argument as non_null, so we can be certain we will receive it. If :id is left out of the query, Absinthe will return an informative error to the user, and the resolve function will not be called. If you have experience writing Phoenix controller actions, you might wonder why we can match incoming arguments with atoms instead of having to use strings. The answer is simple: you&#39;ve defined the arguments in the schema using atom identifiers, so Absinthe knows what arguments will be used ahead of time, and will coerce as appropriate---culling any extraneous arguments given to a query. This means that all arguments can be supplied to the resolve functions with atom keys. Finally you&#39;ll see that we can handle the possibility that the query, while valid from GraphQL&#39;s perspective, may still ask for a user that does not exist. We&#39;ve decided to return an error in that case. There&#39;s a valid argument for just returning {:ok, nil} when a record can&#39;t be found. Whether the absence of data constitutes an error is a decision you get to make.","ref":"query-arguments.html#defining-arguments","title":"Query Arguments - Defining Arguments","type":"extras"},{"doc":"Let&#39;s assume we want to query all posts from a user published within a given time range. First, let&#39;s add a new field to our :post object type, :published_at. The GraphQL specification doesn&#39;t define any official date or time types, but it does support custom scalar types (you can read more about them in the related guide, and Absinthe ships with several built-in scalar types. We&#39;ll use :naive_datetime (which doesn&#39;t include timezone information) here. Edit blog_web/schema/content_types.ex: defmodule BlogWeb.Schema.ContentTypes do use Absinthe.Schema.Notation @desc &quot;A blog post&quot; object :post do field :id, :id field :title, :string field :body, :string field :author, :user # Add this: field :published_at, :naive_datetime end end To make the :naive_datetime type available, add an import_types line to your blog_web/schema.ex: import_types Absinthe.Type.Custom For more information about how types are imported, read the guide on the topic. For now, just remember that import_types should only be used in top-level schema module. (Think of it like a manifest.) Here&#39;s the query we&#39;d like to be able to use, getting the posts for a user on a given date: { user(id: &quot;1&quot;) { name posts(date: &quot;2017-01-01&quot;) { title body publishedAt } } } To use the passed date, we need to update our :user object type and make some changes to its :posts field; it needs to support a :date argument and use a custom resolver. In blog_web/schema/account_types.ex: defmodule BlogWeb.Schema.AccountTypes do use Absinthe.Schema.Notation alias BlogWeb.Resolvers object :user do field :id, :id field :name, :string field :email, :string # Add the block here: field :posts, list_of(:post) do arg :date, :date resolve &amp;Resolvers.Content.list_posts/3 end end end For the resolver, we&#39;ve added another function head to Resolvers.Content.list_posts/3. This illustrates how you can use the first argument to a resolver to match the parent object of a field. In this case, that parent object would be a Blog.Accounts.User Ecto schema: # Add this: def list_posts(%Blog.Accounts.User{} = author, args, _resolution) do {:ok, Blog.Content.list_posts(author, args)} end # Before this: def list_posts(_parent, _args, _resolution) do {:ok, Blog.Content.list_posts()} end Here we pass on the user and arguments to the domain logic function, Blog.Content.list_posts/3, which will find the posts for the user and date (if it&#39;s provided; the :date argument is optional). The resolver, just as when it&#39;s used for the top level query :posts, returns the posts in an :ok tuple. Check out the full implementation of logic for Blog.Content.list_posts/3--and some simple seed data--in the absinthe_tutorial repository. If you&#39;ve done everything correctly (and have some data handy), if you start up your server with mix phx.server and head over to http://localhost:4000/api/graphiql, you should be able to play with the query. It should look something like this:","ref":"query-arguments.html#arguments-and-non-root-fields","title":"Query Arguments - Arguments and Non-Root Fields","type":"extras"},{"doc":"Next up, we look at how to modify our data using mutations.","ref":"query-arguments.html#next-step","title":"Query Arguments - Next Step","type":"extras"},{"doc":"Mutations A blog is no good without new content. We want to support a mutation to create a blog post: mutation CreatePost { createPost(title: &quot;Second&quot;, body: &quot;We&#39;re off to a great start!&quot;) { id } } Now we just need to define a mutation portion of our schema and a :create_post field: In blog_web/schema.ex: mutation do @desc &quot;Create a post&quot; field :create_post, type: :post do arg :title, non_null(:string) arg :body, non_null(:string) arg :published_at, :naive_datetime resolve &amp;Resolvers.Content.create_post/3 end end The resolver in this case is responsible for making any changes and returning an {:ok, post} tuple matching the :post type we defined earlier: In our blog_web/resolvers/content.ex module, we&#39;ll add the create_post/3 resolver function: def create_post(_parent, args, %{context: %{current_user: user}}) do Blog.Content.create_post(user, args) end def create_post(_parent, _args, _resolution) do {:error, &quot;Access denied&quot;} end Obviously things can go wrong in a mutation. To learn more about the types of error results that Absinthe supports, read the guide.","ref":"mutations.html","title":"Mutations","type":"extras"},{"doc":"This resolver adds a new concept: authorization. The resolution struct (that is, an Absinthe.Resolution) passed to the resolver as the third argument carries along with it the Absinthe context, a data structure that serves as the integration point with external mechanisms---like a Plug that authenticates the current user. You can learn more about how the context can be used in the Context and Authentication guide. Going back to the resolver code: If the match for a current user is successful, the underlying Blog.Content.create_post/2 function is invoked. It will return a tuple suitable for return. (To read the Ecto-related nitty gritty, check out the absinthe_tutorial repository.) If the match for a current user isn&#39;t successful, the fall-through match will return an error indicating that a post can&#39;t be created.","ref":"mutations.html#authorization","title":"Mutations - Authorization","type":"extras"},{"doc":"Now let&#39;s take a look at more complex arguments.","ref":"mutations.html#next-step","title":"Mutations - Next Step","type":"extras"},{"doc":"Complex Arguments In preparation for supporting comments on our blog, let&#39;s create users. We&#39;re building a modern mobile first blog of course, and thus want to support either a phone number or an email as the contact method for a user. We want to support the following mutations. Support creation of a user with their email address: mutation CreateEmailUser { createUser(contact: {type: EMAIL, value: &quot;foo@bar.com&quot;}, name: &quot;Jane&quot;, password: &quot;hunter1&quot;) { id contacts { type value } } } And by using their phone number: mutation CreatePhoneUser { createUser(contact: {type: PHONE, value: &quot;+1 123 5551212&quot;}, name: &quot;Joe&quot;, password: &quot;hunter2&quot;) { id contacts { type value } } } To do this we need the ability to create nested arguments. GraphQL has input objects for this purpose. Input objects, like regular object, contain key value pairs, but they are intended for input only (you can&#39;t do circular references with them for example). Another notion we&#39;ll look at here is an enumerable type. We only want to support contact types &quot;email&quot; and &quot;phone&quot; at the moment, and GraphQL gives us the ability to specify this in our schema. Let&#39;s start with our :contact_type Enum. In blog_web/schema/account_types.ex: enum :contact_type do value :phone, as: &quot;phone&quot; value :email, as: &quot;email&quot; end We&#39;re using the :as option here to make sure the parsed enum is represented by a string when it&#39;s passed to our controllers; this is to ease integration with our Ecto schema (by default, the enum values are passed as atoms). The standard convention for representing incoming enum values in GraphQL documents are in all caps. For instance, given our settings here, the accepted values would be PHONE and EMAIL (without quotes). See the GraphQL document examples above for examples. While the enum macro supports configuring this incoming format, we highly recommend you just use the GraphQL convention. Now if a user tries to send some other kind of contact type they&#39;ll get a nice error without any extra effort on your part. Enum types are not a substitute for modeling layer validations however, be sure to still enforce things like this on that layer too. Now for our contact input object. In blog_web/schema/account_types.ex: input_object :contact_input do field :type, non_null(:contact_type) field :value, non_null(:string) end Note that we name this type :contact_input. Input object types have their own names, and the _input suffix is common. Important: It&#39;s very important to remember that only input types---basically scalars and input objects---can be used to model input. Finally our schema, in blog_web/schema.ex: mutation do #... other mutations @desc &quot;Create a user&quot; field :create_user, :user do arg :name, non_null(:string) arg :contact, non_null(:contact_input) arg :password, non_null(:string) resolve &amp;Resolvers.Accounts.create_user/3 end end Suppose in our database that we store contact information in a different database table. Our mutation would be used to create both records in this case. There does not need to be a one to one correspondence between how data is structured in your underlying data store and how things are presented by your GraphQL API. Our resolver, blog_web/resolvers/accounts.ex might look something like this: def create_user(_parent, args, %{context: %{current_user: %{admin: true}}}) do Blog.Accounts.create_user(args) end def create_user(_parent, args, _resolution) do {:error, &quot;Access denied&quot;} end You&#39;ll notice we&#39;re checking for :current_user again in our Absinthe context, just as we did before for posts. In this case we&#39;re taking the authorization check a step further and verifying that only administrators (in this simple example, an administrator is a user account with :admin set to true) can create a user. Everyone else gets an &quot;Access denied&quot; error for this field. To see the Ecto-related implementation of the Blog.Accounts.create_user/1 function and the (stubbed) authentication logic we&#39;re using for this example, see the absinthe_tutorial repository. Here&#39;s our mutation in action in GraphiQL. Note we&#39;re sending a Authorization header to authenticate, which a plug is handling. Make sure to read the related guide for more information on how to set-up authentication in your own applications. Our simple tutorial application is just using a simple stub: any authorization token logs you in the first user. Obviously not what you want in production!","ref":"complex-arguments.html","title":"Complex Arguments","type":"extras"},{"doc":"Now let&#39;s wrap things up.","ref":"complex-arguments.html#next-step","title":"Complex Arguments - Next Step","type":"extras"},{"doc":"Conclusion With this we have a basic GraphQL based API for a blog. Head on over to the github page if you want the final code. We hope to expand this tutorial to include a comment system that will acquaint you with Union types and Fragments in the coming days. Head on over to the topic guides for further reading, and see the community page for information on how to get help, ask questions, or contribute!","ref":"conclusion.html","title":"Conclusion","type":"extras"},{"doc":"This tutorial is a work in progress, and while it covers the basics of using Absinthe, there is plenty more that can be added and improved upon. It&#39;s important that it&#39;s kept up-to-date, too, so if you notice something that&#39;s slipped by us, please help us fix it! Please contribute your GitHub issues (and pull requests!): The tutorial text is under guides/tutorial in the absinthe repository. It&#39;s in Markdown and easy to edit! The tutorial code located in the absinthe_tutorial repository.","ref":"conclusion.html#please-help","title":"Conclusion - Please Help!","type":"extras"},{"doc":"Writing Schemas A GraphQL API starts by building a schema. Using Absinthe, schemas are normal modules that use Absinthe.Schema. Here&#39;s a schema that supports looking up an item by ID: # filename: myapp/schema.ex defmodule MyAppWeb.Schema do use Absinthe.Schema # Example data @items %{ &quot;foo&quot; =&gt; %{id: &quot;foo&quot;, name: &quot;Foo&quot;}, &quot;bar&quot; =&gt; %{id: &quot;bar&quot;, name: &quot;Bar&quot;} } query do field :item, :item do arg :id, non_null(:id) resolve fn %{id: item_id}, _ -&gt; {:ok, @items[item_id]} end end end end You may want to refer to the Absinthe API documentation for more detailed information as you look this over.. Some macros and functions used here that are worth mentioning, pulled in automatically from Absinthe.Schema.Notation by use Absinthe.Schema: query - Defines the root query object. It&#39;s like using object but with nice defaults. There is a matching mutation macro as well. field - Defines a field in the enclosing object, input_object, or interface. arg - Defines an argument in the enclosing field or directive. resolve - Sets the resolve function for the enclosing field. You&#39;ll notice we mention some types being referenced: :item and :id. :id is a built-in scalar type (like :string, :boolean, and others), but :item we need to define ourselves. We can do it in the same MyAppWeb.Schema module, using the object macro defined by Absinthe.Schema.Notation: # filename: myapp/schema.ex @desc &quot;An item&quot; object :item do field :id, :id field :name, :string end Now you can use Absinthe to execute a query document. Keep in mind that for HTTP, you&#39;ll probably want to use Absinthe.Plug instead of executing GraphQL query documents yourself. Absinthe doesn&#39;t know or care about HTTP, but the absinthe_plug project does: it handles the vagaries of interacting with HTTP GraphQL clients so you don&#39;t have to. If you were executing query documents yourself (let&#39;s assume for a local tool), it would go something like this: &quot;&quot;&quot; { item(id: &quot;foo&quot;) { name } } &quot;&quot;&quot; |&gt; Absinthe.run(MyAppWeb.Schema) # Result {:ok, %{data: %{&quot;item&quot; =&gt; %{&quot;name&quot; =&gt; &quot;Foo&quot;}}}} Your schemas can be further customized using the options available to Absinthe.Schema.Notation.field/4 to help provide for a richer experience for your users, customize the field names, or mark fields as deprecated. # filename: myapp/language_schema.ex @desc &quot;A Language&quot; object :language do field :id, :id field :iso_639_1, :string, description: &quot;2 character ISO 639-1 code&quot;, name: &quot;iso639&quot; field :name, :string, description: &quot;English name of the language&quot; end","ref":"schemas.html","title":"Writing Schemas","type":"extras"},{"doc":"We could also move our type definitions out into a different module, for instance, MyAppWeb.Schema.Types, and then use import_types in our MyAppWeb.Schema: # filename: myapp/schema/types.ex defmodule MyAppWeb.Schema.Types do use Absinthe.Schema.Notation object :item do field :id, :id field :name, :string end # ... end # filename: myapp/schema.ex defmodule MyAppWeb.Schema do use Absinthe.Schema import_types MyAppWeb.Schema.Types # ... end It&#39;s a nice way of separating the top-level query and mutation information, which define the surface area of the API, with the actual types that it uses. See Importing Types for a full guide to importing types.","ref":"schemas.html#importing-types","title":"Writing Schemas - Importing Types","type":"extras"},{"doc":"Plug and Phoenix Setup First, install Absinthe.Plug and a JSON codec of your choice, eg, Jason: # filename: mix.exs def deps do [ {:absinthe_plug, &quot;~&gt; 1.5&quot;}, {:jason, &quot;~&gt; 1.0&quot;}, ] end","ref":"plug-phoenix.html","title":"Plug and Phoenix Setup","type":"extras"},{"doc":"To use, simply plug Absinthe.Plug in your pipeline. plug Absinthe.Plug, schema: MyAppWeb.Schema If you are going to support content types other than simply application/graphql you should plug Absinthe.Plug after Plug.Parsers. plug Plug.Parsers, parsers: [:urlencoded, :multipart, :json, Absinthe.Plug.Parser], json_decoder: Jason plug Absinthe.Plug, schema: MyAppWeb.Schema For more information on how the content types work, see General Usage.","ref":"plug-phoenix.html#plug","title":"Plug and Phoenix Setup - Plug","type":"extras"},{"doc":"If your entire API is going to be based on GraphQL, we recommend simply plugging Absinthe.Plug in at the bottom of your endpoint, and removing your router altogether. defmodule MyApp.Endpoint do use Phoenix.Endpoint, otp_app: :my_app plug Plug.RequestId plug Plug.Logger plug Plug.Parsers, parsers: [:urlencoded, :multipart, :json], pass: [&quot;*/*&quot;], json_decoder: Jason plug Absinthe.Plug, schema: MyAppWeb.Schema end If you want only Absinthe.Plug to serve a particular route, configure your router like: defmodule MyAppWeb.Router do use Phoenix.Router resource &quot;/pages&quot;, MyAppWeb.PagesController forward &quot;/api&quot;, Absinthe.Plug, schema: MyAppWeb.Schema end Now Absinthe.Plug will only serve GraphQL from the /api url.","ref":"plug-phoenix.html#phoenix","title":"Plug and Phoenix Setup - Phoenix","type":"extras"},{"doc":"Absinthe.Plug will pass any values found inside conn.private[:absinthe][:context] on to Absinthe.run as the context. This is how you should handle logic that uses headers -- most notably, Authentication. For more information, see the Context guide.","ref":"plug-phoenix.html#absinthe-context","title":"Plug and Phoenix Setup - Absinthe Context","type":"extras"},{"doc":"See the absinthe_plug project and the GraphiQL portion of the Introspection guide to learn how to use the built-in Absinthe.Plug.GraphiQL plug.","ref":"plug-phoenix.html#graphiql","title":"Plug and Phoenix Setup - GraphiQL","type":"extras"},{"doc":"This plug supports requests in a number of ways: Via a GET With a query string: ?query=query+GetItem($id:ID!){item(id:$id){name}}&amp;variables={id:&quot;foo&quot;} Due to varying limits on the maximum size of URLs, we recommend using one of the POST options below instead, putting the query into the body of the request. Via an application/json POST With a POST body: { &quot;query&quot;: &quot;query GetItem($id: ID!) { item(id: $id) { name } }&quot;, &quot;variables&quot;: { &quot;id&quot;: &quot;foo&quot; } } (We could also pull either query or variables out to the query string, just as in the GET example.) Via an application/graphql POST With a query string: ?variables={id:&quot;foo&quot;} And a POST body: query GetItem($id: ID!) { item(id: $id) { name } } HTTP API How clients interact with the plug over HTTP is designed to closely match that of the official express-graphql middleware. In the example above, we went over the various ways to make a request, but here are the details: Once installed at a path, the plug will accept requests with the following parameters: query - A string GraphQL document to be executed. variables - The runtime values to use for any GraphQL query variables as a JSON object. operationName - If the provided query contains multiple named operations, this specifies which operation should be executed. If not provided, a 400 error will be returned if the query contains multiple named operations. The plug will first look for each parameter in the query string, eg: /graphql?query=query+getUser($id:ID){user(id:$id){name}}&amp;variables={&quot;id&quot;:&quot;4&quot;} If not found in the query string, it will look in the POST request body, using a strategy based on the Content-Type header. For content types application/json and application/x-www-form-urlencoded, configure Plug.Parsers (or equivalent) to parse the request body before Absinthe.Plug, eg: plug Plug.Parsers, parsers: [:urlencoded, :multipart, :json], pass: [&quot;*/*&quot;], json_decoder: Jason For application/graphql, the POST body will be parsed as GraphQL query string, which provides the query parameter. If variables or operationName are needed, they should be passed as part of the","ref":"plug-phoenix.html#general-usage","title":"Plug and Phoenix Setup - General Usage","type":"extras"},{"doc":"As a plug, Absinthe.Plug requires very little configuration. If you want to support application/x-www-form-urlencoded or application/json you&#39;ll need to plug Plug.Parsers first. plug Plug.Parsers, parsers: [:urlencoded, :multipart, :json], pass: [&quot;*/*&quot;], json_decoder: Jason plug Absinthe.Plug, schema: MyApp.Linen.Schema Absinthe.Plug requires a schema: config. It also takes several options. See the documentation for the full listing.","ref":"plug-phoenix.html#configuration-notes","title":"Plug and Phoenix Setup - Configuration Notes","type":"extras"},{"doc":"You can use GraphQL as the datasource for your Phoenix controllers. For this you&#39;ll need to add absinthe_phoenix to your dependencies. See Absinthe Phoenix for installation instructions. @graphql &quot;&quot;&quot; query ($filter: UserFilter) { users(filter: $filter, limit: 10) } &quot;&quot;&quot; def index(conn, %{data: data}) do render conn, &quot;index.html&quot;, data end The results of the query are now available in the &quot;index.html&quot; template. For more information, see Absinthe.Phoenix.Controller","ref":"plug-phoenix.html#inside-phoenix-controllers","title":"Plug and Phoenix Setup - Inside Phoenix controllers","type":"extras"},{"doc":"Writing Middleware and Plugins Middleware enables custom resolution behaviour on a field. You can use them to share common logic that needs to happen before or after resolving fields. Things like authentication and error handling.","ref":"middleware-and-plugins.html","title":"Writing Middleware and Plugins","type":"extras"},{"doc":"In order to create a Middleware you need a module that implements Absinthe.Middleware behaviour . Your module needs to have a call/2 method which receives an %Absinthe.Resolution{} struct and some options as its parameters, and then returns a possibly altered resolution struct. Here is an example of a middleware that handle Ecto.Changeset errors and makes sure we properly add error message to the errors in the response. defmodule MyApp.Middlewares.HandleChangesetErrors do @behaviour Absinthe.Middleware def call(resolution, _) do %{resolution | errors: Enum.flat_map(resolution.errors, &amp;handle_error/1) } end defp handle_error(%Ecto.Changeset{} = changeset) do changeset |&gt; Ecto.Changeset.traverse_errors(fn {err, _opts} -&gt; err end) |&gt; Enum.map(fn({k,v}) -&gt; &quot;\#{k}: \#{v}&quot; end) end defp handle_error(error), do: [error] end The resolution struct has all kinds of useful values inside of it. You can access the Absinthe context, the root value, information about the current field&#39;s AST, and more. For more information on how the current user ends up in the context please see our full authentication guide.","ref":"middleware-and-plugins.html#create-a-middleware","title":"Writing Middleware and Plugins - Create a Middleware","type":"extras"},{"doc":"Middleware can be placed on a field in few different ways: 1. Using the Absinthe.Schema.Notation.middleware/2 macro used inside a field definition This option is good when you want to add your middleware on few specific fields. You can use middleware to add multiple Middlewares before or after resolve. In this example MyApp.Web.Authentication would run before resolution, and HandleError would run after. field :hello, :string do middleware MyApp.Web.Authentication resolve &amp;get_the_string/2 middleware HandleError, :foo end 2. Using the middleware/3 callback in your schema. This option is good if you want to add your middleware on all or a group of fields based on the type of query. middleware/3 is a function callback on a schema. When you use Absinthe.Schema a default implementation of this function is placed in your schema. It is passed the existing middleware for a field, the field itself, and the object that the field is a part of. You can override this callback to add your Middleware in the list of existing middlewares. In this example we add our HandleChangesetError Middleware only to mutations. # add this to your schema module # if it&#39;s a field for the mutation object, add this middleware to the end def middleware(middleware, _field, %{identifier: :mutation}) do middleware ++ [MyApp.Middlewares.HandleChangesetErrors] end # if it&#39;s any other object keep things as is def middleware(middleware, _field, _object), do: middleware 3. Returning a {:middleware, middleware_spec, config} tuple from a resolution function. You can update your resolution function to return {:middleware, MyApp.Middlewares.HandleChangesetErrors, config}, note that in this case the middleware can only be applied after the resolution.","ref":"middleware-and-plugins.html#using-middlewares","title":"Writing Middleware and Plugins - Using Middlewares","type":"extras"},{"doc":"Returning Errors This guide could use some improvement. You can help! Please fork the absinthe repository, edit guides/errors.md, and submit a pull request. One or more errors for a field can be returned in a single {:error, error_value} tuple. error_value can be: A simple error message string. A map containing :message key, plus any additional serializable metadata. A keyword list containing a :message key, plus any additional serializable metadata. A list containing multiple of any/all of these. Any other value compatible with to_string/1.","ref":"errors.html","title":"Returning Errors","type":"extras"},{"doc":"A simple error message: {:error, &quot;Something bad happened&quot;} Multiple error messages: {:error, [&quot;Something bad&quot;, &quot;Even worse&quot;]} Single custom errors (note the required :message keys): {:error, message: &quot;Unknown user&quot;, code: 21} {:error, %{message: &quot;A database error occurred&quot;, details: format_db_error(some_value)}} Three errors of mixed types: {:error, [&quot;Simple message&quot;, [message: &quot;A keyword list error&quot;, code: 1], %{message: &quot;A map error&quot;}]} Generic handler for interoperability with errors from other libraries: {:error, :foo} {:error, 1.0} {:error, 2}","ref":"errors.html#basic-errors","title":"Returning Errors - Basic Errors","type":"extras"},{"doc":"You may want to look at the Absinthe ErrorPayload package.","ref":"errors.html#ecto-changeset-errors","title":"Returning Errors - Ecto.Changeset Errors","type":"extras"},{"doc":"Batching Resolution","ref":"batching.html","title":"Batching Resolution","type":"extras"},{"doc":"In general, you want to make sure that when accessing Ecto associations that you preload the data in the top level resolver functions to avoid N+1 queries. Imagine this scenario: You have posts and users. A Post has an author field, which returns a user. You want to list all posts, and get the name of their author: { posts { author { name } } } If you write your schema like this, you&#39;re going to have a bad time due to issues with N + 1: object :post do @desc &quot;Author of the post&quot; field :author, :user do resolve fn post, _, _ -&gt; author = post |&gt; Ecto.assoc(:author) |&gt; Repo.one {:ok, author} end end end query do field :posts, list_of(:post) do resolve fn _, _ -&gt; {:ok, Post |&gt; Repo.all} end end end What this schema will do when presented with the GraphQL query is run Post |&gt; Repo.all, which will retrieve N posts. Then for each post it will resolve child fields, which runs our Repo.one query function, resulting in N+1 calls to the database. One way to handle this issue is with Absinthe&#39;s support for batching. The idea with batching is that we&#39;re gonna aggregate all the author_ids from each post, and then make one call to the user. Let&#39;s first make a function to get a model by ids: defmodule MyAppWeb.Schema.Helpers do def by_id(model, ids) do import Ecto.Query ids = ids |&gt; Enum.uniq model |&gt; where([m], m.id in ^ids) |&gt; Repo.all |&gt; Map.new(&amp;{&amp;1.id, &amp;1}) end end Now we can use this function to batch our author lookups: object :post do @desc &quot;Author of the post&quot; field :author, :user do resolve fn post, _, _ -&gt; batch({MyAppWeb.Schema.Helpers, :by_id, User}, post.author_id, fn batch_results -&gt; {:ok, Map.get(batch_results, post.author_id)} end) end end end Now we make just two calls to the database. The first call loads all of the posts. Then as Absinthe walks through each post and tries to get the author, it&#39;s instead told to aggregate its information. That aggregate information is passed on to our by_id/2 function from earlier. It grabs ALL the users in just one database call, and creates a map of user ids to users. Absinthe then does a second pass and calls the batch_results function with that map, letting us retrieve the individual author for each post. Not only is this a very efficient way to query the data, it&#39;s also 100% dynamic. If a query document asks for authors, they&#39;re loaded efficiently. If it does not, they aren&#39;t loaded at all. See the documentation for Absinthe.Middleware.Batch for more information. Absinthe.Middleware.Batch achieves a lot and, with some helpers, was the standard way to solve this problem for a long time. While batching still has a place, it has a few limitations that have driven the development of Dataloader. There are small scale annoyances like the limitation of only being able to batch one thing at a time in a field, or the fact that the API can get very verbose. There&#39;s also some larger scale issues however. Ecto has a fair number of quirks that make it a difficult library to abstract access to. If you want the concurrent test system to work, you need to add self() to all the batch keys and do Repo.all(caller: pid) in every batch function so that it knows which sandbox to use. It gets very easy for your GraphQL functions to become full of direct database access, inevitably going around important data access rules you may want to enforce in your contexts. Alternatively, your context functions can end up with dozens of little functions that only exist to support batching items by ID. In time, people involved in larger projects have been able to build some abstractions, helpers, and conventions around the Absinthe.Middleware.Batch plugin that have done a good job of addressing these issues. That effort has been extracted into the Dataloader project, which also draws inspiration from similar projects in the GraphQL world. We&#39;ve made it easier and more flexible, however, with Elixir&#39;s dataloader package. Dataloader Let&#39;s jump straight in to getting Dataloader working, and then we&#39;ll expand on what&#39;s actually happening behind the scenes. Using Dataloader is as simple as doing: alias MyApp.Blog # Dataloader source, see below import Absinthe.Resolution.Helpers, only: [dataloader: 1] object :post do field :posts, list_of(:post), resolve: dataloader(Blog) @desc &quot;Author of the post&quot; field :author, :user, do resolve dataloader(Blog) end end To make this work we need to setup a dataloader, add the Blog source to it, and make sure our schema knows it needs to run the dataloader. Latest install instructions found here: https://github.com/absinthe-graphql/dataloader Let&#39;s start with a data source. Dataloader data sources are just structs that encode a way of retrieving data in batches. In a Phoenix application you&#39;ll generally have one source per context, so that each context can control how its data is loaded. Here is a hypothetical Blog context and a dataloader ecto source: defmodule MyApp.Blog do def data() do Dataloader.Ecto.new(MyApp.Repo, query: &amp;query/2) end def query(queryable, _params) do queryable end end When integrating Dataloader with GraphQL, we want to place it in our context so that we can access it in our resolvers. In your schema module add: alias MyApp.{Blog} def context(ctx) do loader = Dataloader.new |&gt; Dataloader.add_source(Blog, Blog.data()) Map.put(ctx, :loader, loader) end def plugins do [Absinthe.Middleware.Dataloader] ++ Absinthe.Plugin.defaults() end That&#39;s it! If you run a GraphQL query that hits that field, it will be loaded efficiently without N+1. See the documentation for Dataloader for more information. Deprecated in v1.4: Batching with Absinthe.Ecto The batching helper functions present in absinthe_ecto provided some early support for making it easy to get data from Ecto. These batching features are considered DEPRECATED in favor of Dataloader, described above. If you&#39;re on 1.4 or earlier absinthe version feel free to check the documentation about absinthe_ecto basic usage.","ref":"batching.html#avoiding-n-1-queries","title":"Batching Resolution - Avoiding N+1 Queries","type":"extras"},{"doc":"Dataloader Dataloader provides an easy way efficiently load data in batches. It&#39;s inspired by https://github.com/facebook/dataloader","ref":"dataloader.html","title":"Dataloader","type":"extras"},{"doc":"def deps do [ {:dataloader, &quot;~&gt; 1.0.0&quot;} ] end","ref":"dataloader.html#installation","title":"Dataloader - Installation","type":"extras"},{"doc":"The core concept of dataloader is a data source which is just a struct that encodes a way of retrieving data. More info in the Sources section. Schema Absinthe provides some dataloader helpers out of the box that you can import into your schema import Absinthe.Resolution.Helpers, only: [dataloader: 1] This is needed to use the various dataloader helpers to resolve a field: field(:posts, list_of(:post), resolve: dataloader(Blog)) Let&#39;s start with a data source. Dataloader data sources are just structs that encode a way of retrieving data in batches. In a Phoenix application you&#39;ll generally have one source per context, so that each context can control how its data is loaded. Here is a hypothetical Blog context and a dataloader ecto source: defmodule MyApp.Blog do def data() do Dataloader.Ecto.new(MyApp.Repo, query: &amp;query/2) end def query(queryable, _params) do queryable end end When integrating Dataloader with GraphQL, we want to place it in our context so that we can access it in our resolvers. In your schema module add: alias MyApp.{Blog, Foo} def context(ctx) do loader = Dataloader.new |&gt; Dataloader.add_source(Blog, Blog.data()) |&gt; Dataloader.add_source(Foo, Foo.data()) # Foo source could be a Redis source Map.put(ctx, :loader, loader) end def plugins do [Absinthe.Middleware.Dataloader] ++ Absinthe.Plugin.defaults() end The context/1 function is a callback specified by the Absinthe.Schema behaviour that gives the schema itself an opportunity to set some values in the context that it may need in order to run. The plugins/0 function has been around for a while, and specifies what plugins the schema needs to resolve. See the documentation for more. Unpacking Dataloader The data/0 function creates an Ecto data source, to which you pass your repo and a query function. This query function is called every time you want to load something, and provides an opportunity to apply arguments or set defaults. So for example if you always want to only load non-deleted posts you can do: def query(Post, _), do: from p in Post, where: is_nil(p.deleted_at) def query(queryable, _), do: queryable Now any time you&#39;re loading posts, you&#39;ll just get posts that haven&#39;t been deleted. We can also use the context to ensure access conditions, so we can only show deleted posts for admins: def query(Post, %{has_admin_rights: true}), do: Post def query(Post, _), do: from p in Post, where: is_nil(p.deleted_at) def query(queryable, _), do: queryable Helpfully, those rules are defined within your context, helping ensure that it has the final say about data access. Sources Dataloader ships with two different built in sources: Dataloader.Ecto - for easily pulling out data with ecto Dataloader.KV - a simple KV key value source. KV Here is a simple example of a loader using the KV source in combination with absinthe: defmodule MyProject.Loaders.Nhl do @teams [%{ id: 1, name: &quot;New Jersey Devils&quot;, abbreviation: &quot;NJD&quot; }, %{ id: 2, name: &quot;New York Islanders&quot;, abbreviation: &quot;NYI&quot; } # etc. ] def data() do Dataloader.KV.new(&amp;fetch/2) end def fetch(:teams, [%{}]) do %{ %{} =&gt; @teams } end def fetch(:team, args) do # must return a map keyed by the args # args is a list of the args used to resolve your field # for example, if you have arg(:foo, non_null(:string)) # args will look like: [%{foo: &quot;value of foo here&quot;)}] args |&gt; Enum.reduce(%{}, fn(%{id: id} = arg, result) -&gt; Map.put(result, arg, find_team(id)) end) end def fetch(_batch, args) do args |&gt; Enum.reduce(%{}, fn(arg, accum) -&gt; Map.put(accum, arg, nil) end) end defp find_team(id) do @teams |&gt; Enum.find(fn(t) -&gt; t |&gt; Map.get(:id) == id end) end end Dataloader.KV requires a load function that accepts a batch and args. It must return a map of values keyed by the args. This is the purpose of the fetch/2 function. The dataloader/1 helper we imported above uses the field name as the batch, and a map where the argument name is the key. For example: fetch(:team, [%{ id: 1 }]) Pattern matching can be used to fetch differently depending on the batch. For example, when the :teams batch is requested, the args will actually be an empty map (i.e. %{}). If you’re interested in more generic use of Dataloader, see the dataloader project source.","ref":"dataloader.html#usage","title":"Dataloader - Usage","type":"extras"},{"doc":"The Context and Authentication Absinthe context exists to provide shared values to a given document execution. A common use would be to pass in the current user of a given request. The context is set at the call to Absinthe.run, and cannot be modified over the course of a given execution.","ref":"context-and-authentication.html","title":"The Context and Authentication","type":"extras"},{"doc":"As a basic example let&#39;s think about a profile page, where we want the current user to be able to access basic information about themselves, but not other users. First we&#39;ll need a very basic schema: defmodule MyAppWeb.Schema do use Absinthe.Schema @fakedb %{ &quot;1&quot; =&gt; %{name: &quot;Bob&quot;, email: &quot;bubba@foo.com&quot;}, &quot;2&quot; =&gt; %{name: &quot;Fred&quot;, email: &quot;fredmeister@foo.com&quot;}, } query do field :profile, :user do resolve fn _, _, _ -&gt; # How could we get a current user here? end end end object :user do field :id, :id field :name, :string field :email, :string end end A query we might want could look like: { profile { email } } If we&#39;re signed in as user 1, we should get only user 1&#39;s email, for example: { &quot;profile&quot;: { &quot;email&quot;: &quot;bubba@foo.com&quot; } } In order to set the context, our call to Absinthe.run/3 should look like: Absinthe.run(document, MyAppWeb.Schema, context: %{current_user: %{id: &quot;1&quot;}}) To access this, we need to update our query&#39;s resolve function: query do field :profile, :user do resolve fn _, _, %{context: %{current_user: current_user}} -&gt; {:ok, Map.get(@fakedb, current_user.id)} end end end And now it works!","ref":"context-and-authentication.html#basic-usage","title":"The Context and Authentication - Basic Usage","type":"extras"},{"doc":"When using Absinthe.Plug you don&#39;t have direct access to the Absinthe.run call. Instead, we can use Absinthe.Plug.put_options/2 to set context values which Absinthe.Plug will use to pass it along to Absinthe.run. Setting up your GraphQL context is as simple as writing a plug that inserts the appropriate values into the connection. Let&#39;s use this mechanism to set our current_user from the previous example via an authentication header. We will use the same Schema as before. First, our plug. We&#39;ll be checking the connection for the authorization header, and calling out to some unspecified authentication mechanism. defmodule MyAppWeb.Context do @behaviour Plug import Plug.Conn import Ecto.Query, only: [where: 2] alias MyApp.{Repo, User} def init(opts), do: opts def call(conn, _) do context = build_context(conn) Absinthe.Plug.put_options(conn, context: context) end @doc &quot;&quot;&quot; Return the current user context based on the authorization header &quot;&quot;&quot; def build_context(conn) do with [&quot;Bearer &quot; &lt;&gt; token] &lt;- get_req_header(conn, &quot;authorization&quot;), {:ok, current_user} &lt;- authorize(token) do %{current_user: current_user} else _ -&gt; %{} end end defp authorize(token) do User |&gt; where(token: ^token) |&gt; Repo.one |&gt; case do nil -&gt; {:error, &quot;invalid authorization token&quot;} user -&gt; {:ok, user} end end end This plug will use the authorization header to lookup the current user. If one is found, it correctly sets the absinthe context. If you&#39;re using Guardian or some other library that provides utilities for authenticating users you can use those here too, and just add their output to the context. If there is no current user it&#39;s better to simply not have the :current_user key inside the map, instead of doing %{current_user: nil}. This way you an just pattern match for %{current_user: user} in your code and not need to worry about the nil case. Using this plug is very simple. If we&#39;re just in a normal plug context we can just make sure it&#39;s plugged prior to Absinthe.Plug plug MyAppWeb.Context plug Absinthe.Plug, schema: MyAppWeb.Schema If you&#39;re using a Phoenix router, add the context plug to a pipeline. defmodule MyAppWeb.Router do use Phoenix.Router resource &quot;/pages&quot;, MyAppWeb.PagesController pipeline :graphql do plug MyAppWeb.Context end scope &quot;/api&quot; do pipe_through :graphql forward &quot;/&quot;, Absinthe.Plug, schema: MyAppWeb.Schema end end","ref":"context-and-authentication.html#context-and-plugs","title":"The Context and Authentication - Context and Plugs","type":"extras"},{"doc":"Understanding Subscriptions GraphQL subscriptions are a way to have events in the server push data out to clients in real time. The client submits a subscription document that asks for particular data, and then when events happen that document is run against that event and the resulting data is pushed out. Like queries and mutations, subscriptions are not intrinsically tied to any particular transport, and they&#39;re built within Absinthe itself to be able to operate on many different platforms. At the moment however the most common and fully featured platform that you can run them on with Elixir is via Phoenix channels, so this guide will walk you through the basics of getting them hooked up to a phoenix application. Absinthe.Phoenix Setup Packages you&#39;ll need: {:absinthe, &quot;~&gt; 1.5&quot;}, {:absinthe_phoenix, &quot;~&gt; 1.5&quot;}, You need to have a working Phoenix pubsub configured. Here is what the default looks like if you create a new Phoenix project: config :my_app, MyAppWeb.Endpoint, # ... other config pubsub: [name: MyApp.PubSub, adapter: Phoenix.PubSub.PG2] In your application supervisor add a line after your existing endpoint supervision line: [ # other children ... supervisor(MyAppWeb.Endpoint, []), # this line should already exist supervisor(Absinthe.Subscription, MyAppWeb.Endpoint), # add this line # other children ... ] In Phoenix v1.4, the supervisor children are mounted like so: # List all child processes to be supervised children = [ # Start the Ecto repository MyAppWeb.Repo, # Start the endpoint when the application starts MyAppWeb.Endpoint, {Absinthe.Subscription, MyAppWeb.Endpoint} ] # See https://hexdocs.pm/elixir/Supervisor.html # for other strategies and supported options opts = [strategy: :one_for_one, name: MyAppWeb.Supervisor] Supervisor.start_link(children, opts) Where MyAppWeb.Endpoint is the name of your application&#39;s phoenix endpoint. In your MyAppWeb.Endpoint module add: use Absinthe.Phoenix.Endpoint For your socket, different configurations are used in MyAppWeb.UserSocket depending on what version of Phoenix you&#39;re using. Phoenix 1.3 and 1.4 use Absinthe.Phoenix.Socket, schema: MyAppWeb.Schema Phoenix 1.2 use Absinthe.Phoenix.Socket def connect(_params, socket) do socket = Absinthe.Phoenix.Socket.put_schema(socket, MyAppWeb.Schema) {:ok, socket} end Where MyAppWeb.Schema is the name of your Absinthe schema module. GraphiQL (optional) If you&#39;re using the GraphiQL plug, in your MyAppWeb.Router, specify the socket option: forward &quot;/graphiql&quot;, Absinthe.Plug.GraphiQL, schema: MyAppWeb.Schema, socket: MyAppWeb.UserSocket That is all that&#39;s required for setup on the server. Setting Options Options like the context can be configured in the connect/2 callback in your socket module. Note: The transport macro is deprecated in phoenix 1.4 and can be omitted. defmodule MyAppWeb.UserSocket do use Phoenix.Socket use Absinthe.Phoenix.Socket, schema: MyAppWeb.Schema # Deprecated in Phoenix v1.4 transport :websocket, Phoenix.Transports.WebSocket def connect(params, socket) do current_user = current_user(params) socket = Absinthe.Phoenix.Socket.put_opts(socket, context: %{ current_user: current_user }) {:ok, socket} end defp current_user(%{&quot;user_id&quot; =&gt; id}) do MyApp.Repo.get(User, id) end def id(_socket), do: nil end Schema Here&#39;s an example schema that lets you use subscriptions to get notified when a comment is submitted to a GitHub repository: mutation do field :submit_comment, :comment do arg :repo_name, non_null(:string) arg :content, non_null(:string) resolve &amp;Github.submit_comment/3 end end subscription do field :comment_added, :comment do arg :repo_name, non_null(:string) # The topic function is used to determine what topic a given subscription # cares about based on its arguments. You can think of it as a way to tell the # difference between # subscription { # commentAdded(repoName: &quot;absinthe-graphql/absinthe&quot;) { content } # } # # and # # subscription { # commentAdded(repoName: &quot;elixir-lang/elixir&quot;) { content } # } # # If needed, you can also provide a list of topics: # {:ok, topic: [&quot;absinthe-graphql/absinthe&quot;, &quot;elixir-lang/elixir&quot;]} config fn args, _ -&gt; {:ok, topic: args.repo_name} end # this tells Absinthe to run any subscriptions with this field every time # the :submit_comment mutation happens. # It also has a topic function used to find what subscriptions care about # this particular comment trigger :submit_comment, topic: fn comment -&gt; comment.repository_name end resolve fn comment, _, _ -&gt; # this function is often not actually necessary, as the default resolver # for subscription functions will just do what we&#39;re doing here. # The point is, subscription resolvers receive whatever value triggers # the subscription, in our case a comment. {:ok, comment} end end end Concretely, if client A submits a subscription document: subscription { commentAdded(repoName: &quot;absinthe-graphql/absinthe&quot;) { content } } This tells Absinthe to subscribe client A in the :comment_added field on the &quot;absinthe-graphql/absinthe&quot; topic, because that&#39;s what comes back from the config function. Then, if client B submits a mutation: mutation { submitComment(repoName: &quot;absinthe-graphql/absinthe&quot;, content: &quot;Great library!&quot;) { id } } Client B will get the normal response to their mutation, and since they just ask for the id that&#39;s what they&#39;ll get. Additionally, the :submit_comment mutation is configured as a trigger on the :comment_added subscription field, so the trigger function is called. That function returns &quot;absinthe-graphql/absinthe&quot; because that&#39;s the repository name for the comment, and now Absinthe knows it needs to get all subscriptions on the :comment_added field that have the &quot;absinthe-graphql/absinthe&quot; topic, so client A gets back: {&quot;data&quot;:{&quot;commentAdded&quot;:{&quot;content&quot;:&quot;Great library!&quot;}}} If you want to publish to this subscription manually (not using triggers in the schema) you can do: Absinthe.Subscription.publish(MyAppWeb.Endpoint, comment, comment_added: &quot;absinthe-graphql/absinthe&quot;) If you want to subscribe to mutations from within your application, you can do: {:ok, %{&quot;subscribed&quot; =&gt; topic}} = Absinthe.run(subscription_query, MyAppWeb.Schema, context: %{pubsub: MyAppWeb.Endpoint}) MyAppWeb.Endpoint.subscribe(topic) De-duplicating Updates By default, Absinthe will resolve each outgoing publish once per individual subscription. This ensures: Different GraphQL documents each receive the different fields they requested User-specific updates are sent out, in case context contains user-specific data To improve the scale at which your subscriptions operate, you may tell Absinthe when it is safe to de-duplicate updates. Simply return a context_id from your field&#39;s config function: subscription do field :news_article_published, :article do config fn _, _ -&gt; {:ok, topic: &quot;*&quot;, context_id: &quot;global&quot;} end end end Here we return a constant (&quot;global&quot;) because our :article type doesn&#39;t contain any user-specific fields on it. Given these three active subscriptions: # user 1 subscription { newsArticlePublished { content } } # user 2 subscription { newsArticlePublished { content author } } # user 3 subscription { newsArticlePublished { content } } Since we provided a context_id, Absinthe will only run two documents per publish to this field: Once for user 1 and user 3 because they have the same context ID (&quot;global&quot;) and sent the same document. Once for user 2. While user 2 has the same context ID (&quot;global&quot;), they provided a different document, so it cannot be de-duplicated with the other two.","ref":"subscriptions.html","title":"Understanding Subscriptions","type":"extras"},{"doc":"Custom Scalar Types One of the strengths of GraphQL is its extensibility---which doesn&#39;t end with its object types, but is present all the way down to the scalar value level. Sometimes it makes sense to build custom scalar types to better model your domain. Here&#39;s how to do it. The GraphQL Specification doesn&#39;t define date and datetime types, but Absinthe ships with several pre-built for use via import_types. In this example we&#39;ll look at how :datetime is defined.","ref":"custom-scalars.html","title":"Custom Scalar Types","type":"extras"},{"doc":"Supporting additional scalar types is as easy as using the scalar macro and providing parse and serialize functions. Here&#39;s the definition for :datetime from Absinthe.Type.Custom: @desc &quot;&quot;&quot; The [`DateTime`](https://hexdocs.pm/elixir/DateTime.html) scalar type represents a date and time in the UTC timezone. The DateTime appears in a JSON response as an ISO8601 formatted string, including UTC timezone (&quot;Z&quot;). The parsed date and time string will be converted to UTC and any UTC offset other than 0 will be rejected. &quot;&quot;&quot; scalar :datetime, name: &quot;DateTime&quot; do serialize &amp;DateTime.to_iso8601/1 parse &amp;parse_datetime/1 end @spec parse_datetime(Absinthe.Blueprint.Input.String.t) :: {:ok, DateTime.t} | :error @spec parse_datetime(Absinthe.Blueprint.Input.Null.t) :: {:ok, nil} defp parse_datetime(%Absinthe.Blueprint.Input.String{value: value}) do case DateTime.from_iso8601(value) do {:ok, datetime, 0} -&gt; {:ok, datetime} {:ok, _datetime, _offset} -&gt; :error _error -&gt; :error end end defp parse_datetime(%Absinthe.Blueprint.Input.Null{}) do {:ok, nil} end defp parse_datetime(_) do :error end Scalar definitions, created using the scalar macro from Absinthe.Schema.Notation, are made up of two major elements: A function provided to parse that defines how input is converted from an AST value (an Absinthe.Blueprint.Input.t) to a value that&#39;s suitable for use in an argument and passed to a resolver. A function provided to serialize that defines how input is serialized back out when used as a result that should be sent back to the user. In this example: mutation CreatePost { post(title: &quot;Second&quot;, body: &quot;We&#39;re off to a great start!&quot;, publishedAt: &quot;2017-11-01T12:00:00Z&quot;) { id publishedAt } } If our schema defines a :published_at argument with the :datetime type: field :post, :post do arg :published_at, :datetime resolve fn _, args, _ -&gt; # If the arg is provided, `args.published_at` will be a DateTime struct # ... end end Then, the value of the publishedAt GraphQL field ends up being parsed by the parse_datetime/1 function; it&#39;s been defined as the parse function for the :datetime type using the parse macro. The value, &quot;2017-11-01T12:00:00Z&quot;, will come into the function as an %Absinthe.Blueprint.Input.String{}, thanks to the hard work of the Absinthe parser and processing pipeline. The parse_datetime/1 function pulls the string value out of the input, parses it with DateTime.from_iso8601/1, then returns the correct result. That result will be used as the value of the :published_at argument when it&#39;s passed to the :post field resolver. It&#39;s important to note that---currently---the correct result from a scalar&#39;s parse function in the event of the error is a lone atom, :error, not an error tuple with a reason. In a future version of Absinthe, custom parse errors may be supported. The serializer of :datetime is a pretty simple affair; it uses the DateTime.to_iso8601/1 utility function. It would be called to serialize the %DateTime{} struct for the requested :published_at field in the result. More custom scalar examples can be found under Absinthe Wiki - Scalar Recipes.","ref":"custom-scalars.html#defining-a-scalar","title":"Custom Scalar Types - Defining a scalar","type":"extras"},{"doc":"Importing Types It doesn&#39;t take long for a schema module to become crowded with types, resolvers, and other customizations. A good first step in cleaning up your schema is extracting your types, organizing them into other modules, and then using Absinthe.Schema.Notation.import_types/1 to make them available to your schema.","ref":"importing-types.html","title":"Importing Types","type":"extras"},{"doc":"Let&#39;s say you have a schema that looks something like this: defmodule MyAppWeb.Schema do use Absinthe.Schema object :user do field :name, :string end # Rest of the schema... end You could extract your :user type into a module, MyAppWeb.Schema.AccountTypes: defmodule MyAppWeb.Schema.AccountTypes do use Absinthe.Schema.Notation object :user do field :name, :string end end Note that, unlike your schema module, type modules should use Absinthe.Schema.Notation, notAbsinthe.Schema. Now, you need to make sure you use import_types to tell your schema where to find additional types: defmodule MyAppWeb.Schema do use Absinthe.Schema import_types MyAppWeb.Schema.AccountTypes # Rest of the schema... end Important: You should only use import_types from your schema module; think of it like a manifest. Now, your schema will be able to resolve any references to your :user type during compilation.","ref":"importing-types.html#example","title":"Importing Types - Example","type":"extras"},{"doc":"Root types (which are defined using the query, mutation, and subscription macros), can only be defined on the schema module---you can&#39;t extract them, but you can use the import_fields mechanism to extract their contents. Here&#39;s an example: query do import_fields :account_queries end This will look for a matching object type :account_queries, and pull its fields into the root query type. For more information, see the guide.","ref":"importing-types.html#what-about-root-types","title":"Importing Types - What about root types?","type":"extras"},{"doc":"Importing Fields Sometimes an object type becomes too large and needs to be broken into pieces. This is especially true of the root query, mutation, and subscription types that are defined in the schema module itself. Absinthe provides a mechanism, Absinthe.Schema.Notation.import_fields/1, to support objects being able to import fields from other object types.","ref":"importing-fields.html","title":"Importing Fields","type":"extras"},{"doc":"Let&#39;s say you&#39;re building a content management system. Your root query type has become unwieldy over time, and your schema looks something like this: defmodule MyAppWeb.Schema do use Absinthe.Schema query do @desc &quot;Get all the users, optionally filtering&quot; field :users, list_of(:user) do # ... end @desc &quot;Get a user using criteria&quot; field :user, :user do # ... end # More account-related fields.. @desc &quot;Get all the articles, optionally filtering&quot; field :articles, list_of(:article) do # ... end @desc &quot;Get an article using criteria&quot; field :article, :article do # ... end # More content-related fields... end # Other types... end This could be cleaned up to look something like this: defmodule MyAppWeb.Schema do use Absinthe.Schema import_types MyAppWeb.Schema.AccountTypes import_types MyAppWeb.Schema.ContentTypes query do # Using :account_queries from MyAppWeb.Schema.AccountTypes import_fields :account_queries # Using :content_queries from MyAppWeb.Schema.ContentTypes import_fields :content_queries end # Other types... end import_fields here is pulling fields in from separate object types. Before you can import fields from another object type, make sure that the type in question is available to your schema. See the guide on importing types for information on how that&#39;s done. Here&#39;s how those object types are defined. First, AccountTypes: defmodule MyAppWeb.Schema.AccountTypes do use Absinthe.Schema.Notation object :account_queries do @desc &quot;Get all the users, optionally filtering&quot; field :users, list_of(:user) do # ... end @desc &quot;Get a user using criteria&quot; field :user, :user do # ... end # More account-related fields... end # More account-related types... end And ContentTypes: defmodule MyAppWeb.Schema.ContentTypes do use Absinthe.Schema.Notation object :content_queries do @desc &quot;Get all the articles, optionally filtering&quot; field :articles, list_of(:article) do # ... end @desc &quot;Get an article using criteria&quot; field :article, :article do # ... end # More content-related fields end # More content-related types... end For more information on import_types, see the guide.","ref":"importing-fields.html#an-example","title":"Importing Fields - An Example","type":"extras"},{"doc":"Using Document Variables GraphQL supports query documents that declare variables that can be accepted to fill-in values. This is a useful mechanism for reusing GraphQL documents---instead of attempting to interpolate values yourself. To support variables, simply define them for your query document as the specification expects, and pass in a variables option to Absinthe.run. If you&#39;re using absinthe_plug, variables are passed in for you automatically after being parsed from the query parameters or POST body. Here&#39;s an example of defining a non-nullable variable, id, in a document and then executing the document with a value for the variable: &quot;&quot;&quot; query GetItem($id: ID!) { item(id: $id) { name } } &quot;&quot;&quot; |&gt; Absinthe.run(MyAppWeb.Schema, variables: %{&quot;id&quot; =&gt; &quot;bar&quot;}) # Result {:ok, %{data: %{&quot;item&quot; =&gt; %{&quot;name&quot; =&gt; &quot;Bar&quot;}}}}","ref":"variables.html","title":"Using Document Variables","type":"extras"},{"doc":"Schema Introspection You can introspect your schema using __schema, __type, and __typename, as described in the specification. Examples Seeing the names of the types in the schema: &quot;&quot;&quot; { __schema { types { name } } } &quot;&quot;&quot; |&gt; Absinthe.run(MyAppWeb.Schema) {:ok, %{data: %{ &quot;__schema&quot; =&gt; %{ &quot;types&quot; =&gt; [ %{&quot;name&quot; =&gt; &quot;Boolean&quot;}, %{&quot;name&quot; =&gt; &quot;Float&quot;}, %{&quot;name&quot; =&gt; &quot;ID&quot;}, %{&quot;name&quot; =&gt; &quot;Int&quot;}, %{&quot;name&quot; =&gt; &quot;String&quot;}, ... ] } }} } Getting the name of the queried type: &quot;&quot;&quot; { profile { name __typename } } &quot;&quot;&quot; |&gt; Absinthe.run(MyAppWeb.Schema) {:ok, %{data: %{ &quot;profile&quot; =&gt; %{ &quot;name&quot; =&gt; &quot;Joe&quot;, &quot;__typename&quot; =&gt; &quot;Person&quot; } }} } Getting the name of the fields for a named type: &quot;&quot;&quot; { __type(name: &quot;Person&quot;) { fields { name type { kind name } } } } &quot;&quot;&quot; |&gt; Absinthe.run(MyAppWeb.Schema) {:ok, %{data: %{ &quot;__type&quot; =&gt; %{ &quot;fields&quot; =&gt; [ %{ &quot;name&quot; =&gt; &quot;name&quot;, &quot;type&quot; =&gt; %{&quot;kind&quot; =&gt; &quot;SCALAR&quot;, &quot;name&quot; =&gt; &quot;String&quot;} }, %{ &quot;name&quot; =&gt; &quot;age&quot;, &quot;type&quot; =&gt; %{&quot;kind&quot; =&gt; &quot;SCALAR&quot;, &quot;name&quot; =&gt; &quot;Int&quot;} }, ] } }} } Note that you may have to nest several depths of type/ofType, as type information includes any wrapping layers of List and/or NonNull.","ref":"introspection.html","title":"Schema Introspection","type":"extras"},{"doc":"The GraphiQL project is &quot;an in-browser IDE for exploring GraphQL.&quot; Absinthe provides GraphiQL via a plug in absinthe_plug. See the Plug and Phoenix Guide for how to install that library. Once installed, usage is simple as: plug Absinthe.Plug.GraphiQL, schema: MyAppWeb.Schema If you want to use it at a particular path (in this case graphiql in your Phoenix router, simply do: # filename: router.ex forward &quot;/graphiql&quot;, Absinthe.Plug.GraphiQL, schema: MyAppWeb.Schema This can be trivially reserved to just the :dev elixir environment by doing: # filename: router.ex if Mix.env == :dev do forward &quot;/graphiql&quot;, Absinthe.Plug.GraphiQL, schema: MyAppWeb.Schema end If you&#39;d prefer to use a desktop application, we recommend using the pre-built Electron-based wrapper application, GraphiQL.app. GraphQL Hub GraphQL Hub is an interesting website that you can use to introspect a number of public GraphQL servers, using GraphiQL in the browser and providing useful examples.","ref":"introspection.html#using-graphiql","title":"Schema Introspection - Using GraphiQL","type":"extras"},{"doc":"Telemetry Absinthe 1.5 uses telemetry to instrument its activity. Call :telemetry.attach/4 or :telemetry.attach_many/4 to attach your handler function to any of the following event names: [:absinthe, :execute, :operation, :start] when the operation starts [:absinthe, :execute, :operation, :stop] when the operation finishes [:absinthe, :subscription, :publish, :start] when a subscription starts [:absinthe, :subscription, :publish, :stop] when a subscription finishes [:absinthe, :resolve, :field, :start] when field resolution starts [:absinthe, :resolve, :field, :stop] when field resolution finishes [:absinthe, :middleware, :batch, :start] when the batch processing starts [:absinthe, :middleware, :batch, :stop] when the batch processing finishes Telemetry handlers are called with measurements and metadata. For details on what is passed, checkout Absinthe.Phase.Telemetry, Absinthe.Middleware.Telemetry, and Absinthe.Middleware.Batch. For async, batch, and dataloader fields, Absinthe sends the final event when it gets the results. That might be later than when the results are ready. If you need to know how long the underlying operation took, you&#39;ll need to hook telemetry up to that underlying operation. See, for example, the recommended telemetry events in the documentation for Ecto.Repo.","ref":"telemetry.html","title":"Telemetry","type":"extras"},{"doc":"As an example, you could attach a handler in an iex -S mix shell. Paste in: :telemetry.attach_many( :demo, [ [:absinthe, :resolve, :field, :stop] ], fn event_name, measurements, metadata, _config -&gt; %{ event_name: event_name, measurements: measurements, metadata: metadata } |&gt; IO.inspect() end, [] ) After a query is executed, you&#39;ll see something like: %{ event_name: [:absinthe, :resolve, :field, :stop], measurements: %{duration: 14000}, metadata: %{ id: -576460752303351647, middleware: [ {{Absinthe.Resolution, :call}, &amp;MyApp.Resolvers.resolve_field/3} ], resolution: :..., start_time: 1565830447035742000 } }","ref":"telemetry.html#interactive-telemetry","title":"Telemetry - Interactive Telemetry","type":"extras"},{"doc":"Schema Deprecation Use the deprecate option when defining any field or enum value. Provide a binary value to give a deprecation reason Provide true to just mark it as deprecated An example: query do field :old_item, :item, deprecate: true field :another_old_item, :item, deprecate: &quot;still too old&quot; end You can also use the deprecate as a macro inside a block, for instance: field :age, :integer do deprecate arg :user_id, non_null(:id) end With a reason: field :ssn, :string do deprecate &quot;Privacy concerns&quot; end Warning: Deprecated fields and enum values are not reported by default during introspection.","ref":"deprecation.html","title":"Schema Deprecation","type":"extras"},{"doc":"Document Adapters Absinthe supports an adapter mechanism that allows developers to define their schema using one code convention (eg, snake_cased fields and arguments), but accept query documents and return results (including names in errors) in another (eg, camelCase). This is useful in allowing both client and server to use conventions most natural to them. Absinthe ships with two adapters: Absinthe.Adapter.LanguageConventions, which expects schemas to be defined in snake_case (the standard Elixir convention), translating to/from camelCase for incoming query documents and outgoing results. This is the default as of v0.3, and it is highly recommended that it&#39;s the adapter you use, as introspection currently makes certain assumptions about how to return results. Absinthe.Adapter.Underscore, which is similar to the LanguageConventions adapter but converts all incoming identifiers to underscores and does not modify outgoing identifiers (since those are already expected to be underscores). Unlike Absinthe.Adapter.Passthrough this does not break introspection. Absinthe.Adapter.Passthrough, which is a no-op adapter and makes no modifications. To set the adapter, you provide it as an option to Absinthe.run/3: Absinthe.run(query, MyAppWeb.Schema, adapter: Absinthe.Adapter.TheAdapterName) Notably, this means you&#39;re able to switch adapters on case-by-case basis. In a Phoenix application, this means you could even support using different adapters for different clients. A custom adapter module must merely implement the Absinthe.Adapter behaviour, in many cases with use Absinthe.Adapter and only overriding the desired functions. Note that types that are defined external to your application (including the introspection types) may not be compatible if you&#39;re using a different adapter.","ref":"adapters.html","title":"Document Adapters","type":"extras"},{"doc":"Complexity Analysis A misbehaving client might send a very complex GraphQL query that would require considerable resources to handle. In order to protect against this scenario, the complexity of a query can be estimated before it is resolved and limited to a specified maximum. For example, to enable complexity analysis and limit the complexity to a value of 50 -- if we were using Absinthe.run/3 directly -- we would do this: Absinthe.run(doc, MyAppWeb.Schema, analyze_complexity: true, max_complexity: 50) That would translate to the following configuration when using absinthe_plug (&gt;= v1.2.3): plug Absinthe.Plug, schema: MyAppWeb.Schema, analyze_complexity: true, max_complexity: 50 The maximum value, 50, is compared to complexity values calculated for each request.","ref":"complexity-analysis.html","title":"Complexity Analysis","type":"extras"},{"doc":"Here&#39;s how the complexity value is calculated: By default each field in a query will increase the complexity by 1. However it can be useful to customize how the complexity value for a field. This is done in your schema using the complexity/1 macro, which can accept a function or an explicit integer value. As an example, when a field is a list, the complexity is often correlated to the size of the list. To prevent large selections, a field can use a limit argument with a suitable default (think, for instance, of page sizes during pagination), and complexity can be calculated keeping that in mind. Here is a schema that supports analyzing (and limiting) complexity using that approach: defmodule MyAppWeb.Schema do use Absinthe.Schema query do field :people, list_of(:person) do arg :limit, :integer, default_value: 10 complexity fn %{limit: limit}, child_complexity -&gt; # set complexity based on maximum number of items in the list and # complexity of a child. limit * child_complexity end end end object :person do field :name, :string field :age, :integer end end For a field, the first argument to the function you supply to complexity/1 is the user arguments -- just as a field&#39;s resolver can use user arguments to resolve its value, the complexity function that you provide can use the same arguments to calculate the field&#39;s complexity. The second argument passed to your complexity function is the sum of all the complexity scores of all the fields nested below the current field. (If a complexity function accepts three arguments, the third will be an %Absinthe.Resolution{} struct, just as with resolvers.) If the value of a document&#39;s :limit argument was 10 and both name and age were queried for, the complexity of the :people field would be calculated as 20: 10, the value of :limit times 2, the sum of the complexity of the fields requested on the :person A field&#39;s complexity will default to 1 if it&#39;s not set explicitly. So this would be okay: { people(limit: 10) { name } } But this, at a complexity of 60, wouldn&#39;t: { people(limit: 30) { name } } Complexity limiting If a document&#39;s calculated complexity exceeds the configured limit, resolution will be skipped and an error will be returned in the result detailing the calculated and maximum complexities.","ref":"complexity-analysis.html#complexity-analysis","title":"Complexity Analysis - Complexity Analysis","type":"extras"},{"doc":"File Uploads Absinthe provides a unique pattern to support file uploads in conjunction with normal GraphQL field arguments as part of the absinthe_plug package.","ref":"file-uploads.html","title":"File Uploads","type":"extras"},{"doc":"The following schema includes a mutation field that accepts multiple uploaded files as arguments (:users and :metadata): defmodule MyAppWeb.Schema do use Absinthe.Schema # Important: Needed to use the `:upload` type import_types Absinthe.Plug.Types mutation do field :upload_file, :string do arg :users, non_null(:upload) arg :metadata, :upload resolve fn args, _ -&gt; args.users # this is a `%Plug.Upload{}` struct. {:ok, &quot;success&quot;} end end end end To send a mutation that includes a file upload, you need to use the multipart/form-data content type. For example, using cURL: $ curl -X POST \\\\ -F query=&quot;mutation { uploadFile(users: \\&quot;users_csv\\&quot;, metadata: \\&quot;metadata_json\\&quot;)}&quot; \\\\ -F users_csv=@users.csv \\\\ -F metadata_json=@metadata.json \\\\ localhost:4000/graphql Note how there is a correspondence between the value of the :users argument and the -F option indicating the associated file. By treating uploads as regular arguments we get all the usual GraphQL argument benefits (such as validation and documentation)---which we wouldn&#39;t get if we were merely putting them in the context as in other implementations.","ref":"file-uploads.html#example","title":"File Uploads - Example","type":"extras"},{"doc":"Apollo: apollo-absinthe-upload-link Apollo (v1): apollo-absinthe-upload-client (Note: does not support Relay Native as of v1.0.1) Relay: (None known. Please submit a pull request updating this information.)","ref":"file-uploads.html#integration-with-client-side-graphql-frameworks","title":"File Uploads - Integration with Client-side GraphQL Frameworks","type":"extras"},{"doc":"Testing There are three main approaches to testing GraphQL APIs built with Absinthe: Testing resolver functions, since they do most of work. Testing GraphQL document execution directly via Absinthe.run/3, for the bigger picture. Outside-in, testing the full HTTP request/response cycle with absinthe_plug. This guide focuses on the third approach, which we generally recommend since it exercises more of your application.","ref":"testing.html","title":"Testing","type":"extras"},{"doc":"GraphQL is transport independent, but it&#39;s most often served over HTTP. To test HTTP requests with absinthe you&#39;ll also need absinthe_plug. This guide will also assume you&#39;re using Phoenix, although it is possible to use Absinthe without it (see the Plug and Phoenix Setup Guide).","ref":"testing.html#testing-with-absinthe-plug","title":"Testing - Testing with Absinthe Plug","type":"extras"},{"doc":"Say we want to test the following schema: defmodule MyAppWeb.Schema do use Absinthe.Schema @fakedb %{ &quot;1&quot; =&gt; %{name: &quot;Bob&quot;, email: &quot;bubba@foo.com&quot;}, &quot;2&quot; =&gt; %{name: &quot;Fred&quot;, email: &quot;fredmeister@foo.com&quot;} } query do field :user, :user do arg :id, non_null(:id) resolve &amp;find_user/2 end end object :user do field :name, :string field :email, :string end defp find_user(%{id: id}, _) do {:ok, Map.get(@fakedb, id)} end end Which we have exposed at the /api endpoint: defmodule MyAppWeb.Router do use Phoenix.Router scope &quot;/api&quot; do forward &quot;/&quot;, Absinthe.Plug, schema: MyAppWeb.Schema end end The test could look something like this: defmodule MyAppWeb.SchemaTest do use MyAppWeb.ConnCase @user_query &quot;&quot;&quot; query getUser($id: ID!) { user(id: $id) { name email } } &quot;&quot;&quot; test &quot;query: user&quot;, %{conn: conn} do conn = post(conn, &quot;/api&quot;, %{ &quot;query&quot; =&gt; @user_query, &quot;variables&quot; =&gt; %{id: 1} }) assert json_response(conn, 200) == %{ &quot;data&quot; =&gt; %{&quot;user&quot; =&gt; %{&quot;email&quot; =&gt; &quot;bubba@foo.com&quot;, &quot;name&quot; =&gt; &quot;Bob&quot;}} } end end Phoenix generates the MyAppWeb.ConnCase test helper module. This supplies the conn variable containing the request and response. It also has helper functions such as post/3 and json_response/2. The query is stored in the @user_query module attribute. We post this document to the GraphQL endpoint at /api, along with a map of variables which will be transformed to arguments for the getUser query. The response to the query can then be directly asserted to be a JSON object of the right shape.","ref":"testing.html#example","title":"Testing - Example","type":"extras"},{"doc":"Using with JavaScript You can interact with an Absinthe GraphQL server via HTTP (thanks to absinthe_plug) and websockets (thanks to absinthe_phoenix): We also have special support for configuring and working with specific JavaScript frameworks. You can see the guides here: Apollo Client Relay","ref":"javascript.html","title":"Using with JavaScript","type":"extras"},{"doc":"To integrate a JavaScript application via HTTP, any standard GraphQL HTTP request (GET/POST) will do. Here&#39;s an example using isomorphic-fetch: require(&#39;isomorphic-fetch&#39;); fetch(&#39;http://localhost:4000/graphql&#39;, { method: &#39;POST&#39;, headers: { &#39;Content-Type&#39;: &#39;application/json&#39; }, body: JSON.stringify({ query: &#39;{ posts { title } }&#39; }), }) .then(res =&gt; res.json()) .then(res =&gt; console.log(res.data));","ref":"javascript.html#over-http","title":"Using with JavaScript - Over HTTP","type":"extras"},{"doc":"See the @absinthe/socket NPM package for special support for Absinthe&#39;s use of Phoenix channels for GraphQL over websockets, including support for subscriptions.","ref":"javascript.html#over-websockets","title":"Using with JavaScript - Over Websockets","type":"extras"},{"doc":"Using with Apollo Client An Apollo client manages its connection to the GraphQL server using links -- which are essentially middleware that tell Apollo how to resolve each query. You can configure Apollo to connect to your Absinthe server via HTTP, websockets, or both.","ref":"apollo.html","title":"Using with Apollo Client","type":"extras"},{"doc":"Using Apollo with an HTTP link does not require any Absinthe-specific configuration. You can create an HTTP link pointed at your Absinthe server as follows: import ApolloClient from &quot;apollo-client&quot;; import { createHttpLink } from &quot;apollo-link-http&quot;; import { InMemoryCache } from &quot;apollo-cache-inmemory&quot;; // Create an HTTP link to the Absinthe server. const link = createHttpLink({ uri: &quot;http://localhost:4000/graphql&quot; }); // Apollo also requires you to provide a cache implementation // for caching query results. The InMemoryCache is suitable // for most use cases. const cache = new InMemoryCache(); // Create the client. const client = new ApolloClient({ link, cache }); You may find that you need to modify the HTTP request that Apollo makes -- for example, if you wish to send the value of a particular cookie in the Authorization header. The setContext helper allows you to do this, and also demonstrates how links in Apollo can be chained. import ApolloClient from &quot;apollo-client&quot;; import { createHttpLink } from &quot;apollo-link-http&quot;; import { setContext } from &quot;apollo-link-context&quot;; import { InMemoryCache } from &quot;apollo-cache-inmemory&quot;; import Cookies from &quot;js-cookie&quot;; // Create an HTTP link to the Absinthe server. const httpLink = createHttpLink({ uri: &quot;http://localhost:4000/graphql&quot; }); // Use setContext to create a chainable link object that sets // the token cookie to the Authorization header. const authLink = setContext((_, { headers }) =&gt; { // Get the authentication token from the cookie if it exists. const token = Cookies.get(&quot;token&quot;); // Add the new Authorization header. return { headers: { ...headers, authorization: token ? `Bearer ${token}` : &quot;&quot; } }; }); // Chain the HTTP link and the authorization link. const link = authLink.concat(httpLink); // Apollo also requires you to provide a cache implementation // for caching query results. The InMemoryCache is suitable // for most use cases. const cache = new InMemoryCache(); // Create the client. const client = new ApolloClient({ link, cache });","ref":"apollo.html#using-an-http-link","title":"Using with Apollo Client - Using an HTTP link","type":"extras"},{"doc":"An HTTP link is suitable for many basic use cases, but if you require two-way communication between the server and the client, you will need to use a websocket link. The most common use case is a client that needs to use GraphQL subscriptions to receive updates from the server when particular events occur. To implement a websocket link, we will need to use the @absinthe/socket and @absinthe/socket-apollo-link packages. import ApolloClient from &quot;apollo-client&quot;; import * as AbsintheSocket from &quot;@absinthe/socket&quot;; import { createAbsintheSocketLink } from &quot;@absinthe/socket-apollo-link&quot;; import { Socket as PhoenixSocket } from &quot;phoenix&quot;; import { InMemoryCache } from &quot;apollo-cache-inmemory&quot;; import Cookies from &quot;js-cookie&quot;; // Create a standard Phoenix websocket connection. If you need // to provide additional params, like an authentication token, // you can configure them in the `params` option. const phoenixSocket = new PhoenixSocket(&quot;ws://localhost:4000/socket&quot;, { params: () =&gt; { if (Cookies.get(&quot;token&quot;)) { return { token: Cookies.get(&quot;token&quot;) }; } else { return {}; } } }); // Wrap the Phoenix socket in an AbsintheSocket. const absintheSocket = AbsintheSocket.create(phoenixSocket); // Create an Apollo link from the AbsintheSocket instance. const link = createAbsintheSocketLink(absintheSocket); // Apollo also requires you to provide a cache implementation // for caching query results. The InMemoryCache is suitable // for most use cases. const cache = new InMemoryCache(); // Create the client. const client = new ApolloClient({ link, cache }); Reconnecting the websocket link You may find that you periodically need to reconnect the websocket with different parameters. The most common case for this is when a user logs in or logs out; you will then want to refresh their subscriptions to reflect the new authentication state. You can accomplish this by invoking phoenixSocket.conn.close(); from your application code whenever the reconnection needs to happen. Phoenix will notice the closed connection and automatically reconnect. It is important that you provide a function that returns the websocket parameters to the socket params option. If you provide the parameters directly as an object, the new parameters will not be picked up when the websocket reconnects, but if you provide a function, Phoenix invokes the function on each connection to obtain the parameters. Note that this solution (reconnecting with phoenixSocket.conn.close();) is somewhat unstable because it relies upon an implementation detail of the Phoenix socket. Ideally, a future version of the Phoenix package might add a public API method to reconnect the websocket with new parameters. import ApolloClient from &quot;apollo-client&quot;; import * as AbsintheSocket from &quot;@absinthe/socket&quot;; import { createAbsintheSocketLink } from &quot;@absinthe/socket-apollo-link&quot;; import { Socket as PhoenixSocket } from &quot;phoenix&quot;; import { InMemoryCache } from &quot;apollo-cache-inmemory&quot;; import Cookies from &quot;js-cookie&quot;; // Create a standard Phoenix websocket connection. If you need // to provide additional params, like an authentication token, // you can configure them in the `params` option. // // If you plan to reconnect the socket with updated parameters, // you must provide a function to the `params` option. If you // provide the parameters directly as an object, the updated // parameters will not be picked up when the socket reconnects. const phoenixSocket = new PhoenixSocket(&quot;ws://localhost:4000/socket&quot;, { params: () =&gt; { if (Cookies.get(&quot;token&quot;)) { return { token: Cookies.get(&quot;token&quot;) }; } else { return {}; } } }); // Wrap the Phoenix socket in an AbsintheSocket. const absintheSocket = AbsintheSocket.create(phoenixSocket); // Create an Apollo link from the AbsintheSocket instance. const link = createAbsintheSocketLink(absintheSocket); // Apollo also requires you to provide a cache implementation // for caching query results. The InMemoryCache is suitable // for most use cases. const cache = new InMemoryCache(); // Create the client. const client = new ApolloClient({ link, cache }); // Later in your application code, when you need to reconnect // the socket. phoenixSocket.conn.close();","ref":"apollo.html#using-a-websocket-link","title":"Using with Apollo Client - Using a websocket link","type":"extras"},{"doc":"A common configuration for Apollo client applications is to use both HTTP and websocket links -- HTTP for queries and mutations, and a websocket for subscriptions. We can implement this in our client using directional composition with Apollo&#39;s split helper. import ApolloClient from &quot;apollo-client&quot;; import { createHttpLink } from &quot;apollo-link-http&quot;; import { setContext } from &quot;apollo-link-context&quot;; import * as AbsintheSocket from &quot;@absinthe/socket&quot;; import { createAbsintheSocketLink } from &quot;@absinthe/socket-apollo-link&quot;; import { Socket as PhoenixSocket } from &quot;phoenix&quot;; import { hasSubscription } from &quot;@jumpn/utils-graphql&quot;; import { split } from &quot;apollo-link&quot;; import { InMemoryCache } from &quot;apollo-cache-inmemory&quot;; import Cookies from &quot;js-cookie&quot;; // Create an HTTP link to the Absinthe server. const httpLink = createHttpLink({ uri: &quot;http://localhost:4000/graphql&quot; }); // Use setContext to create a chainable link object that sets // the token cookie to the Authorization header. const authLink = setContext((_, { headers }) =&gt; { // Get the authentication token from the cookie if it exists. const token = Cookies.get(&quot;token&quot;); // Add the new Authorization header. return { headers: { ...headers, authorization: token ? `Bearer ${token}` : &quot;&quot; } }; }); // Chain the HTTP link and the authorization link. const authedHttpLink = authLink.concat(httpLink); // Create a standard Phoenix websocket connection. If you need // to provide additional params, like an authentication token, // you can configure them in the `params` option. const phoenixSocket = new PhoenixSocket(&quot;ws://localhost:4000/socket&quot;, { params: () =&gt; { if (Cookies.get(&quot;token&quot;)) { return { token: Cookies.get(&quot;token&quot;) }; } else { return {}; } } }); // Wrap the Phoenix socket in an AbsintheSocket. const absintheSocket = AbsintheSocket.create(phoenixSocket); // Create an Apollo link from the AbsintheSocket instance. const websocketLink = createAbsintheSocketLink(absintheSocket); // If the query contains a subscription, send it through the // websocket link. Otherwise, send it through the HTTP link. const link = split( operation =&gt; hasSubscription(operation.query), websocketLink, authedHttpLink ); // Apollo also requires you to provide a cache implementation // for caching query results. The InMemoryCache is suitable // for most use cases. const cache = new InMemoryCache(); // Create the client. const client = new ApolloClient({ link, cache });","ref":"apollo.html#using-both-http-and-websocket-links","title":"Using with Apollo Client - Using both HTTP and websocket links","type":"extras"},{"doc":"Using with Relay While GraphQL specifies what queries, mutations, and object types should look like, Relay is a client-side implementation of an efficient data storage and (re-)fetching system that is designed to work with a GraphQL server. To allow Relay to work its magic on the client side, all GraphQL queries and mutations need to follow certain conventions. Absinthe.Relay provides utilities to help you make your server-side schemas Relay-compatible while requiring only minimal changes to your existing code. Absinthe.Relay supports three fundamental pieces of the Relay puzzle: nodes, which are normal GraphQL objects with a unique global ID scheme; mutations, which in Relay Classic conform to a certain input and output structure; and connections, which provide enhanced functionality around many-to-one lists (most notably pagination).","ref":"relay.html","title":"Using with Relay","type":"extras"},{"doc":"Make sure you have the absinthe_relay package configured as a dependency for your application. To add Relay support schemas should start with use Absinthe.Relay.Schema, eg: defmodule Schema do use Absinthe.Schema use Absinthe.Relay.Schema, :classic # ... end Note that this schema is being prepared to support Relay Classic; if you do not provide either a :classic or :modern option, :classic is currently selected as the default, but a warning is output; :modern will be the default option in v1.5. If you&#39;re defining your types in a separate type module that you&#39;re using via import_types in your schema, use the Notation module instead: defmodule Schema.Types do use Absinthe.Schema.Notation use Absinthe.Relay.Schema.Notation, :classic # ... end Now you&#39;re ready to implement the Relay features you need.","ref":"relay.html#using-absinthe-relay","title":"Using with Relay - Using Absinthe.Relay","type":"extras"},{"doc":"To enable Relay to be clever about caching and (re-)fetching data objects, your server must assign a globally unique ID to each object before sending it down the wire. Absinthe will take care of this for you if you provide some additional information in your schema. First of all, you must define a :node interface in your schema. Rather than do this manually, Absinthe.Relay provides a macro so most of the configuration is handled for you. Use node interface in your schema: node interface do resolve_type fn %YourApp.Model.Person{}, _ -&gt; :person %YourApp.Model.Business{}, _ -&gt; :business _, _ -&gt; nil end end # ... mutations, queries ... For instance, if your query or mutation resolver returns: {:ok, %YourApp.Model.Business{id: 19, business_name: &quot;ACME Corp.&quot;, employee_count: 52}} Absinthe will pattern-match the value to determine that the object type is :business. This becomes important when you configure your :business type as a node: node object :business do # &lt;-- notice the macro prefix &quot;node&quot; field :business_name, non_null(:string) field :employee_count, :integer end (Note the macro name, node, looks like a prefix to the object macro.) While it may appear that your :business object type only has two fields, :business_name and :employee_count, it actually has three. An :id field is configured for you because you used the node object macro, and because the :node interface knows how to identify the values returned from your resolvers, that :id field is automatically set-up to convert internal (in this case, numeric) IDs to the global ID scheme -- an opaque string (like &quot;UWxf59AcjK=&quot;) will be returned instead. Important: the global ID is generated based on the object's unique identifier, which by default is the value of its existing :id field. This is convenient, because if you are using Ecto, the primary key :id database field is typically enough to uniquely identify an object of a given type. It also means, however, that the internal :id of a node object will not be available to be queried as :id. If you wish to generate your global IDs based on something other than the existing :id field (if, for instance, your internal IDs are returned as _id), provide the :id_fetcher option (see the documentation). If you wish to make your internal ID queryable, you must return it as a different field (eg, you could define an :internal_id field whose resolver extracts the raw, internal :id value from the source map/struct). Node query field Ok, so your node objects provide a global :id. How does Relay use it? Relay expects you to provide a query field called node that accepts a global ID (as arg :id) and returns the corresponding node object. Absinthe makes it easy to set this up -- use the node field macro inside your query. query do # ... node field do resolve fn %{type: :person, id: id}, _ -&gt; # Get the person from the DB somehow, returning a tuple YourApp.Resolver.Person.find(%{id: id}, %{}) %{type: :business, id: id}, _ -&gt; # Get the business from @businesses {:ok, Map.get(@businesses, id)} # etc. end end # ... more queries ... end Notice that the resolver for node field expects the first (args) argument to contain a :type and :id. These are the node object type identifier and the internal (non-global) ID, automatically parsed from the global ID. The resolver looks up the correct value using the internal ID and returns a tuple, as usual. For more information, see the documentation. Converting node IDs to internal IDs for resolvers If you need to parse a node (global) ID for use in a resolver, there is a helpful utility, parsing_node_ids/2 that is automatically imported for you. Here&#39;s an example of how it works. Let&#39;s assume we have a field, :employees, that returns a list of :person objects for a given :business_id -- a node ID: query do field :employees, list_of(:people) do arg :business_id, :id resolve &amp;resolve_employees/2 end end def resolve_employees(%{business_id: global_id}, _) do # But I need an internal ID to look-up the employees! end In resolve_employees/2, we could certainly parse out the internal ID manually. Here&#39;s how that would look: def resolve_employees(%{business_id: global_id}, _) do {:ok, %{type: :business, id: internal_id}} = Absinthe.Relay.Node.from_global_id(global_id, YourApp.Schema) # TODO: find employees using internal_id, return tuple end Obviously this can get a bit tedious if we have to do it often. Instead, we can use parsing_node_ids/2 to wrap our resolver function to do the parsing for us, invoking our function with the internal ID instead. We just have to tell the parsing_node_ids/2 what ID field arguments to parse and what the associated types should be: query do field :employees, list_of(:people) do arg :business_id, :id resolve parsing_node_ids(&amp;resolve_employees/2, business_id: :business) end end def resolve_employees(%{business_id: internal_id}, _) do # We have an internal ID! end This leaves our resolver function virtually unchanged, and keeps our code much cleaner.","ref":"relay.html#nodes","title":"Using with Relay - Nodes","type":"extras"},{"doc":"Relay Classic sets some specific constraints around the way arguments and results for mutations are structured. In Relay Modern (if you&#39;re using the :modern option when defining the schema), you&#39;ll have access to a similar set of macros as discussed here, but be aware that the constraints mentioned (on input, on clientMutationId, etc) don&#39;t apply. See the documentation for Absinthe.Relay.Mutation.Notation.Modern for more specific instructions. Relay expects mutations to accept exactly one argument, input, an InputObject. On the JavaScript side, it automatically populates a field on the input, clientMutationId, and expects to get it back, unchanged, as part of the result. Thankfully Absinthe.Relay abstracts these details away from the schema designer, allowing them to focus on any other arguments needed or results expected. Important: Remember that input fields (and arguments in general) cannot be of one of your object types. Use input_object to model complex argument types. In this example, we accept a list of multiple :person_input_object values to insert people into a database. defmodule YourApp.Schema # ... input_object :person_input_object do field :first_name, non_null(:string) field :last_name, non_null(:string) field :age, :integer end mutation do @desc &quot;A mutation that inserts a list of persons into the database&quot; payload field :bulk_create_persons do input do field :persons, list_of(:person_input_object) end output do # fields in the result end resolve &amp;Resolver.Person.bulk_create/2 end # ... more mutations ... end end Note the payload macro introduces a Relay mutation, input defines the fields (inside the input argument), and output defines the fields available as part of the result. See the module documentation for more information: Absinthe.Relay.Mutation.Notation.Classic Absinthe.Relay.Mutation.Notation.Modern Referencing existing nodes in mutation inputs Occasionally, your client may wish to make reference to an existing node in the mutation input (this happens particularly when manipulating the connection edges of a parent node). Incoming IDs for node types may have to be converted to their internal equivalents so you can persist changes to your backend. For this purpose, you can use Absinthe.Relay.Node.from_global_id/2 to parse node (global) IDs manually. def bulk_create(%{persons: new_persons, group: global_group_id}, _) do {:ok, %{type: :group, id: internal_group_id}} = Absinthe.Relay.Node.from_global_id(global_group_id, YourApp.Schema)` # ... manipulate your DB using internal_group_id end If, of course, your client knows the internal IDs (in a peer field to :id, eg, :internal_id), you can depends on that ID -- but we recommend that you use node IDs as they are opaque values and it&#39;s the more conventional practice. Important: When using from_global_id, remember to always match the :type value to ensure the internal ID is for the type you expect, and a global ID for the wrong type of node hasn't been mistakenly sent to the server.","ref":"relay.html#mutations","title":"Using with Relay - Mutations","type":"extras"},{"doc":"One of the more popular features of Relay is the rich pagination support provided by its connections. This medium post has a good explanation of the full feature set and nomenclature. For example, you could define a connection for paginating :location objects with: connection node_type: :location This will automatically define two new types: :location_connection and :location_edge. We define a field that uses these types to paginate associated records by using connection field. Here, for instance, we support paginating a business’s locations: object :business do field :short_name, :string connection field :locations, node_type: :location do resolve fn pagination_args, %{source: business} -&gt; Location |&gt; where(business_id: ^business.id) |&gt; order_by(:inserted_at) |&gt; Connection.from_query(&amp;Repo.all/1, pagination_args) end end end We are piping a query for the associated locations into from_query/3 along with the default relay pagination arguments that allow for pagination. For example, to get just the first 10 locations, use the first argument: query { business(id:&quot;9ea6605e-e6c8-44ea-98d0-1fe6276e193d&quot;) { shortName locations(first:10) { edges node { address1 city } } } } } Check the documentation for more details on connections. Note: These features do not require using Relay on the client as Apollo and other client implementations generally support Relay connection configuration.","ref":"relay.html#connections","title":"Using with Relay - Connections","type":"extras"},{"doc":"Upgrading to v1.4 This information is extracted and expanded from the CHANGELOG. This version included subscriptions, and also came packaged with a number of improvements that required breaking changes. The breaking changes primarily affect middleware and plugin authors, but some changes (like null handling and changes to error messages) warrant review by all Absinthe users.","ref":"v1-4.html","title":"Upgrading to v1.4","type":"extras"},{"doc":"Default middleware are now applied eagerly. Although a small change, this will affect anyone who is currently changing the default middleware. Before v1.4 Before v1.4, the default middleware was applied &quot;lazily&quot;. What this means is if you had a simple field like: object :user field :name, :string end then when it is passed to the middleware/3 callback on a schema, the middleware is an empty list: def middleware(middleware, %{identifier: :name}, %{identifier: :user}) do middleware |&gt; IO.inspect #=&gt; [] end The nice thing about this was that it made it easy to pattern match for the &quot;no middleware supplied&quot; case; you could just match against []. The problem, however, is that if you wanted to add a simple tracing middleware that runs on every field for example, the &quot;obvious&quot; way to do it seemed like it could be this: def middleware(middleware, _field, _object) do [YourTracer | middleware] end ... and we just broke our field :name, :string field, and all others like it. No longer did it come back from def middleware as [], and thus our lazy default wasn&#39;t applied. This has tripped up an unreasonable number of people, and it violated the common sense meaning of &quot;default value.&quot; It also made it hard for users to determine what default middleware might run on a field. Checking the value passed to middleware/3 didn&#39;t help. In v1.4 The default middleware is now eager: def middleware(middleware, %{identifier: :name}, %{identifier: :user}) do middleware |&gt; IO.inspect #=&gt; [{Absinthe.Middleware.MapGet, :name}] end Every field has at least one middleware specified, and the middleware/3 callback has full access to it. Conceptually, it&#39;s a lot simpler than the previous approach, in that there isn&#39;t some hidden action after the fact that you can&#39;t see. Changing the default is a bit more work now, because you have to explicitly match against the Absinthe default to put something else in its place. However it isn&#39;t very difficult (moreover a helper function could be added later to make it even easier).","ref":"v1-4.html#middleware-watch-out-for-eager-default","title":"Upgrading to v1.4 - Middleware: Watch Out for Eager Default","type":"extras"},{"doc":"Plugins now receive an %Absinthe.Blueprint.Execution{} struct instead of the bare accumulator. This makes it possible for plugins to set or operate on context values. Upgrade your plugins! Change this: def before_resolution(acc) do acc = # doing stuff to the acc here end def after_resolution(acc) do acc = # doing stuff to the acc here end def pipeline(pipeline, acc) do case acc do # checking on the acc here end end to: def before_resolution(%{acc: acc} = exec) do acc = # doing stuff to the acc here %{exec | acc: acc} end def after_resolution(%{acc: acc} = exec) do acc = # doing stuff to the acc here %{exec | acc: acc} end def pipeline(pipeline, exec) do case exec.acc do # checking on the acc here end end The reason for this is that you can also access the context within the exec value. When using something like Dataloader, it&#39;s important to have easy to the context","ref":"v1-4.html#plugins-change-arguments","title":"Upgrading to v1.4 - Plugins: Change Arguments","type":"extras"},{"doc":"Absinthe now supports GraphQL null literals. null values, when provided as arguments, are passed on to Absinthe resolvers as nil (provided they don&#39;t run afoul of a non_null/1 argument constraint). The concrete effect of this is that your resolvers may need to be updated to take into account that nil is a possible value; in the past arguments would never be passed as nil. Let&#39;s take a look at this example schema snippet. Before v1.4 field :avatar_url, :string do arg :size, :integer, default_value: 64 # ... resolver here end Before v1.4, you could write a resolver that could always assume a :size would be provided: resolve fn _, %{size: size}, _ -&gt; {:ok, &quot;http://example.com/avatars/test_\#{size}x\#{size}.png&quot;} end If the user doesn&#39;t provide a value for :size, it would default to 64: { avatarUrl(size: 32) # =&gt; http://example.com/avatars/test_32x32.png avatarUrl # =&gt; http://example.com/avatars/test_64x64.png # This is invalid in v1.3, as there&#39;s no `null` literal: avatarUrl(size: null) } In v1.4 In v1.4, users can freely send null, and that value will override any default: { # This didn&#39;t change: avatarUrl(size: 32) # =&gt; http://example.com/avatars/test_32x32.png # Neither did this (default value applied as expected) avatarUrl # =&gt; http://example.com/avatars/test_64x64.png # But `nil` gets interpolated here, as it overrode the default value of `64`: avatarUrl(size: null) # =&gt; http://example.com/avatars/test_x.png } You may want to change your resolvers to use the default value if nil is received: resolve fn _, %{size: size}, _ -&gt; px = size || 64 {:ok, &quot;http://example.com/avatars/test_\#{px}x\#{px}.png&quot;} end Or handle it as an explicit match (especially if you want to assign a special semantic value to the now-available null value): resolve fn _, %{size: nil}, _ -&gt; {:ok, &quot;http://example.com/avatars/test_default.png&quot;} _, %{size: size}, _ -&gt; {:ok, &quot;http://example.com/avatars/test_\#{size}x\#{size}.png&quot;} end Some other options to think about: Shore up your schema by adding more uses of non_null/1 constraints where it makes sense. Add piece of middleware to strip out nil argument values, universally or focused on a specific set of fields.","ref":"v1-4.html#calling-all-resolvers-the-null-literal-has-arrived","title":"Upgrading to v1.4 - Calling All Resolvers: The Null Literal Has Arrived","type":"extras"},{"doc":"Errors returned from resolvers no longer say &quot;In field \#{field_name}:&quot;. The inclusion of the path information obviates the need for this data, and it makes error messages a lot easier to deal with on the frontend. If you expect certain error messages in your clients, you may need to update your code.","ref":"v1-4.html#expect-shorter-error-messages","title":"Upgrading to v1.4 - Expect Shorter Error Messages","type":"extras"},{"doc":"Upgrading to v1.5 This information is extracted and expanded from the CHANGELOG. This version includes: Schema compilation phases SDL based schema definitions SDL rendering Telemetry based instrumentation Existing macro-based schemas will work as-is, but make sure to note that the schema pipeline executes at compile time.","ref":"v1-5.html","title":"Upgrading to v1.5","type":"extras"},{"doc":"Default values evaluated at compile time Default values are evaluated at compile time. For example default_value: DateTime.utc_now() will have its time set at compile time. You probably don&#39;t want this :) Scalar output validation Scalar outputs are now type checked and will raise exceptions if the result tries to send the wrong data type in the result. Field name validation Added a schema phase to check the validity of field names according to GraphQL spec. Remove the Absinthe.Phase.Schema.Validation.NamesMustBeValid from the schema pipeline if you need to retain the previous behavior. Absinthe.Subscription.PubSub Added node_name/0 callback to Absinthe.Subscription.PubSub behaviour. To retain old behaviour, implement this callback to return Kernel.node/0. Absinthe.Traversal Removed the un-used Absinthe.Traversal module.","ref":"v1-5.html#breaking-changes","title":"Upgrading to v1.5 - Breaking changes","type":"extras"}]